<div align="center">
<picture>
  <source media="(prefers-color-scheme: dark)" srcset="docs/src/assets/logo-dark.png">
  <source media="(prefers-color-scheme: light)" srcset="docs/src/assets/logo.png">
  <img alt="Bloqade Logo">
</picture>
</div>

---

[![CI](https://github.com/QuEraComputing/Bloqade.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/QuEraComputing/Bloqade.jl/actions/workflows/CI.yml)
[![codecov](https://codecov.io/gh/QuEraComputing/Bloqade.jl/branch/master/graph/badge.svg?token=DYm2XwiTaR)](https://codecov.io/gh/QuEraComputing/Bloqade.jl)

Bloqade is a package developed for quantum computation and quantum simulation based on the neutral-atom architecture with the ability to submit tasks to [QuEra's *Aquila* quantum processor](https://www.quera.com/aquila). Please refer to the [documentation](https://queracomputing.github.io/Bloqade.jl/dev/) page to learn more about Bloqade.

**Bloqade is currently under public release beta. High-level APIs are stable, but please expect some further exploration and rough edges.**

## Installation

<p>
Bloqade is a &nbsp;
    <a href="https://julialang.org">
        <img src="https://raw.githubusercontent.com/JuliaLang/julia-logo-graphics/master/images/julia.ico" width="16em">
        Julia Language
    </a>
    &nbsp; package. To install Bloqade,
    please <a href="https://docs.julialang.org/en/v1/manual/getting-started/">open
    Julia's interactive session (known as REPL)</a> and press <kbd>]</kbd> key in the REPL to use the package mode, and then type the following command:
</p>

For stable release:

```julia
pkg> add Bloqade
```

For current master:

```julia
pkg> add Bloqade#master
```

## Community 

You can join QuEra's Slack workspace with this [link](https://join.slack.com/t/querapublic/shared_invite/zt-1d5jjy2kl-_BxvXJQ4_xs6ZoUclQOTJg). Join the `#bloqade` channel to discuss anything related to Bloqade.

## 🚀 Bloqade SDK for Python 🚀

While you're checking out this version of Bloqade, we encourage you to also give [Bloqade for Python](https://github.com/QuEraComputing/bloqade-python) a spin, currently in the Alpha phase of development. Check the documentation to [get started](https://bloqade.quera.com/0.8.0/#how-do-i-get-started). We are in active development of this new package so we appreciate [feedback](https://bloqade.quera.com/0.8.0/contributing/providing-feedback/) during the Alpha phase.

### What About Bloqade.jl?

Bloqade.jl will not go away any time soon because of Bloqade for Python's existence. In fact, plans are underway to allow Bloqade.jl to become a high-performance emulator that the Python version of Bloqade can interface to, giving you unparalleled emulation power to test your ideas on top of a syntax designed to make designing programs for neutral atom hardware easier than ever.

## Citation

If you use Bloqade for a publication, we would kindly ask you to cite our work using the following bibtex citation:

```bibtex
@misc{bloqade2023quera,
  url = {https://github.com/QuEraComputing/Bloqade.jl/},
  title = {Bloqade.jl: {P}ackage for the quantum computation and quantum simulation based on the neutral-atom architecture.},
  year = {2023}
}
```

## License

Apache License 2.0

# Examples

This directory contains a number of examples of the Bloqade package.

## Generate Jupyter notebooks

you can generate the corresponding jupyter notebook from these examples, e.g

```sh
.ci/run example build 2.adiabatic
```

will build the jupyter notebook at `build` folder. Then you can open and run
this jupyter notebook using the `IJulia` package

```julia
pkg> add IJulia
julia> using IJulia; IJulia.notebook()
```

## Setup

Each example contains its own environment, and one should start
the corresponding example with its own environment via:

```julia
julia --project=examples/<example-name>
```

or from the REPL pkg mode:

```julia
] activate examples/<example-name>
```

## Format

The examples are written using [Literate](https://github.com/fredrikekre/Literate.jl).

## Developers Notes

### Setup example for development

For developers, it is important to make sure examples are using the
packages in current local directories that is under development. To
do this, just run the following in your terminal:

```sh
.ci/run dev <path/to/your/example>
```

This will add the local packages into your example environments.

### Create a new example

We enforce each example to have their own environment. An automatic
tool is provided for this purpose: you can create an example folder
with the corresponding environment using the following:

```sh
.ci/run create <name>
```

which will create `examples/<name>`.

using Test
using Bloqade
using Random

wf = piecewise_linear(clocks = [0.0, 1.0, 2.0, 3.0], values = [0.0, 2.0, 2.0, 1.0])
Bloqade.plot(wf)

r = rand_state(12)
bitstring_hist(r; nlargest = 10)

space = Subspace(5, randperm(1 << 5)[1:10] .- 1)
r = rand_state(space)
bitstring_hist(r; nlargest = 10)

@testset "plot_densities" begin
    # dimension mismatch test
    atoms = generate_sites(SquareLattice(), 4, 4, scale=6.7)
    # Densities from adiabatic sweep on 3x3 Square Lattice
    densities = [0.9721147069025007,
                 0.010593663461943983,
                 0.9721147069025009,
                 0.010593663461943983,
                 0.987148044531143,
                 0.010593663461943978,
                 0.9721147069025005,
                 0.010593663461943981,
                 0.9721147069025007]
    @test_throws ArgumentError plot_densities(atoms, densities)

    # should work without failure
    plot_densities(generate_sites(SquareLattice(), 3, 3, scale=6.7), densities)
end

# # Quantum Scar
# ## Background

# The experimental study by [H. Bernien et al. (10.1038/nature24622)](https://www.nature.com/articles/nature24622) discovered that if one starts with a 
# particular initial state (e.g. the Neel state), the Rydberg blockade constraint results into persistent revivals of quantum dynamics, 
# in contrast to the expectation of reaching thermalization quickly.
# Later, theoretical studies (e.g. [C. J. Turner et al. (10.1038/s41567-018-0137-5)](https://www.nature.com/articles/s41567-018-0137-5)) reveal that this behavior is due to 
# special eigenstates embedded in the quantum many-body spectrum, and the phenomenon is called quantum many-body scars.

# Quantum many-body scars are analogous to the phenomenon of classical scars in single-particle quantum chaos, where scars represent a concentration of some eigenfunctions 
# along the trajectory of classical periodic orbits. Similarly, in the quantum many-body case, the initial Neel state has a large overlap of these specific scar states. 
# Under the time evolution of the Rydberg Hamiltonian, the initial state undergoes the trajectory of periodic quantum orbits. The non-thermal behavior is mainly caused by such non-ergodicity 
# in the Hilbert space. 

# In this example, we use Bloqade to simulate the evolution of a fully coherent, 
# strongly interacting Rydberg system.  We demonstrate the persistent revivals of many-body dynamics with measurements of the Rydberg density 
# and entanglement entropy. For a comprehensive review of quantum many-body scars, we refer readers to the paper [M. Serbyn et al. (10.1038/s41567-021-01230-2)](https://www.nature.com/articles/s41567-021-01230-2)

# In this tutorial, we provide an example of using Bloqade to simulate quantum many-body scars.
# To start, we first import the required libraries:

using Bloqade
using Bloqade.CairoMakie
using Random

# # Many-Body Rabi Oscillations with Rydberg Blockade

# We first demonstrate that the strong Rydberg interactions have important effects on the Rabi oscillations of Rydberg atoms.
# To do so, we consider a system with 1, 2, and 3 atoms. All the atoms are placed within the blockade radius of any other atom (see the [Rydberg Blockade](@ref blockade) tutorial for more details). 
# The atom positions can be created as:

atom1 = generate_sites(ChainLattice(), 1, scale = 3.0)
atom2 = generate_sites(ChainLattice(), 2, scale = 3.0)
atom3 = generate_sites(ChainLattice(), 3, scale = 3.0)

# Let's apply a resonant Rabi drive on each atom. The Hamiltonians can be simply constructed by: 
h1 = rydberg_h(atom1; Δ = 0, Ω = 2π * 2)
h2 = rydberg_h(atom2; Δ = 0, Ω = 2π * 2)
h3 = rydberg_h(atom3; Δ = 0, Ω = 2π * 2)

# The initial states are chosen such that all atoms start from the ground state:
reg1 = zero_state(1)
reg2 = zero_state(2)
reg3 = zero_state(3)

# We first simulate the dynamics for the single atom's case, where the initial state is quenched under a Hamiltonian with constant Rabi frequency:
total_time = 1.5
clocks = 0.0:1e-2:total_time
prob1 = KrylovEvolution(reg1, clocks, h1)
density1 = zeros(1, length(clocks));

for info in prob1
    density1[1, info.step] = rydberg_density(info.reg, 1)
end

# Here, we use a [`KrylovEvolution`](@ref) object to simulate the dynamics for a time-independent Hamiltonian.
# One can also use ODE to simulate the dynamics. For an example, see the [Adiabatic Evolution](@ref) tutorial.
# The Rydberg density of this atom exhibits Rabi oscillations as a function of time, shown by the plot below:
fig = Figure()
ax = Axis(fig[1,1], xlabel = "Time (μs)", ylabel = "Single Rydberg Probability", title = "Rabi Oscillation: Single Atom Case")
lines!(ax, clocks, density1[1, :], label = "1 atom")
fig

# For the case of 2 and 3 atoms, if they are separated far enough with negligible interactions, the total Rydberg excitation densities are simply the sum of the Rydberg density for each atom.
# However, we show that this is not the case for systems when atoms are close to each other (which results in strong Rydberg interactions). 
# Similar to the 1 atom case, we can simulate the dynamics and get the time-dependent dynamics for each atom:
prob2 = KrylovEvolution(reg2, clocks, h2);
density2 = zeros(2, length(clocks));

for info in prob2
    for i in 1:2
        density2[i, info.step] = rydberg_density(info.reg, i)
    end
end
density2 = sum(density2, dims = 1);

prob3 = KrylovEvolution(reg3, clocks, h3);
density3 = zeros(3, length(clocks));

for info in prob3
    for i in 1:3
        density3[i, info.step] = rydberg_density(info.reg, i)
    end
end
density3 = sum(density3, dims = 1);

# Because of the Rydberg blockade, the system will undergo many-body Rabi oscillation with the state 
# oscillating between the all 0 state (``\Ket{0 \ldots 0}``) and the W state (``1/\sqrt{2}(\Ket{0 \ldots 0} + \Ket{010 \ldots 0} + \Ket{0 \ldots 1})``), where the Rabi frequency will be enhanced by ``\sqrt{N}``, 
# where ``N`` is the number of atoms.
# For more information, please refer to [H. Bernien, et al. (10.1038/nature24622)](https://www.nature.com/articles/nature24622).
# The total Rydberg density for the 1-, 2-, and 3-atom system is plotted below:
fig = Figure()
ax = Axis(fig[1,1], xlabel = "Time (μs)", ylabel = "Rydberg Probability", title = "Many-body Rabi Oscillation for 1-, 2-, and 3-atom system")
lines!(ax, clocks, density1[1, :], label = "1 atom")
lines!(ax, clocks, density2[1, :], label = "2 atoms")
lines!(ax, clocks, density3[1, :], label = "3 atoms")
axislegend(position = :rb)
fig

# From this plot, we can see that the total Rydberg density for 2 (3) atom case does not exceed 1. This is because
# it is energetically unfavorable to have more than 1 excitation due to the strong Rydberg interactions. 
# In addition, we can see the enhancement of the many-body Rabi frequency.
# This shows that the interactions play an important role in the system's dynamics.

# Below, we show that for a system with 9 atoms where only nearest-neighbor atoms in a chain are within each other's blockade radius, 
# the system can exhibit nontrivial dynamics for certain initial states, the so-called quantum many-body scars.

# # Quantum Scar
# ## Create the lattice and the Hamiltonian

# We first create a 9-atom system with a 1D-chain arrangement, where each atom is separated from its neighbors by 5.72 μm. This results in a nearest-neighbor 
# interaction strength of ``2 \pi \times 24`` MHz, which is much larger than the Rabi frequency ``\Omega`` specified below. Thus, the nearest-neighbor
# Rydberg atoms are within the blockade radius and cannot be both excited simultaneously:

nsites = 9
atoms = generate_sites(ChainLattice(), nsites, scale = 5.72)

# The waveforms are made up of two parts. For the first part, we use the adiabatic evolution to prepare an ordered Neel state (see the [Adiabatic Evolution](@ref) tutorial for more details):

Δ1 = piecewise_linear(clocks = [0.0, 0.3, 1.6, 2.2], values = 2π * [-10.0, -10.0, 10.0, 10.0]);
Ω1 = piecewise_linear(clocks = [0.0, 0.05, 1.6, 2.2], values = 2π * [0.0, 4.0, 4.0, 0.0]);

# The second part of the waveform has constant values for the parameters, so we can use [`constant`](@ref) to construct them:
Ω2 = constant(duration = 2.0, value = 2 * 2π);
Δ2 = constant(duration = 2.0, value = 0);

# The waveform for the whole evolution can be composed by appending the second part to the first part via [`append`](@ref):

Ω_tot = append(Ω1, Ω2);
Δ_tot = append(Δ1, Δ2);

fig = Figure(size=(960, 320))
ax1 = Axis(fig[1, 1], ylabel = "Ω/2π (MHz)")
ax2 = Axis(fig[1, 2], ylabel = "Δ/2π (MHz)")
Bloqade.plot!(ax1, Ω_tot)
Bloqade.plot!(ax2, Δ_tot)
fig[1, 1] = ax1
fig[1, 2] = ax2
fig

# Note that the total evolution time is 4.2 μs.
# We then build the Hamiltonian by importing the defined lattice structure and waveforms: 

h = rydberg_h(atoms; Δ = Δ_tot, Ω = Ω_tot)

# ## Simulating the Quantum Dynamics

# We now simulate the quench dynamics of the Rydberg atom array (initially prepared in the ground state). 
# The initial state can be created by:

reg = zero_state(nsites);

# We can then simulate the time evolution of the quantum state using an ODE solver:
total_time = 4.2;
prob = SchrodingerProblem(reg, total_time, h);
integrator = init(prob, Vern8());
# Then, we measure the real-time expectation value of the Rydberg density and entanglement entropy: 

entropy = Float64[]
densities = []
for _ in TimeChoiceIterator(integrator, 0.0:1e-3:total_time)
    push!(densities, rydberg_density(reg))
    rho = density_matrix(reg, (1, 2, 3, 4, 5)) # calculate the reduced density matrix
    push!(entropy, von_neumann_entropy(rho)) # compute entropy from the reduced density matrix
end

# ## Plotting the Results
# We first plot the Rydberg density for each site as a function of time:

clocks = 0:1e-3:total_time
D = hcat(densities...)'

fig = Figure(size=(800, 320))
ax = Axis(fig[1, 1]; xlabel = "Time (μs)", ylabel = "Site", xticks = 0:0.4:total_time, yticks = (0.5:1:nsites, string.(1:nsites)))
shw = heatmap!(ax, LinRange(0, total_time, size(D, 1)), LinRange(0.5, nsites - 0.5, size(D, 2)), real(D), colormap = :viridis)
bar = Colorbar(fig[1, 2], shw)
fig
# We can see that the state evolves to a Neel state after the first part of the pulse (time around 2.2 μs). 
# After that, there are clear oscillations between the two patterns of the Rydberg density, which is a signature of the quantum scar.

# We can also plot the entanglement as a function of time:

fig = Figure(size=(800, 320))
ax = Axis(fig[1, 1]; xlabel = "time (μs)", ylabel = "entanglement entropy")
line = lines!(ax, clocks, entropy)
fig[1, 1] = ax
fig
# # A Different Initial State 

# In order to see that the revivals depends strongly on the initial state, 
# we now choose a different initial state, and use the [`KrylovEvolution`](@ref) solver to simulate the dynamics:  

hd = rydberg_h(atoms; Ω = 4π)
total_time = 1.2;
clocks = 0.0:1e-2:total_time;

init_d = product_state(bit"100000101")
prob_d = KrylovEvolution(init_d, clocks, hd)
density_mat_d = zeros(length(clocks), nsites)

for info in prob_d
    for i in 1:nsites
        density_mat_d[info.step, i] = rydberg_density(info.reg, i)
    end
end

fig = Figure(size=(800, 320))
ax = Axis(fig[1, 1]; xlabel = "time (μs)", ylabel = "site", xticks = 0:0.2:total_time, yticks = (0.5:1.0:nsites, string.(1:nsites)))
shw = heatmap!(ax, LinRange(0.0, total_time, size(density_mat_d, 1)), LinRange(0.5, nsites - 0.5, size(density_mat_d, 2)), density_mat_d, colormap = :viridis)
bar = Colorbar(fig[1, 2], shw)
fig

# From this figure, we see that the density does not show long-lived oscillations.

using Test
using Bloqade

reg = rand_state(10)
@test rydberg_density(reg, 2) ≈ expect(put(10, 2 => Op.n), reg)
@test rydberg_density(reg) ≈ [rydberg_density(reg, i) for i in 1:10]

@test rydberg_corr(reg) ≈
      [expect(chain(nqubits(reg), put(i => Op.n), put(j => Op.n)), reg) for i in 1:nqubits(reg), j in 1:nqubits(reg)]


# Test 1 for get_average_rydberg_densities: π-pulse for 1-atom
@test [[0.0], [1.0]] ≈ get_average_rydberg_densities(
      generate_sites(ChainLattice(), 1), 
      zero_state(1); 
      Ω = piecewise_linear(clocks = [0.0, 0.1], values = [π/(0.1), π/(0.1)]), 
      dt=0.1)

# Throw an error if there are no waveforms supplied for Ω, Δ, or ϕ
@test_throws ErrorException get_average_rydberg_densities(
                              generate_sites(ChainLattice(), 1), 
                              zero_state(1);
                              dt=0.1)

# Throw an error if waveforms are present but durations are incompatible
## Waveforms taken from "Adiabatic Evolution" Tutorial of Bloqade Documentation: 
## https://queracomputing.github.io/Bloqade.jl/dev/tutorials/2.adiabatic/main/#Preparation-of-Ordered-States-in-1D

Ω_max = 2π * 4;
Ω = piecewise_linear(clocks = [0.0, 0.1, 1.2, 2.2, 3.0], values = [0.0, Ω_max, Ω_max, 0, 0 ]) 

U1 = -2π * 10;
U2 = 2π * 10;
Δ = piecewise_linear(clocks = [0.0, 0.6, 2.1, 4.1],values = [U1, U1, U2, U2]);
@test_throws ErrorException get_average_rydberg_densities(
                              generate_sites(ChainLattice(), 1), 
                              zero_state(1);
                              Ω = Ω,
                              Δ = Δ,
                              dt=0.1)

# # Simulation of a Lattice Gauge Theory with Rydberg Atoms
# ## Introduction
# In previous examples, we have shown how to prepare $Z_2$ ordered ground state for the Rydberg system, and discussed the quantum scar phenomenon. 
# We note that these are achieved by tuning the detuning and the Rabi frequency of the lasers that address all the atoms simultaneously. 

# In this tutorial, we shall simulate the dynamics of a Lattice Gauge Theory (LGT) with a 1D Rydberg atom chain. 
# In the context of gauge theories, it turns out that the $Z_2$ ground state and the quantum scar of the Rydberg chain correspond to 
# the "string" state and the string-inversion mechanism of the studied LGT respectively. More interestingly, by 
# locally addressing certain atoms, we can create defects in the chain and simulate the propagation of particle-antiparticle pairs. 
# This tutorial is inspired by the paper [F. M. Surace et al. (10.1103/PhysRevX.10.021041)](https://journals.aps.org/prx/pdf/10.1103/PhysRevX.10.021041). 


# We first import the required packages 

using Bloqade
using Bloqade.CairoMakie

# ## Mapping between the Rydberg system and the LGT

# In this tutorial, we are interested in the so-called quantum link model (QLM) formulation
# of the LGT. In this formalism, depending on the configurations of the even and odd sites,
# the bonds between them could be interpreted as a particle $q$, an antiparticle $\bar{q}$
# or a vacuum state. More specifically, the bond between an odd and an even sites corresponds
# to an antiparticle if both atoms are in the ground states, otherwise it is interpreted as
# a vacuum state. On the other hand, the bond between an even and an odd sites corresponds
# to a particle if both atoms are in the ground states, otherwise it is interpreted as a vacuum.
# Further, the Rydberg states at the odd (even) sites are interpreted as electric fields
# pointing to the left (right), whereas the ground states at the odd (even) sites are electric
# field pointing to the right (left). The electric fields correspond to the red and blue arrows
# in the following figure, which summarizes the mappings described above
# (source: [F. M. Surace et al. (10.1103/PhysRevX.10.021041)](https://journals.aps.org/prx/pdf/10.1103/PhysRevX.10.021041)).

# ![mapping](../../../assets/LGT_mapping.png)

# ## Preparing the initial state for the LGT dynamics

# The LGT dynamics starts from the "anti-string" state with all electric fields pointing
# to the right. This is nothing but the $Z_2$ ordered state in the language of Rydberg
# system, and we have seen how to prepare it in previous tutorials. Here, we are interested
# in a 1D lattice with 21 atoms. The neighboring atoms are separated by 5.5 μm such that
# they are blockaded throughout the dynamics (the typical value of the Rabi frequency is
# ``2\pi \times 5`` MHz throughout the dynamics, which corresponds to blockade radius ``R_b\approx7.46`` μm.):

a = 5.5;
N = 21;
atoms = generate_sites(ChainLattice(), N, scale=a);
subspace = blockade_subspace(atoms, a); 

# In order to prepare the anti-string state of the LGT, we use piecewise linear waveforms for both the detuning and the Rabi frequency. The waveforms will last for 3.5 μs:

total_time = 3.5; 
Ωmax = 2π * 5;
Δmin = -2π * 10;
Δmax = 2π * 10;

Δ1 = piecewise_linear(clocks = [0.0, 0.2, total_time], values = [Δmin, Δmin, Δmax]); 
Ω1 = piecewise_linear(clocks = [0.0, 0.2, total_time], values = [0.0, Ωmax, Ωmax]);

# The waveforms for the detuning and the Rabi frequency are shown below
fig1 = Figure(size=(960, 320))
ax1 = Axis(fig1[1, 1], ylabel="Ω1/2π (MHz)", xgridvisible=true, ygridvisible=true)
ax2 = Axis(fig1[1, 2], ylabel="Δ1/2π (MHz)", xgridvisible=true, ygridvisible=true)
Bloqade.plot!(ax1, Ω1)
Bloqade.plot!(ax2, Δ1)
fig1

# In order to simulate the gauge theory dynamics, we define the function
# `get_average_rydberg_densities` which takes in a detuning
# and Rabi frequency $(Δ, Ω)$, and returns the final state and the Rydberg density: 

function get_average_rydberg_densities(Δ, Ω; dt=1e-3)
    h = rydberg_h(atoms; Δ=Δ, Ω=Ω)
    reg = zero_state(subspace)

    duration = Ω.duration
    prob = SchrodingerProblem(reg, duration, h, progress=true);
    integrator = init(prob, Vern8());
    densities = []
    for _ in TimeChoiceIterator(integrator, 0.0:dt:duration)
        normalize!(reg) 
        push!(densities, rydberg_density(reg)) 
    end

    return densities
end;

# We can confirm that the waveforms produce the desired anti-string state of the LGT, 
# by simulating the dynamics governed by the waveforms, followed by plotting the density profile, as shown below:

dens1 = get_average_rydberg_densities(Δ1, Ω1) ;

fig2 = Figure(size = (800, 320))
ax = Axis(fig2[1, 1], xlabel="site index", ylabel="Average Rydberg densities")
barplot!(ax, 1:N, dens1[end])
fig2

# Recalling the mapping between the Rydberg chain and the LGT illustrated above, 
# we see that the final state is an approximation of the anti-string state of the LGT, or a $Z_2$ ordered state of the Rydberg chain. 
# It is not perfectly $Z_2$ ordered where the discrepancy is more prominent at the center compared to the edge of the chain. 
# But as we will see later, the prepared state is sufficient for demonstrating the dynamics of the interested LGT. 

# ## Propagation of Particle-Antiparticle Pairs

# Next, we prepare defects in the anti-string state, which are links with right-pointing electric fields. 
# The domain walls between anti-string and string states will host particles, whereas those between string and anti-string states will host anti-particles. 
# These can be seen via the mapping between Rydberg a system and LGT illustrated above. 
# Interestingly, the particle and antiparticle always come in pairs, and their time evolution exhibits light cones, 
# in which the string-antistring oscillation is out-of-phase compared to that outside of the light cone. 
# This is illustrated below (source: [F. M. Surace et al. (10.1103/PhysRevX.10.021041)](https://journals.aps.org/prx/pdf/10.1103/PhysRevX.10.021041)):


# ![propagation](../../../assets/LGT_particle_antiparticle_propagation.png)

# ### Site-Dependent Waveforms

# To realize the defects, we turn off the detuning for the target atoms while maintaining the same Rabi frequency for all the atoms. 
# This effectively applies a $\pi$-pulse to the target atoms for transitioning them from the Rydberg state to the ground state: 

Δq = 0.0; 
tq = π/Ωmax; 

# The waveforms of the detunings for creating one and two defects are defined as following:

Δ2_single_defect = map(1:length(atoms)) do idx
    if idx == floor(Int, N/2)+1
        append(Δ1, constant(duration=tq, value=Δq))
    else
        append(Δ1, constant(duration=tq, value=Δmax))
    end
end ; 

Δ2_two_defects = map(1:length(atoms)) do idx
    if idx == floor(Int, N/3) || idx == floor(Int, N-N/3)+1
        append(Δ1, constant(duration=tq, value=Δq))
    else
        append(Δ1, constant(duration=tq, value=Δmax))
    end
end ; 

# We append a constant waveform with the same amplitude to the Rabi frequency such that it has the same duration as the detunings:

Ω2 = append(Ω1, constant(duration=tq, value=Ωmax)); 

# As an example, for the case with a single defect, we show the detuning for the central site, which is the defect, and those for other sites separately below:

fig3 = Figure(size=(960, 320))
ax1 = Axis(fig3[1, 1], title="Detuning for the central site", xgridvisible=true, ygridvisible=true)
ax2 = Axis(fig3[1, 2], title="Detunings for other sites", xgridvisible=true, ygridvisible=true)

for idx in 1 : length(atoms)
    if idx == floor(Int, N/2)+1
        Bloqade.plot!(ax1, Δ2_single_defect[idx])
    else
        Bloqade.plot!(ax2, Δ2_single_defect[idx])
    end
end

fig3

# We can confirm that the waveforms produce the desired domain walls for the LGT states, 
# by simulating the dynamics governed by the waveforms, followed by plotting their density profiles:

dens2 = get_average_rydberg_densities(Δ2_single_defect, Ω2)
dens3 = get_average_rydberg_densities(Δ2_two_defects, Ω2)

fig4 = Figure(size=(800, 320))
ax1 = Axis(fig4[1, 1], xlabel="site index", ylabel="Average Rydberg densities")
ax2 = Axis(fig4[2, 1], xlabel="site index", ylabel="Average Rydberg densities")
barplot!(ax1, 1:N, dens2[end])
barplot!(ax2, 1:N, dens3[end])
fig4

# Again, we see that the Rydberg density at the defects are not exactly zero, but the prepared states,
# as we shall see below, serve as good initial states to study the propagation of particle-antiparticle pairs in LGT. 

# We define the very last piece in the Rabi frequency and detuning that govern the time evolution of the Rydberg chain with defects:

Δq2 = -π ;
tq2 = 40/Ωmax ; 

Δ3_single_defect = map(1:length(atoms)) do idx
    append(Δ2_single_defect[idx], constant(duration=tq2, value=Δq2))
end       
Δ3_two_defects = map(1:length(atoms)) do idx
    append(Δ2_two_defects[idx], constant(duration=tq2, value=Δq2))
end       

Ω3 = append(Ω2, constant(duration=tq2, value=Ωmax));

# Again, as an example, for the case with a single defect, we show the detuning for the central site, 
# which is the defect, and those for other sites separately below:

fig5 = Figure(size=(960, 320))
ax1 = Axis(fig5[1, 1], xlabel="Time", ylabel="Detuning", xgridvisible=true, ygridvisible=true)
ax2 = Axis(fig5[1, 2], xlabel="Time", ylabel="Detuning", xgridvisible=true, ygridvisible=true)

Bloqade.plot!(ax1, Δ3_single_defect[floor(Int, N/2)+1], label="Detuning for the central site")
Bloqade.plot!(ax2, Δ3_single_defect[1], label="Detunings for other sites")
Bloqade.plot!(ax1, Ω3; label="Rabi frequency for all sites")
axislegend(ax1, position=:rb)
axislegend(ax2, position=:rb)
fig5

# ### Simulating Particle-Antiparticle Pairs in LGT Dynamics 

# With the waveforms defined above, we can run the simulation to evolve the Rydberg chains with defects and collect the final Rydberg densities:
densities_single_defect = get_average_rydberg_densities(Δ3_single_defect, Ω3);
densities_two_defects = get_average_rydberg_densities(Δ3_two_defects, Ω3);

D_single_defect = hcat(densities_single_defect...);
D_two_defects = hcat(densities_two_defects...);

# To better visualize the propagation of particle-antiparticle pairs, 
# we shall only show the Rydberg densities starting from the time point when the ground state of the defect chain is prepared:

ind0 = 3550;
D_single_defect = D_single_defect[:, ind0:end];
D_two_defects = D_two_defects[:, ind0:end];

clocks = 0:1e-3:Ω3.duration;
clocks = clocks[ind0: end];

# Then we plot the Rydberg density as a function of time, where the two panels correspond to the cases with single and two defects respectively:
yticks = range(clocks[1], stop=clocks[end], length=10);
yticks = [string(ytick)[1:4] for ytick in yticks][end:-1:1];

fig6 = Figure(size=(960, 640))
ax1 = Axis(fig6[1, 1], xlabel = "sites", ylabel = "time (μs)", yticks = (range(1, stop = length(clocks), length = 10), string.(round.(range(clocks[1], stop=clocks[end], length=10); digits=2))))
ax2 = Axis(fig6[1, 2], xlabel = "sites", yticklabelsvisible=false)
clims = (0.0, 1.0)
img1 = image!(ax1, D_single_defect[end:-1:1, :], colormap = :inferno, colorrange=clims, interpolate=false)
img2 = image!(ax2, D_two_defects[end:-1:1, :], colormap = :inferno, colorrange=clims, interpolate=false)
Colorbar(fig6[1, 3]; limits=clims)
fig6
# From the left panel, we can observe a light-cone-shaped region originating from the particle-antiparticle pair in the vacuum. 
# At the right panel, we show the interference of two light cones, which produces an additional change of periodicity corresponding to the elastic scattering. 
# When the particle or antiparticle reaches the boundary of the chain, it will be scattered back as observed. 
# For more details, the interested readers are referred to the paper [F. M. Surace et al. (10.1103/PhysRevX.10.021041)](https://journals.aps.org/prx/pdf/10.1103/PhysRevX.10.021041). 

# In summary, we have shown that the ground state and the dynamics of certain LGT can be simulated by a 1D chain of Rydberg atoms.
# More interestingly, defects can be introduced by locally addressing certain atoms in the chain, 
# and with that we can simulate the propagation of particle-antiparticle pairs in the LGT dynamics.

# # [The Maximum Independent Set Problem](@id mis-tutorial)

# ## Background

# In graph theory, an independent set is a set of vertices in a graph such that no two of which are connected by an edge.
# The problem of finding Maximum Independent Sets (MISs) is NP-hard, i.e., it is unlikely to be solved in a time polynomial to the problem size.
# Interestingly, there is a natural connection between the independent set constraint,
# and the [Rydberg Blockade](@ref blockade) phenomenon in neutral-atom quantum computing using Rydberg states. 
# More specifically, the Rydberg blockade implies that two atoms cannot be both excited to the Rydberg state ``\Ket{r}`` if they are close to each other, 
# whereas the independent set constraint means two vertices cannot be both in the independent set when they are connected by an edge.
# Thus, one can consider atoms in the Rydberg state as vertices in an independent set. See the proposal in [H. Pichler et al. (10.48550/arXiv.1808.10816)](https://arxiv.org/pdf/1808.10816.pdf) for more details. 

# In particular, one can use the ground state of the [Rydberg Hamiltonian](@ref Hamiltonians) to encode the [Maximum Independent Set problem](https://en.wikipedia.org/wiki/Independent_set_(graph_theory)), 
# which is to find the largest independent set of a given graph. 
# For a particular subclass of geometric graphs, the so-called unit disk graphs, 
# the Rydberg Hamiltonian can encode the solution without any overhead in the number of qubits. 
# In fact, an experimental demonstration of quantum optimization has been realized in solving the Maximum Independent Set problem on up to 289 qubits in [S. Ebadi et al. (10.48550/arXiv.2202.09372)](https://arxiv.org/abs/2202.09372).

# In this tutorial, we show how to solve the MIS problem using Bloqade.
# We focus on a particular subclass of unit disk graphs defined as Diagonal-connected Unit-disk Grid Graphs (DUGG).
# This is the class of graphs studied in the demonstration experiment [S. Ebadi et al. (10.48550/arXiv.2202.09372)](https://arxiv.org/abs/2202.09372).
# Although these graphs have highly constrained topologies, finding its MISs is still NP-hard.
# Here, we show how to use variational quantum algorithms with Rydberg Hamiltonians to solve the MIS problem on these graphs.
# The tutorial here strongly resembles the setup in [S. Ebadi et al. (10.48550/arXiv.2202.09372)](https://arxiv.org/abs/2202.09372),
# with the limitation that Bloqade can only simulate a much smaller problem.

# For more details on the functionalities supported by Bloqade in studying independent set problems,
# please refer to the [Maximum Independent Set](@ref mis) page in the Manual. 

# Let's start by importing the required libraries:

using Graphs
using Bloqade
using Random
using GenericTensorNetworks
using Optim
using Bloqade.CairoMakie

# ## Setting Up the Problem

# To begin, we create a ``4 \times 4`` DUGG with 0.8 filling, by using the [`random_dropout`](@ref) function. 
# Here, we choose the lattice constant ``a`` to be 4.5 μm: 
Random.seed!(2)
atoms = generate_sites(SquareLattice(), 4, 4; scale = 4.5) |> random_dropout(0.2)

# Next, we set the blockade radius to be 7.5 μm, 
# corresponding to a case where nearest neighbors and next-nearest neighbors (diagonal from the initial atom) are within the blockade radius.
# As we discussed in the [Rydberg Blockade](@ref blockade) tutorial, only one Rydberg excitation is allowed within the blockade radius.  
# To better illustrate this constraint, we 
# plot the interactions of Rydberg atoms as a DUGG, where each edge corresponds to the blockade constraint given by the blockade radius: 
Bloqade.plot(atoms, blockade_radius = 7.5)

# Our goal is to find a maximum independent set of such a graph.

# For comparison, we first use classical algorithms to calculate the MIS size here using the graph utilities in Bloqade, 
# so that one can compare this exact result with the quantum algorithms.
# The exact MIS size and its degeneracy can be solved with
# the [generic tensor network algorithm (J. Liu et al. (10.48550/arXiv.2205.03718))](https://arxiv.org/pdf/2205.03718.pdf) 
# in the package [`GenericTensorNetworks`](https://github.com/QuEraComputing/GenericTensorNetworks.jl):
graph = BloqadeMIS.unit_disk_graph(atoms, 7.5)
independent_set_problem = IndependentSet(graph)
mis_size_and_counting = GenericTensorNetworks.solve(GenericTensorNetwork(independent_set_problem), CountingMax())[]

# The `solve` function takes a graph instance and a solution space property as inputs,
# where the graph instance is generated by the [`unit_disk_graph`](@ref) function in the Bloqade submodule `BloqadeMIS`,
# and the solution space property is to count the number of maximum independent sets here.
# For this specific DUGG, we see that the MIS size is 4, and the number of possible Maximum Independent Sets is 26.
# In the following, we are going to show how to solve the independent set problem with both quantum adiabatic and variational algorithms.

# ## The Adiabatic Approach

# Here, we generalize the quantum adiabatic algorithm used in 
# the [Adiabatic Evolution](@ref) tutorial to prepare ground states of the Rydberg Hamiltonian for this disordered lattice.
# We first construct the adiabatic pulse sequences for the Rabi frequency ``\Omega`` and the detuning ``\Delta``:

T_max = 0.6
Ω_max = 2π * 4
Ω = piecewise_linear(clocks = [0.0, 0.1, 0.5, T_max], values = [0.0, Ω_max, Ω_max, 0])
Δ_start = -2π * 13
Δ_end = 2π * 11
Δ = piecewise_linear(clocks = [0.0, 0.1, 0.5, T_max], values = [Δ_start, Δ_start, Δ_end, Δ_end])

fig = Figure(size=(960, 320))
ax1 = Axis(fig[1, 1]; ylabel="Ω/2π (MHz)")
ax2 = Axis(fig[1, 2]; ylabel="Δ/2π (MHz)")
Bloqade.plot!(ax1, Ω)
Bloqade.plot!(ax2, Δ)
fig

# Here, the total time is fixed to `T_max`, the adiabatic evolution path is specified by the [`piecewise_linear`](@ref) function.
# The Rydberg blockade radius can be computed with 
# ```math
# C_6 / R_b^6 \sim \sqrt{\Delta^2 + \Omega^2}
# ```
# The default for ``C_6=2π * 862690 \text{ MHz μm}^6``.
# For encoding the corresponding MIS problem at ``\Omega = 0``, 
# the detuning can be set around ``2\pi \times 11`` MHz 
# for a blockade radius of ``7.5`` µm
# (see the parameters in [S. Ebadi et al. (10.48550/arXiv.2202.09372)](https://arxiv.org/abs/2202.09372)).

# Next, we create the time-dependent Hamiltonian and simulate its time evolution by using the [`SchrodingerProblem`](@ref) solver:

hamiltonian = rydberg_h(atoms; Ω = Ω, Δ = Δ)
prob = SchrodingerProblem(zero_state(nqubits(hamiltonian)), T_max, hamiltonian)
emulate!(prob)

# Finally, we can plot the most probable bitstrings by using the [`bitstring_hist`](@ref) function on the resulting register (quantum state):
bitstring_hist(prob.reg; nlargest = 20)

# We can see that some of the most probable configurations indeed have an independent set size 4 by counting the number of ones in the bitstring.
# The correctness of the output can be verified by comparing it to the classical solution:

best_bit_strings = most_probable(prob.reg, 2)
all_optimal_configs = GenericTensorNetworks.solve(GenericTensorNetwork(independent_set_problem), ConfigsMax())[]
@assert all(bs -> GenericTensorNetworks.StaticBitVector([bs...]) ∈ all_optimal_configs.c, best_bit_strings)

# We can also visualize these atoms and check them visually:
Bloqade.plot(atoms, blockade_radius = 7.5; colors = [iszero(b) ? "white" : "red" for b ∈ best_bit_strings[1]])
#
Bloqade.plot(atoms, blockade_radius = 7.5; colors = [iszero(b) ? "white" : "red" for b ∈ best_bit_strings[2]])

# However, there are still some configurations that violate the blockade constraint, 
# because the blockade interaction is not an ideal unit disk constraint (e.g. some bitstrings have a size 5).
# One can check whether the independence constraint is satisfied or not with the [`BloqadeMIS.is_independent_set`](@ref) function:
best5_bit_strings = most_probable(prob.reg, 3)
BloqadeMIS.is_independent_set.(best5_bit_strings, Ref(graph))

# This can happen when the Rydberg interaction is not very strong at the unit disk radius.
# See the [Rydberg Blockade](@ref blockade) page for more detailed explanations on Rydberg blockade 
# and its relation with the unit disk radius.
# One can perform some postprocessing by reducing the violated configurations to indendendent set configurations 
# using the [`mis_postprocessing`](@ref) function.
# Please also refer to the paper [S. Ebadi et al. (10.48550/arXiv.2202.09372)](https://arxiv.org/abs/2202.09372)).
# for more detailed discussion on the postprocessing procedure.
fixed = mis_postprocessing(best5_bit_strings[3], graph)
BloqadeMIS.is_independent_set(fixed, graph)

# ## QAOA with Piecewise Constant Pulses
# The [QAOA (Quantum Approximate Optimization Algorithm) algorithm (E. Farhi, J. Goldstone, S. Gutmann (10.48550/arXiv.1411.4028))](https://arxiv.org/pdf/1411.4028.pdf) is a hybrid quantum-classical algorithm. 
# The classical part of the algorithm is an optimizer, which can be either a gradient-based or non-gradient-based one.
# For our specific problem, the corresponding quantum part is a neutral-atom quantum computer 
# first evolving under the Rydberg Hamiltonian with parameterized pulse sequences and then being measured in the computational basis.

# The standard definition of QAOA involves applying the problem (expressed as a cost function) Hamiltonian ``C`` and the transverse field Hamiltonian ``B`` alternately.
# Let ``G=(V,E)`` be a graph. The cost Hamiltonian for an MIS problem can be defined as 
# ```math
# C(G) = -\sum_{j\in V}^{n} w_j n_j^z + \infty \sum_{\langle j,k\rangle \in E}n_j^z n_k^z
# ```
# where the first summation is proportional to the size of the independent set, 
# and the second term enforces the independence constraints.

# In a Rydberg Hamiltonian, the first term corresponds to the detuning ``w_i = \Delta``.
# The second term contains an ``\infty``, which corresponds to the Rydberg blockade term 
# with its strength described as ``V_{jk} = C_6/|\mathbf{x}_j - \mathbf{x}_k|^6``.
# As we can see, the Rydberg interaction is not a perfect independence constraint due to with finite blockade interaction and unwanted long-range interaction. 
# Thus, postprocessing might be required using neutral-atom quantum computers to solve the MIS problem.
#
# The transverse-field Hamiltonian corresponds to the Rabi term in the Rydberg Hamiltonian,
# ```math
# B = \sum_{j=1}^{n}\sigma_j^x + \infty \sum_{\langle j,k\rangle \in E}n_j^z n_k^z.
# ```

# Note that the Rybderg interaction term is always on, 
# in contrast to the standard QAOA protocol. 
# For the convenience of the simulation, we use the [`expect`](@ref) function to get the averaged measurement outputs. 
# On the actual quantum hardware, the `expect` should be replaced by measuring in the computational basis
# and obtaining the averaged number of Rydberg excitations as the loss function (also called objective function or cost function).
# One can then either use non-gradient-based optimizers to perform the optimization 
# or finite-difference methods to obtain gradients of parameters.

# Let us first set up a non-optimized pulse sequence for QAOA with step ``p=3``:

durations = fill(0.1, 6)
clocks = [0, cumsum(durations)...]
Ω2 = piecewise_constant(; clocks = clocks, values = repeat([Ω_max, 0.0], 3))
Δ2 = piecewise_constant(; clocks = clocks, values = repeat([0.0, Δ_end], 3))


fig = Figure(size=(960, 320))
ax1 = Axis(fig[1, 1]; ylabel="Ω/2π (MHz)")
ax2 = Axis(fig[1, 2]; ylabel="Δ/2π (MHz)")
Bloqade.plot!(ax1, Ω2)
Bloqade.plot!(ax2, Δ2)
fig

# The `piecewise_constant` pulses can be more accurately simulated with the [`KrylovEvolution`](@ref) solver.
# This time, we simulate the dynamics in the subspace generated by the [`blockade_subspace`](@ref) function, so that we do not need postprocessing anymore.
hamiltonian2 = rydberg_h(atoms; Ω = Ω2, Δ = Δ2)
nsites = length(atoms)
subspace = blockade_subspace(atoms, 7.5)  # we run our simulation within the blockade subspace 
prob2 = KrylovEvolution(zero_state(subspace), clocks, hamiltonian2)
emulate!(prob2);

# We defined the loss function as the negative of the mean MIS size, 
# which corresponds to the expectation value of the [`SumOfN`](@ref) operator.
# Thus, we can calculate the average loss function after the time evolution:  
loss_MIS(reg) = -rydberg_density_sum(reg)
loss_MIS(prob2.reg)

# The output shows the negative mean independent set size. 
# This is because we have flipped its sign since most optimizers are set to minimize the loss function.
# This loss is equivalent to the [`rydberg_density_sum`](@ref) loss function in the [`BloqadeMIS`](@ref) module. 
# Alternative loss functions include the [`gibbs_loss`](@ref) and the [`independent_set_probabilities`](@ref).

# Here, the loss produced by the pulse sequence does not look very good.
# We can throw it into an optimizer and see if a classical optimizer can help.
# First, let us wrap up the above code into a loss function:

function loss_piecewise_constant(atoms::AtomList, x::AbstractVector{T}) where {T}
    @assert length(x) % 2 == 0
    Ω_max = 4 * 2π
    Δ_end = 11 * 2π
    p = length(x) ÷ 2

    ## detuning and rabi terms
    durations = abs.(x)   # the durations of each layer of the QAOA pulse take the optimizing vector x as their input 
    clocks = [0, cumsum(durations)...]
    Ωs = piecewise_constant(; clocks = clocks, values = repeat(T[Ω_max, 0.0], p))
    Δs = piecewise_constant(; clocks = clocks, values = repeat(T[0.0, Δ_end], p))

    hamiltonian = rydberg_h(atoms; Ω = Ωs, Δ = Δs)
    subspace = blockade_subspace(atoms, 7.5)  # we run our simulation within the blockade subspace 
    prob = KrylovEvolution(zero_state(Complex{T}, subspace), clocks, hamiltonian)
    emulate!(prob)
    return -rydberg_density_sum(prob.reg), prob.reg
end

# !!! note
#     Running the simulation in the subspace does not violate the independence constraints.
#     If one uses fullspace simulation or runs it on the quantum computer, one may need to post-process the measured bitstrings to a get a correct measure of the loss if we do not set the blockade constraint. 
#     Related APIs include [`is_independent_set`](@ref), [`num_mis_violation`](@ref), and [`mis_postprocessing`](@ref).

# Let us check the loss function again using the initial point above: 
x0 = durations
density, reg1 = loss_piecewise_constant(atoms, x0)
density

# The most probable bitstrings are:

bitstring_hist(reg1; nlargest = 20)

# We see that without optimization, many of these bitstrings are not the MIS solutions.

# Let us now use the non-gradient-based optimizer `NelderMead` in the `Optim` package to optimize the loss function:
optresult = Optim.optimize(x -> loss_piecewise_constant(atoms, x)[1], x0)

rydberg_density_final, reg1_final = loss_piecewise_constant(atoms, optresult.minimizer)
rydberg_density_final

# We see that the loss is indeed improved, but still not very good.
# This is likely because the optimization is trapped in a local minimum:

bitstring_hist(reg1_final; nlargest = 20)

# This example shows that the performance of the algorithm very much depends on 
# the parametrization of the pulse sequences, the initialization of the variational parameters, 
# and the classical optimizers. 
# See [S. Ebadi et al. (10.48550/arXiv.2202.09372)](https://arxiv.org/abs/2202.09372)
# for more in-depth comparison of different pulse parameterizations and tips on how to improve the performance.

# In the example below, we show a better pulse parameterization 
# using smoothened piecewise linear waveforms. 

# ## Smoothened Piecewise Linear Pulses

# A smoothened piecewise linear waveform can be created by applying a Gaussian filter on a waveform created by the `piecewise_linear` function. 
# For example:
pulse_piecewise_linear = piecewise_linear(clocks = [0.0, 0.05, 0.1, 0.5, 0.55, T_max], values = [0, 0, 0.4, 0.4, 0, 0]);
pulse_smooth = smooth(pulse_piecewise_linear; kernel_radius = 0.02);

fig = Figure()
ax = Axis(fig[1, 1]; ylabel="strength")
Bloqade.plot!(ax, pulse_piecewise_linear; label = "piecewise linear")
Bloqade.plot!(ax, pulse_smooth; label = "smoothened piecewise linear")
axislegend(ax; position=:rb)
fig

# Here, the function [`smooth`](@ref) takes a `kernel_radius` keyword parameter as the Gaussian kernel parameter.
# With the new waveforms, we can define the loss function as follows:

function loss_piecewise_linear(atoms::AtomList, x::AbstractVector{T}) where {T}
    @assert length(x) == 3
    Ω_max = 4 * 2π
    Δ_start = -13 * 2π
    Δ_end = 11 * 2π
    Δ0 = 11 * 2π
    T_max = 0.6

    ## the strength of the detunings at each step takes the optimizing x as their input 
    Δs = smooth(
        piecewise_linear(
            clocks = T[0.0, 0.05, 0.2, 0.3, 0.4, 0.55, T_max],
            values = T[Δ_start, Δ_start, Δ0*x[1], Δ0*x[2], Δ0*x[3], Δ_end, Δ_end],
        );
        kernel_radius = 0.02,
    )
    Ωs = smooth(
        piecewise_linear(clocks = T[0.0, 0.05, 0.1, 0.5, 0.55, T_max], values = T[0, 0, Ω_max, Ω_max, 0, 0]);
        kernel_radius = 0.02,
    )

    hamiltonian = rydberg_h(atoms; Ω = Ωs, Δ = Δs)
    subspace = blockade_subspace(atoms, 7.5)
    prob = SchrodingerProblem(zero_state(Complex{T}, subspace), T_max, hamiltonian)
    emulate!(prob)
    return -rydberg_density_sum(prob.reg), prob.reg, Δs
end

x0 = [0.1, 0.8, 0.8]; # initial point for the optimization

# Let us check the loss function with smoothened waveform with the initial point:
Δ_start = -13 * 2π
Δ_end = 11 * 2π
Δ0 = 11 * 2π
T_max = 0.6
Δ_initial = piecewise_linear(
    clocks = [0.0, 0.05, 0.2, 0.3, 0.4, 0.55, T_max],
    values = [Δ_start, Δ_start, Δ0 * x0[1], Δ0 * x0[2], Δ0 * x0[3], Δ_end, Δ_end],
)

density, reg2, Δ_initial_smooth = loss_piecewise_linear(atoms, x0)
density

# and plot the smoothened waveform:
fig = Figure()
ax = Axis(fig[1, 1]; ylabel="Δ/2π (MHz)")
Bloqade.plot!(ax, Δ_initial; label = "piecewise linear")
Bloqade.plot!(ax, Δ_initial_smooth; label = "smoothened piecewise linear")
axislegend(ax; position=:rb)
fig

# Let's plot the distribution:
bitstring_hist(reg2; nlargest = 20)

# The performance of the algorithm is quite good. 
# Again, let us use the `NelderMead` optimizer to optimize the loss function:
optresult = Optim.optimize(x -> loss_piecewise_linear(atoms, x)[1], x0)

rydberg_density_final, reg_final, Δ_final = loss_piecewise_linear(atoms, optresult.minimizer)
rydberg_density_final
# One can see the mean MIS size can be further improved to a value close to the size of the MIS,
# which means there is a substantial probability for measuring an MIS state. 

bitstring_hist(reg_final; nlargest = 20)

# We can also plot out the final optimized waveform for Δ 
# and compare it with the initial waveform:
fig = Figure()
ax = Axis(fig[1, 1]; ylabel="Δ/2π (MHz)")
Bloqade.plot!(ax, Δ_initial_smooth; label = "initial")
Bloqade.plot!(ax, Δ_final; label = "optimized")
axislegend(ax; position=:rb)
fig

# ## Applications in VLSI Chip Manufacturing 

# ### Background

# The Maximum Independent Set (MIS) tutorial above described how to use Bloqade to computed the MIS on arbitrary unit disk graphs. 
# In this tutorial, we will use the same algorithm but also show how to map a problem with real-world applications to a problem 
# that can be solved with Bloqade's features.  

# Configurability is an approach to chip manufacturing in VLSI design. 
# Ordinarily, copies of the entire chip and fabricated and on a wafer, the wafer is diced into chips using scribing corridors, 
# and then faulty chips are marked and discarded. However, since the entire chip is being manufactured at once, this is wasteful because even 
# if only a small portion of the chip is defective, it must be entirely discarded. 
# According to [F. Berman et al.](https://core.ac.uk/download/pdf/4951484.pdf), "To use configurability, this process is changed somewhat. 
# Special circuitry is added in the scribing corridors that enables adjacent chips to be connected. 
# Then, after the wafer is tested, adjacent functional chips are connected into a group and the entire group is used as a single enlarged chip." 
# In this way, even if a smaller chips becomes defective, the adjacent chips can be rewired so that they can still be used in the larger chip. 

# A natural problem that arises from this setup is the _square packing_ problem. 
# [D. Hochbaum and W. Maass](https://www.cs.du.edu/~snarayan/sada/research/docs/p130-hochbaum.pdf) summarizes an example problem: 
# "64K RAM chips, some of which may be defective, are available on a rectilinear grid placed on a silicon wafer. 
# 2 x 2 arrays of such nondefective chips could be wired together to produce 256K RAM chips.
# In order to maximize yield, we want to pack a maximal number of such 2 X 2 arrays into the array of working chips on a wafer."

# To solve this problem, let us start with the necessary imports:


using Bloqade
using GenericTensorNetworks
using GenericTensorNetworks: unit_disk_graph
using Bloqade.CairoMakie
using Random
using Optim

# ### Setting up the Problem

# We can visualize this problem as a grid of 64K RAM chips, where some of the grid cells are removed. 


G = 5 # grid size (G x G)
defects = []
for i in range(1, G*G//15)
    push!(defects, ((rand(Int)%G+10) % G, (rand(Int)%G + 10) % G))
end

fig = Figure(size=(400, 400))
ax = Axis(fig[1, 1]; ygridvisible=true, xgridvisible=true, xticks=1:G, yticks=1:G, aspect=DataAspect(), limits=(0, G, 0, G))
grid = zeros((G, G))

function plot_defects(defects)
    for (x, y) in defects
        CairoMakie.poly!(Rect(x, y, 1.0, 1.0), color = :red)
        grid[x+1, y+1] = 1
    end
end

plot_defects(defects)
    
fig

# Wherever there is a 2x2 grid of non-defective chips, these grid cells can be wired together. 
# This potential grouping of chips can be visualized as a unit disk which overlaps with the four grid cells that are being wired together.
# For example, in the figure below, the four grid cells in the upper left corner could be wired together, 
# so we would put a unit disk at (1, 9) with radius 1.

# ![VLSI](../../../assets/vlsi.png)

# The code below shows the unit disk corresponding to every possible wiring.
# Overlapping unit disks represents two wirings which conflict with each other because they use the same chips. 
# Our goal is to find the maximum number of non-conflicting wirings, i.e. the MIS.

circs::Vector{Tuple{Int64, Int64}} = []
Δ = [(0, 0) (0, 1) (1, 0) (1, 1)]

for x in 1:G-1
    for y in 1:G-1
        works = true
        for (dx, dy) in Δ
            if 1 ≤ x+dx ≤ G && 1 ≤ y + dy ≤ G
                works &= grid[x+dx,y+dy]==0
            end
        end
        if works
            push!(circs, (x, y))
        end
    end
end

R_opt = sqrt(2sqrt(2))/2
circles = []
for circ in circs
    push!(circles, CairoMakie.poly!(Circle(CairoMakie.Point(Float64.(circ)), R_opt), color = :transparent, strokewidth=1))
end

fig

# We can now use Bloqade, transforming this problem (which is a type of Diagonal-connected Unit-disk Grid Graph (DUGG)) into a lattice of atoms.
# We want each atom to be positioned at the center of the unit disk and have a blockade radius of roughly 7.5 μm, reusing the methdology and values
# given in the "Setting Up the Problem" section of the tutorial above which enables atoms that exist diagonally from the initial atom to fall within 
# the Blockade radius.

# We will scale the position of the atoms so that we get the desired unit disk overlaps with a radius of 7.5 μm: 

function scalePos(pos, scale)::Vector{Tuple{Float64, Float64}}
    npos = []
    for (x, y) in pos
        push!(npos, (x*scale, y*scale))
    end
    return npos
end
R = 7.5
scale = 7.5/(2*R_opt)

atoms = AtomList(scalePos(circs, scale))
Bloqade.plot(atoms, blockade_radius = R)

# We will first use classical algorithms to find the optimal solution to the problem:

unit_graph = unit_disk_graph(atoms, R)
independent_set_problem = IndependentSet(unit_graph)
configs = GenericTensorNetworks.solve(GenericTensorNetwork(independent_set_problem), ConfigsMax())[]
MIS_config = configs.c[1]

# We can visualize the solution on the atom lattice:

Bloqade.plot(atoms, blockade_radius = R; colors = [iszero(b) ? "white" : "red" for b in MIS_config])

# We can also visualize the solution on the chip grid:

delete!.(Ref(ax.scene), circles)
for (circ, used) in zip(circs, MIS_config)
    if used == 1
        CairoMakie.poly!(Circle(CairoMakie.Point(Float64.(circ)), R_opt), color = :transparent, strokewidth=1)
    end
end

fig


# ### The Adiabatic Approach

# Like with the Maximum Independent Set tutorial above, we can use an adiabatic algorithm to solve this problem. 
# We can use the same pulse sequence for $\Omega$ and $\Delta$:

T_max = 0.6
Ω_max = 2π * 4
Ω = piecewise_linear(clocks = [0.0, 0.1, 0.5, T_max], values = [0.0, Ω_max, Ω_max, 0])
Δ_start = -2π * 13
Δ_end = 2π * 11
Δ = piecewise_linear(clocks = [0.0, 0.1, 0.5, T_max], values = [Δ_start, Δ_start, Δ_end, Δ_end])

fig = Figure(size=(960, 320))
ax1 = Axis(fig[1, 1]; ylabel="Ω/2π (MHz)")
ax2 = Axis(fig[1, 2]; ylabel="Δ/2π (MHz)")
Bloqade.plot!(ax1, Ω)
Bloqade.plot!(ax2, Δ)
fig

# And construct the Hamiltonian:

hamiltonian = rydberg_h(atoms; Ω = Ω, Δ = Δ, ϕ=Waveform(t->0.0, T_max))
prob = SchrodingerProblem(zero_state(nqubits(hamiltonian)), T_max, hamiltonian)
emulate!(prob)

# We can see that our algorithm found the Maximum Independent Set by summing the probabilities of being in any one of the MIS configurations:

function get_MIS_prob(reg::Union{ArrayReg, SubspaceArrayReg}, configs) # want to maxmimize this 
    prob = 0
    x = [parse(Int, reverse(string(x)); base=2) for x in configs.c]
    for (c, amp) in BloqadeMIS.ConfigAmplitude(reg)
        if c in x
            prob+=abs2(amp)
        end
    end
    return prob
end

get_MIS_prob(prob.reg, configs)

# ### Optimization

# For even better results, we can optimize the pulse sequence for $\Omega$ and $\Delta$.
# We can parametrize the pulses by $t_{start}$ and $t_{end}$, which are the times spent in the initial and final state, respectively. 
# We will also optimize the shape on the detuning pulse by modeling it as a piecewise linear function given by parameters that indicate 
# what values it reaches at regular time intervals. We will optimize for the probabilitity that of getting one the MIS solutions without 
# applying any classical postprocessing on the results of the stimulation. 


function get_waves(params::Vector{Float64}) # returns the pulses as a function of certain parameters
    t_start, t_end, scale... = params
    t_start+=0.03
    T_max = 0.6
    t_end = T_max - t_end - 0.03
    t_interval = (t_end - t_start) / (length(scale) + 1)
    Ω_max = 4 * 2π
    Δ_start = -13 * 2π
    Δ_end = Δ0 = 11 * 2π
    
    Δ_clock = [0.0, t_start]
    Δ_val = [Δ_start, Δ_start]
    for i in 1:length(scale)
        push!(Δ_val, Δ0*scale[i])
        push!(Δ_clock, t_start + i*t_interval)
    end
    push!(Δ_val, Δ_end); push!(Δ_val, Δ_end)
    push!(Δ_clock, t_end); push!(Δ_clock, T_max)
    Δ = piecewise_linear(clocks = Δ_clock, values = Δ_val);
    Ω = piecewise_linear(clocks = [0.0, t_start, t_end, T_max], values = [0, Ω_max, Ω_max, 0]);
    return Ω, Δ
end

# The example below plots the pulse sequence that would be generated by the parameters given in `x0`:

function plot_waves(params::Vector{Float64})
    Ω, Δ = get_waves(params)

    fig = Figure(size=(960, 320))
    ax1 = Axis(fig[1, 1]; ylabel="Ω/2π (MHz)")
    ax2 = Axis(fig[1, 2]; ylabel="Δ/2π (MHz)")
    Bloqade.plot!(ax1, Ω)
    Bloqade.plot!(ax2, Δ)
    return fig
end

x0 = [0.1, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8]

plot_waves(x0)

# We can now run the optimization using the `Nelder-Mead` algorithm

function loss(atoms::AtomList, x::Vector{Float64}, configs)
    Ω, Δ = get_waves(x)
    hamiltonian = rydberg_h(atoms; Ω = Ω, Δ = Δ)
    subspace = blockade_subspace(atoms, 4.5)
    prob = SchrodingerProblem(zero_state(subspace), T_max, hamiltonian)
    emulate!(prob)
    return -get_MIS_prob(prob.reg, configs), prob.reg, Δ
end

optresult = Optim.optimize(x -> loss(atoms, x, configs)[1], x0)

# We can look at the new pulse sequence, which has a much better `get_MIS_prob`:

plot_waves(optresult.minimizer)

# The new parameters give much better results when we rerun the adiabtic algorithm: 

Ω, Δ = get_waves(optresult.minimizer)
hamiltonian = rydberg_h(atoms; Ω = Ω, Δ = Δ, ϕ=Waveform(t->0.0, T_max))
prob = SchrodingerProblem(zero_state(nqubits(hamiltonian)), T_max, hamiltonian)
emulate!(prob)

bitstring_hist(prob.reg; nlargest = 20)

# # [Rydberg Blockade](@id blockade)

# The Rydberg blockade mechanism is one of the most important phenomena of neutral atom quantum computing based on Rydberg interactions.
# By including a term in the effective Hamiltonian which adds an interaction between adjacent atoms in the Rydberg states, 
# one can construct gates and nontrivial dynamics that create entanglement and correlation across the system.

# The Rydberg interaction is a van der Waals interaction, where there is an energy shift if two adjacent atoms are both in the Rydberg state. 
# The van der Waals interaction is

# ```math
# V_{jk} = \frac{C_6}{|\mathbf{x}_j - \mathbf{x}_k|^6}\hat n_j \hat n_k,
# ```

# where ``\hat n_j=|r_j\rangle\langle r_j|`` is the number operator on the ``j``th site, 
# which is 1 if the atom is in the Rydberg state ``| r_j \rangle``, and 0 if the atom is in the ground state ``| g_j \rangle``. 
# The coefficient ``C_6 = 2\pi\times 862690 \text{ MHz μm}^6`` is the interaction strength; 
# characteristically, this interaction has a strength ``C_6 \approx 2\pi\times 4`` MHz for two atoms separated by ``7.74`` μm,
# a similar scale to the Rabi frequency coupling the ground and the Rydberg state. 
# Crucially, this can be seen as an energy shift on atom ``k``, conditional on the state of atom ``j``, 
# and so can be used, in a loose sense, as a conditional logical gate. 
# This is because the adjacent atom forces the atom to be off-resonant with the laser field if it is in the Rydberg state.
# Please refer to the [Hamiltonians](@ref) page for descriptions of all the terms in the Rydberg Hamiltonian.

# This conditional drive can be seen given the following dynamics. 
# Suppose two atoms are close to each other (``< 10`` μm) and so experience a strong Rydberg interaction (see the diagram below). 
# The left atom is either in a Rydberg state, or in the ground state, and the right atom is originally in the ground state. 
# Then, a Rabi drive is applied to the right atom, which couples the atom's ground state to the Rydberg state. 
# For this example, we choose a Rabi frequency of ``\Omega=2\pi\times 0.5`` MHz 
# and distance between atoms ``|\mathbf{x}_j - \mathbf{x}_k| = 7`` μm, 
# which gives a conditional detuning (Rydberg interaction) of ``\approx 2\pi \times 7.33`` MHz. 
# When the left atom is in the ground state (blue circle in figure), 
# there are no interactions and the state of the right atom experiences 
# standard [Rabi oscillation](https://en.wikipedia.org/wiki/Rabi_cycle) between the ground state and the Rydberg state; 
# for a particular choice of timing, this executes a ``\pi`` pulse, 
# flipping the right atom from the ground to the Rydberg state. 
# However, when the left atom is in the Rydberg state (red circle in figure), 
# there is a large detuning on the right atom due to the strong Rydberg interaction, 
# which causes the transition to the Rydberg state to be strongly suppressed. 
# In this case, the right atom (up to perturbative corrections) is never in the Rydberg state.
# This is the so-called Rydberg blockade.

# ![RydbergBlockade](../../../assets/RydbergBlockade.png)

# Because of the large energy shift from having two adjacent atoms in the Rydberg state, 
# evolution from an atomic ground state with local Rabi couplings between ground and Rydberg state is restricted to a low-energy subspace of states 
# where no two adjacent atoms are in the Rydberg state. 
# Furthermore, because the interaction strength with distance is a large power law, 
# one can define a characteristic scale set by the Rabi frequency. 
# If two atoms are close such that the conditional detuning is much larger than the Rabi frequency, 
# one can consider the atoms to be blockading each other, 
# and both atoms cannot simultaneously be in the Rydberg state. 
# In contrast, if two atoms are far away, the two atoms never blockade each other and both atoms can simultaneously be in the Rydberg state.

# ## Blockade radius ``R_b``, subspace radius ``R_s``, and unit disk graphs

# The blockade radius is defined as the distance at which 
# the Rydberg interaction energy is the same as the Rabi frequency

# ```math
# \frac{C_6}{R_b^6} = \Omega,
# ```

# where ``R_b`` is the blockade radius, which sets the characteristic distance scale 
# for which Rydberg interaction will be strong compared to the coupling strength between
# the ground and the Rydberg state set by ``\Omega``. 
# In the above example, ``\Omega = 2\pi\times 0.5`` MHz, so ``R_b = (C_6 / \Omega)^{1/6} \approx 10.95``  μm.
# In practice, the blockade approximation,
# i.e., truncating the states that have both atoms in the Rydberg state, may not be a good approximation at the distance ``R_b``, 
# since it is more like the onset energy scale at which Rydberg interaction becomes strong. For a better blockade approximation, 
# the atoms should be closer than ``R_b``. We refer to this distance as the subspace radius ``R_s`` (``R_s \leq R_b``), 
# at which we claim it will be a reasonably good approximation to throw away all the states that have more than one Rydberg states 
# whenever they are within the radius ``R_s``.

# Therefore, in simulating the quantum dynamics, instead of doing it in the full ``2^N`` Hilbert space, we may take advantage of the energy structure
# and truncate those blockade-violated states. 
# Mathematically, this is related to the [independent sets](@ref mis-tutorial) of the unit disk graph defined by the positions of the atoms.
# A unit disk graph is a set of vertices and edges, where each vertex represents an atom, 
# and there are edges if the distance between vertices is less than or equal to some unit disk radius ``|\mathbf{x}_j - \mathbf{x}_k| \leq R_u``.
# An independent set is a set of vertices in the graph such that no two of which are connected by an edge.
# Thus, the non-blockade-violated states are the independent set states of the corresponding unit disk graph, 
# where the independent set consists of the vertices (atoms) that are excited to the Rydberg state.
# If we set ``R_u = R_s``, it will be a good approximation to throw away those non-independent sets.
# In practice, it may not be easy to know *a priori* what will be a good choice for ``R_s``, since it depends on 
# the specific atom arrangement and the specific many-body quantum dynamics. 
# For example, if ``R_s = 1/2 \times R_b``, we will be throwing away states that have interaction energies at least ``2^6 \times \Omega``, 
# which will typically be a very good approximation. 
# In the two-atom example above, we can set ``R_s = 7`` μm and throw away the state when both atoms are in the Rydberg state,
# which is quite good an approximation as seen in the figure below. 
# In this case, the Rydberg-blockaded state has an interaction of ``(R_b / R_s)^6 \, \Omega \approx 14.7 \, \Omega``.
# When the blockade approximation is valid, the basis states would be separated into bands due to the strong Rydberg interaction,
# and there will be small perturbative coupling between the bands due to the Rabi coupling, 
# (which is typically in the order of ``(\Omega / V_{jk})^2``).
# See the illustrative figure below: 

# ![EnergyTruncation](../../../assets/bloqade_subspace.png)

# The lowest energy states are representative of independent sets of the unit disk graph, 
# where Rydberg excitations are in the independent set and no two Rydberg excitations are within the unit disk radius. 
# The second energy band are sets with a single independent set violation, 
# where there are equivalently just two Rydberg excitations within the unit disk radius of each other. 
# Higher and higher bands represent more and more independent set violations. 
# We emphasize again that this band structure is dependent on the arrangement of atoms, 
# and for arbitrary configurations, this band structure may not be clear.

# To run more efficient simulations in the blockade [subspace](@ref subspace),
# the simplest scheme is to truncate the Hilbert space to the low-energy subspace, 
# and exclude all states above a certain energy. 
# Given the natural band structure of the classical Hamiltonian, 
# we may simply truncate the Hilbert space to the subspace of independent sets of the unit disk graph
# with the unit disk radius set as ``R_u = R_s``.
# Equivalently, this is the **blockade subspace**, 
# where atoms within the subspace radius are excluded from simultaneously being in the Rydberg state.
# The validity of the energy truncation subspace is governed by the strength of off-diagonal matrix elements coupling the low-energy subspace to the high-energy one. 
# For the Rydberg Hamiltonian, these off-diagonal elements ``|1r\rangle\leftrightarrow|rr\rangle`` have a strength ``\Omega``. 
# In order to preserve dynamics within the subspace, the energy difference 
# between states within the blockade subspace (e.g. ``|1r\rangle``) and outside (``|rr\rangle``) must be much larger than the Rabi strength. 
# Formally, if ``\Omega \ll C_6/R_s^6``, then the blockade approximation should be valid 
# (the perturbation is typically in the second order ``(\Omega/ (C_6/R_s^6))^2``).
# As long as this condition holds, the exact dynamics in the full Hilbert space should be closely approximated by the dynamics in the blockade subspace, 
# as the mixing terms only couple to low-energy states.

# Please also refer to the [Working with Subspace](@ref subspace) page in the manual for more details on running simulations in the subspace. 
# Also, see [Maximum Independent Set](@ref mis-tutorial) tutorial for more descriptions on the correspondence 
# between the independent set constraint and the blockade constraint,
# and a tutorial on how to solve the Maximum Independent Set problem using Rydberg Hamiltonians.

# ## Setting Atom Separation Distance from the Blockade Radius

# Suppose given certain arrangement of atoms, we would like to have atoms close to each other to be mutually blockaded, 
# and distant atoms to be non-blockaded. 
# This corresponds to a unit disk graph 
# and the distance scale can be set by the blockade radius ``R_b``.
# For any two atoms within the unit disk radius ``R_u``, 
# the energy scale of having both in the Rydberg state must be much larger than ``\Omega``;
# this sets a lower bound for ``R_u`` compared to ``R_b``.
# On the other hand, for any two atoms outside of the unit disk radius, 
# the energy scale of having both be in the Rydberg state must be much smaller than ``\Omega``, 
# as the two atoms should not be blockaded;
# this sets an upper bound for ``R_u``,
# as there are still ``1/R^6`` interactions between nearby atoms 
# which may "accidentally" blockade each other if 
# ``R_u`` is too large to include the supposedly unblockaded atoms. 
# This upper bound on ``R_u`` guarantees that dynamics occur within the correct independent set subspace 
# and is not affected by long-range "Rydberg tails", 
# which cause each independent set state to have a slightly different energy.

# More specifically, we denote the lower bound as ``R_\text{min}``, 
# which is the minimum ``R_u`` can be without removing any edges from the unit disk graph. 
# Equivalently, it is the maximum distance between vertices that are connected by an edge. 
# We denote the upper bound as ``R_\text{max}``, 
# which is the maximum ``R_u`` can be without adding any additional edges to the unit disk graph. 
# This is equivalently the minimum distance between vertices that are _not_ connected by an edge in the unit disk graph. 
# Therefore, we have ``R_\text{min}\leq R_u < R_\text{max}``.

# The actual scale for ``R_\text{min}, R_u, R_\text{max}`` can be set by ``R_b``. 
# In order to fulfill the condition

# ```math
#  \frac{C_6}{R_\text{max}^6} \ll \Omega \equiv \frac{C_6}{R_b^6} \ll \frac{C_6}{R_\text{min}^6}
# ```

# as much as possible, it's best to have 

# ```math
# R_b = \sqrt{R_\text{min} R_\text{max}} = R_\text{min} \times \sqrt{\frac{R_\text{max}}{R_\text{min}}} 
# \quad \Rightarrow \quad R_\text{min} = R_b \times \sqrt{\frac{R_\text{min}}{R_\text{max}}}.
# ```

# Now, there are several characteristic distances. To summarize, we have: 

# - ``R_u`` is the unit disk radius of the graph. Usually, this is taken to be ``R_u = R_\text{min}``, though generally ``R_\text{min} \leq R_u < R_\text{max}``.

# - ``R_\text{min}`` is the minimum ``R_u`` can be without removing any edges from the unit disk graph.

# - ``R_\text{max}`` is the maximum ``R_u`` can be without adding any edges from the unit disk graph.

# - ``R_b`` is the **blockade radius** of the system defined as ``C_6/R_b^6 = \Omega``. It's preferable to scale ``R_\text{min}`` and ``R_\text{max}`` such that ``R_b = \sqrt{R_\text{min} R_\text{max}}``.

# - ``R_s`` is the subspace radius, at which it is a good approximation to truncate the Hilbert space when two Rydberg excitations are closer than ``R_s``. We have ``R_s \leq R_b``.

# Note that ``R_s`` is used only for faster simulation in the truncated blockade subspace. 
# The smaller the ``R_s``, the better the approximation for the simulation.
# When ``R_s = 0``, one recovers the full-space simulation.

# Below, we explain how to set the distance scale using a few example unit disk graphs.

# Note that acronyms such as "NN", "NNN", and "NNNN" found in this page and its diagrams/tables stand for "Nearest-Neighbor", "Next Nearest-Neighbor", and
# "Next Next Nearest-Neighbor", denoting the furthest atom that can feel the blockading effect of another atom.

# ![BlockadRadius](../../../assets/bloqade_subspace_UDGradius.png)

# In the examples above, ``R_\text{min}`` is the radius of the dark-red disk, 
# ``R_\text{max}`` is the radius of the light-red disk, 
# and ``R_b`` is the radius of the red-dashed circle. 
# The ratios ``R_\text{max}/R_\text{min}`` are shown for several arrangements of atoms. 
# For the 1D chain with nearest-neighbor blockade, let's say the lattice constant is ``a``
# with ``R_\text{min} = a`` and ``R_\text{max} = 2a``. 
# So with ``R_b = \sqrt{R_\text{min} R_\text{max}}``, we have ``a = R_b/\sqrt{2}``.
# Therefore:
# - given ``\Omega = 2\pi \times 4`` MHz,
# - we have``R_b = (C_6 / \Omega)^{1/6} \approx 7.74`` μm,
# - and `` a = R_b /\sqrt{2} \approx 5.48`` μm. 

# Thus, for the ``Z_2`` phase transition in the upcoming [Adiabatic Evolution](@ref Adiabatic-Evolution) example and
# and in a 1D system [paper (H. Bernien et al. (10.1038/nature24622))](https://www.nature.com/articles/nature24622), it is good to set ``a = 5.48`` μm.
# Similarly, one can compute that ``a = 3.16`` μm and ``a = 2.24`` μm will be good choices 
# for observing ``Z_3`` and ``Z_4`` phase transitions in the 1D chain. 
# For the 2D square lattice, ``a = 6.51`` μm and ``a = 4.60`` μm are good options for 
# observing the checkerboard phase (nearest-neighbor blockade) and the striated phase (next-nearest-neighbor blockade)
# as in this [paper (S. Ebadi et al. (10.1038/s41586-021-03582-4))](https://www.nature.com/articles/s41586-021-03582-4),
# following the same rationale as above.
# Here, we summarize the recommended lattice constants (unit μm) for common lattices in the following table:

# |                         | ``R_\text{min}``              | ``R_\text{max}``                       | ``a`` for ``\Omega = 2\pi \times 4`` MHz     | ``a`` for ``\Omega = 2\pi \times 10`` MHz    | 
# | :-----                  |    :-----:                    |     :-----:                            |              :-----:                    |             :-----:                     | 
# | Chain ``Z_2``           |      ``a``                    |       ``2a``                           |                 5.48                    |                 4.70                    |
# | Chain ``Z_3``           |      ``2a``                   |       ``3a``                           |                 3.16                    |                 2.71                    |
# | Chain ``Z_4``           |      ``3a``                   |       ``4a``                           |                 2.24                    |                 1.92                    |
# | Square checkerboard     |       ``a``                   |       ``\sqrt{2}a``                    |                 6.51                    |                 5.59                    |
# | Square striated         |    ``\sqrt{2}a``              |       ``2a``                           |                 4.60                    |                 3.95                    |
# | Square star             |      ``2a``                   |       ``\sqrt{5}a``                    |                 3.66                    |                 3.14                    |
# | Lieb NN                 |      ``a``                    |       ``2a``                           |                 5.48                    |                 4.70                    |
# | Lieb NNN                |      ``2a``                   |       ``\sqrt{5}a``                    |                 3.66                    |                 3.14                    |
# | Lieb NNNN               |      ``\sqrt{5}a``            |       ``\sqrt{8}a``                    |                 3.08                    |                 2.64                    |
# | Triangular NN           |       ``a``                   |       ``\sqrt{3}a``                    |                 5.88                    |                 5.05                    |
# | Triangular NNN          |       ``\sqrt{3}a``           |       ``2a``                           |                 4.16                    |                 3.57                    |
# | Honeycomb NN            |       ``a``                   |       ``\sqrt{3}a``                    |                 5.88                    |                 5.05                    |
# | Honeycomb NNN           |       ``\sqrt{3}a``           |       ``2a``                           |                 4.16                    |                 3.57                    |
# | Kagome NN               |       ``a``                   |       ``\sqrt{3}a``                    |                 5.88                    |                 5.05                    |
# | Kagome NNN              |       ``\sqrt{3}a``           |       ``2a``                           |                 4.16                    |                 3.57                    |

# Other than regular lattices, for an example arbitrary graph shown in the right most panel of the above figure,
# one only has ``R_\text{max}/R_\text{min} \approx 1.15``.
# Thus, there is only a small window to set the unit disk radius, 
# and the energy scale for the blockaded versus non-blockaded Rydberg interaction is not as large 
# (``1.15^6 \approx  2.34``).
# Thus, the blockade approximation for the atoms with a separation close to the blockade radius 
# will not be as good. For accurate simulation of the actual Rydberg dynamics, 
# one should take a subspace radius ``R_s \ll R_\text{min}``. 
# Therefore, we can see that graphs on a regular lattice typically have larger and better energy separation 
# between the blockaded and the non-blockaded states than arbitrary graphs.

# Below, we give an example of doing the simulation in the blockade subspace for a ring system.
# For more information on subspace emulation, please refer to the [subspace](@ref subspace) page.

# ## Example Dynamics in the Blockade Subspace

# To emphasize the effectiveness of the subspace emulation, 
# some example non-equilibrium dynamics are shown below, 
# for a ring of ``12`` atoms separated by ``R_\text{min} = 6.9`` μm. 
# The minimum distance of atoms not within the blockade radius is ``R_\text{max} \approx 13.33`` μm (next-nearest neighbor separation), 
# Thus, the blockade radius can be ``R_b = 6.9 \times \sqrt{13.33/6.9} \approx 9.59`` μm.
# This blockade energy scale corresponds to ``\Omega \approx 2\pi \times 1.11`` MHz, 
# and the perturbative limits are 
# ``\Omega \ll C_6/R_\text{min} \approx 7.99`` MHz 
# and ``\Omega \gg C_6/R_\text{max} \approx 0.15`` MHz. 

# Note that in this example, we set the blockade radius from ``R_\text{min}`` and ``R_\text{max}``, 
# and then obtain Rabi frequency ``\Omega`` from the blockade radius. 
# In practice, it's often the opposite order for specification on the hardware. 
# ``\Omega`` is typically limited by the laser power on the hardware. 
# Thus, one starts from a given ``\Omega``, which determines the blockade radius, ``R_b``,
# which can then inform the separation between atoms as described in the previous section.
# If one starts from the atom separation distance first, 
# it may often result in a Rabi frequency 
# that is too large or too small to be feasible on the neutral-atom hardware.

# The set of atoms for this ring example can be defined by:

using Bloqade
nsites = 12; # 12-site ring
unit_disk_radius = 6.9 # Distance between nearest-neighbor atoms, in microns; R_min

R = unit_disk_radius / (2 * sin(2 * pi / (nsites) / 2)) # Radius of the circle, using a little trigonometry; it is also the next-nearest neighbor distance, R_max.
pos = [(R * sin(i * 2 * pi / (nsites)), R * cos(i * 2 * pi / (nsites))) for i in 1:nsites] # Positions of each atom
atoms = AtomList(pos); # Define the atom positions as an AtomList.

blockade_radius = sqrt(unit_disk_radius * R);  # R_b = \sqrt{R_min R_max} 

# The system is driven by a constant Rabi drive, 
# which couples each atom's ground and Rydberg state. 
# The Hamiltonian can be defined in Bloqade with:

C6 = 2π * 862690;
Ω = C6 / blockade_radius^6
h = rydberg_h(atoms; Ω = Ω);

# The system is then initialized into the ground state of all atoms, 
# which is the lowest energy of the classical Hamiltonian. 
# We have two choices for the basis: the first choice is the full Hilbert space of ``2^{12}`` states, 
# whereas the second basis is the blockade subspace, 
# which excludes Rydberg excitations within the **subspace radius**, ``R_s``. 
# In principle, the subspace radius can be taken to be any value less than the blockade radius,
# but for better approximation, it is better to take smaller ``R_s``. 
# Typically, ``R_s < R_b / 1.7`` will be a reasonably good approximation,
# since states with Rydberg interaction ``1.7^6 \, \Omega \approx 24 \, \Omega`` will be then truncated, 
# and the perturbative truncation error is typically in second order.
# For ``R_s = 0``, no states are excluded and one recovers the exact dynamics. 
# For a subspace radius anywhere between ``R_\text{min}`` and ``R_\text{max}``, 
# the subspace is the same, as there are no vertices having a separation within those radii. 
# Here, we choose the subspace radius for the ring of atoms to be the unit disk radius, 
# which corresponds to truncating the states having a Rydberg interaction 
# ``>(R_b/R_u)^6 \, \Omega \approx 7.2 \, \Omega``.
# For more general graphs, it may be reasonable to choose the subspace radius to be smaller than the unit disk radius 
# and include extra states to improve the fidelity of the energy truncation. 
# For example, for the next-nearest-neighbor line, it may be reasonable to choose the subspace radius to be half the blockade radius, 
# which includes high-energy NNN blockaded states to improve numerical accuracy.
# See the [Working With Subspace](@ref subspace) page in the manual for more details: 

subspace_radius = unit_disk_radius # R_s

init_state = zero_state(nsites) # Define the initial state in the full space.
space = blockade_subspace(atoms, subspace_radius) # Compute the blockade subspace with R_s.
init_state2 = zero_state(space); # Define the initial state in the blockade subspace.

# The blockade subspace has ``D=322`` basis states, 
# which is much smaller than ``2^{12}``, so the emulation will be much faster. 
# If the atoms were far apart and non-interacting, 
# each atom would oscillate completely between its ground state and Rydberg state with a period of ``\approx 0.5`` μs. 
# However, because adjacent atoms shift to the Rydberg state concurrently, 
# they are dynamically blockaded, causing the maximum Rydberg density to only be ``1/2``, 
# corresponding to an antiferromagnetic ``Z_2`` state. 
# Note that because the ring has a translation symmetry, 
# the Rydberg density is equal on all sites: 

Tmax = 6.0
nsteps = 2001
times = LinRange(0, Tmax, nsteps)
dt = Tmax / (nsteps - 1)

prob = SchrodingerProblem(init_state, Tmax, h, dt = dt, adaptive = false);
integrator = init(prob, Vern8());

densities = [] # Time evolve the system in the full space
for _ in TimeChoiceIterator(integrator, 0.0:dt:Tmax)
    push!(densities, rydberg_density(init_state, 1))
end

prob2 = SchrodingerProblem(init_state2, Tmax, h, dt = dt, adaptive = false);
integrator2 = init(prob2, Vern8());

densities2 = [] # Time evolve the system in the subspace
for _ in TimeChoiceIterator(integrator2, 0.0:dt:Tmax)
    push!(densities2, rydberg_density(init_state2, 1))
end

# Plot the data:
using Bloqade.CairoMakie # Use CairoMakie to generate plots

fig = Figure()
ax = Axis(fig[1, 1], xlabel = "Time (us)", ylabel = "Rydberg density", limits=(0.0, Tmax, 0.0, 0.45))
lines!(ax, times, real(densities), label = "Full space", color=:black)
lines!(ax, times, real(densities2), label = "Subspace", color=:red, linestyle=:dash)
axislegend(ax, position = :rt)
fig

# The inset axis
ax2 = Axis(fig[1, 1],
    width=Relative(0.2),
    height=Relative(0.3),
    halign=0.9,
    valign=0.1,
    limits=(0.0, 0.5, -0.001, 0.003),
    ylabel="Difference",
    yticks=LinRange(-0.001, 0.003, 5),
    xticks=[0, 0.2, 0.4, 0.6],
    backgroundcolor=:lightgray)

lines!(ax2, times, real(densities - densities2), color = :black)
fig;

# ![RydbergBlockadeSubspace](../../../assets/RydbergBlockadeSubspace.png)

# Data for this evolution is shown above, 
# where exact evolution in the full space is shown by the black line, 
# and the truncated evolution in the subspace is shown by the red dashed line. 
# It is clear that even though the Hilbert space is 12 times smaller, 
# the dynamics are faithfully reproduced, 
# up to high frequency oscillations (inset) from adjacent atoms in the Rydberg state, 
# similar to the high frequency oscillations of the 2-atom conditional blockade example above. 
# However, at longer times, this subspace approximation fails to reproduce the full space (shown by divergence between the black and red dashed lines), 
# as the perturbative effects become relevant over longer timescales.

# # [Simulating Noise](@id blockade)

# ## Background
#
# ### The Lindblad master equation
# Open quantum systems in the limit of ultraweak coupling to a Markovian bath can be modelled using the Lindblad master equation:
# ```math
# \frac{\partial \rho}{\partial t} = i[\rho, \mathcal H_{eff}] + \sum_{k}\gamma_k L_k\rho L_k^\dagger
# ``
# where `` \mathcal H_{eff}`` is the effective Hamiltonian, `` L_k`` are the quantum jump operators, and `` \gamma_k`` are the jump rates. The jump operators describe the coupling to the bath, and they are without loss of generality taken to be traceless. The effective Hamiltonian is non-Hermitian and is related to the closed-system Hamiltonian ``\mathcal H`` via ``\mathcal H_{eff} = \mathcal H-\frac{i}{2}\sum_{k}\gamma_k L_k^\dagger L_k``. 
#
# ### Stochastic wavefunction method
# The infinitesimal form of this channel can be put into Kraus map form as
# ```math
# \rho(t+dt) = (1-i dt \mathcal H_{eff})\rho(t) (1+i dt \mathcal H_{eff}) + dt\sum_{k}\gamma_k L_k \rho(t) L_k^\dagger
# ``
# This corresponds to a quantum jump `` L_k`` with probability `` dp_k = dt\gamma_k\operatorname{Tr}(L_k \rho L_k^\dagger)``. If `` \rho = |\psi\rangle\langle \psi|``is a (normalized) pure state, then 
# `` dp_k = dt \gamma_k \Vert L_k|\psi\rangle\Vert^2``, the norm of the state after undergoing the quantum jump. With probability `` 1-dp`` where `` dp = \sum_k dp_k`` is the total probability of experencing a quantum jump, the system evolves to ``(1-i dt \mathcal H_{eff})\rho (1+i dt \mathcal H_{eff}) \approx \rho + i dt[\rho, \mathcal H_{eff}]``. This corresponds to the normal Liouville-Von Neumann equation with the non-Hermitian effective Hamiltonian ``\mathcal H_{eff}``. The physical interpretation of this is that an absence of a quantum jump also has an affect on the system evolution.
#
# These dynamics can be modeled stochastically by chopping the evolution into small intervals `` dt``. At each time step, the state `` |\psi\rangle`` evolves to `` \frac{1}{\mathcal N}(1-idt\mathcal H_{eff})|\psi \rangle``
# with probability ``1-dp`` and evolves to ``\frac{1}{\mathcal N}L_k |\psi \rangle`` with probability ``dp_k``, where ``\frac{1}{\mathcal N}``  is the appropriate normalization. Performing this stochastic evolution results in a single trajectory consisting of a number of random quantum jumps at random times. Averaging over ``j \in \{1,...,m\}`` trajectories results in an ensemble of state ``|\psi_j(t)\rangle``, and averaging ``|\psi_j\rangle\langle\psi_j|`` over these trajectories converges to the density matrix ``\rho`` produced by the master equation in the limit as ``m\to \infty``.
#
# ### Stochastic wavefunction algorithm
# In practice, directly simulating the stochastic process described above is computationally inefficient. Noticing that 
# ```math
# \Vert(1-idt\mathcal H_{eff})|\psi \rangle\Vert^2 = 1 - dt\sum_k \gamma_k\langle \psi| L_k^\dagger L_k |\psi\rangle = 1 - dp \ ,
# ```
# the change in the wavefunction norm over an interval of coherent evolution is related to the accumulation of probability `` p`` of experiencing a quantum jump. The result is the following algorithm:
# 1. Choose a random number `` r``
# 2. Evolve according to `` \frac{\partial}{\partial t}|\psi\rangle = -i\mathcal H_{eff}|\psi\rangle`` without normalizing the state
# 3. When `` \Vert |\psi\rangle \Vert^2 = r``, trigger a quantum jump `` k`` according to the distribution `` p_k \equiv dp_k/\sum_k dp_k`` and normalize
#
# ### Further reading
# For a more in-depth description of the algorithm, please refer to refs. [1,2].

using BloqadeNoisy

using Bloqade
using Yao
using CSV
using DataFrames
using JSON
using LinearAlgebra
using Bloqade.CairoMakie
using StatsBase
using Printf
using ProgressBars


# ## Noisy Single-Qubit Rabi Oscillations

# ### Solution to the master equation
# First, we observe the effect that incoherent depolarizing noise has on the Rabi oscillations of a single qubit. A depolarizing channel is modelled by collapse operators
# ``X, Y, `` and `` Z`` which occur with the a uniform rate ``\gamma``, as expressed in the following master equation
# ```math
# \rho(t+dt) = (1-idt\mathcal H)\rho(t)(1+idt H) + dt\gamma (X \rho(t) X + Y \rho(t) Y + Z \rho(t) Z-3\rho(t))
# ```
# Using the identity `` 2I = \rho + X\rho X + Y\rho Y + Z \rho Z`` for arbitrary `` \rho``, we can write
# ```math
# \rho(t+dt) = (1-idt\mathcal H') \rho(t) (1+idt \mathcal H') + 4\gamma dt\frac{I}{2}
# ```
# where ``\mathcal H' = \mathcal H - 4i\gamma``. This corresponds to ``\rho`` undergoing coherent evolution according to
# ``\mathcal H'`` with probability `` 1-4\gamma dt`` and being replaced with the completely mixed state 
# with probability `` 4\gamma dt``. Since all trace-preserving quantum channels stabilize the maximally mixed state, 
# the evolution can be modeled as a continuous-time Markov chain transitioning between coherent evolution
# ``|\psi(t)\rangle`` and the mixed state `` \frac{I}{2}`` with probability `` 4\gamma dt p_I(t)``, where `` p_I(t)`` 
# is the probability that the system is already in the mixed state. Integrating this probability over time gives ``p_I(t) = 1-e^{-4\gamma t}``. Therefore we can write down the solution
# ```math
# \rho(t) = e^{-4\gamma t}|\psi(t)\rangle\langle\psi(t)| + (1-e^{-4\gamma t})\frac{I}{2}
# ```math
# Where ``|\psi\rangle`` is evolved via the Schrodinger equation and normalized. Solving the Schrodinger equation for a 
# time-independent `` \mathcal H'`` gives `` |\psi(t)\rangle = e^{-i\mathcal Ht}e^{-4\gamma t}|\psi\rangle``. Normalizing
# this state gets rid of the exponential decay factor, leaving `` |\psi(t)\rangle\rangle = e^{-i\mathcal Ht}|\psi\rangle``, 
# corresponding to coherent evolution by the original Hamiltonian `` \mathcal H``.
#
# Consider the Hamiltonian ``\mathcal H = \frac{\Omega}{2}X`` and an initial state ``|\psi\rangle = |0\rangle``. 
# The time-evolution operator is ``e^{-iXt\Omega/2} = \cos(\frac{\Omega}{2}t) -i\sin(\frac{\Omega}{2}t)X``, 
# and so the state evovles in time to ``|\psi(t)\rangle = \cos(\frac{\Omega}{2}t)|0\rangle - i\sin(\frac{\Omega}{2}t)|1\rangle``.
# The expectation value of the number operator ``\hat n`` is then ``\langle \hat n(t) \rangle_\psi = \sin^2(\frac{\Omega}{2}t)``. 
# Plugging this into the master equation solution, in a noisy channel the evolution is
# ```math
# \langle \hat  n(t) \rangle = e^{-4\gamma t}\langle \hat n(t) \rangle_\psi + (1-e^{-4\gamma t})\frac{1}{2}\operatorname{Tr}(\hat n) = \frac{1}{2} - \frac{1}{2}e^{-4\gamma t}\cos(\Omega t)
# ```
# Like an underdamped harmonic oscillator, the value oscillates around an equilibrium value of ``1/2`` with an envelope that decays 
# exponentially in time.
#
# ### Simulation in Bloqade
# In BloqadeNoisy, the `NoisySchrodingerProblem` plays the same role as the `SchrodingerProblem` in Bloqade, and `emulate_noisy` plays the same role as `emulate!`. The `NoisySchrodingerProblem` is constructed using the following arguments:
# 1. initial state
# 2. list of times to save the solution
# 3. noiseless Hamiltonian
# 4. list of collapse operators. The rate is absorbed into the operators, so ``L_k`` becomes ``\sqrt{\gamma_k}L_k``. 
#
# `emulate` is called with the problem and the number of trajectories. Additional arguments can be a list of operators to take expectation values. Calling `emulate` with `report_error = true` will return a set of estimates of error by computing the standard deviation of the expectation values over the trajectories. Lastly, choices for the `ensemble_algo` argument are `EnsembleSerial()`, `EnsembleThreads()`, or `EnsembleDistributed()` for different levels of parallelization.

Ω = 2π
γ = 0.1

collapse_operator = sqrt(γ) .* mat.([X, Y, Z]) 
e_observable = [mat(Op.n)] #expectation values

h = rydberg_h([(0.0,)]; Ω = Ω)
save_times = LinRange(0, 10, 200)

prob = NoisySchrodingerProblem(
    zero_state(1), 
    save_times, 
    h, 
    collapse_operator
)

sol = emulate_noisy(
    prob, 2000, e_observable;
    ensemble_algo = EnsembleThreads(),
    report_error = true
)

fig = Figure()
ax = Axis(fig[1, 1]; xlabel = "Rabi periods", ylabel = L"\langle \hat{n} \rangle", title="Noisy Rabi Oscillation")
ylims!(ax, 0, 1)
x_plot = lines!(ax,
    save_times,
    sol.expectations[1],
    label = "simulated",
    color=:black
)
band!(ax, save_times, sol.expectations[1] .- sol.twosigma[1], sol.expectations[1] .+ sol.twosigma[1], alpha=0.2, color=:cyan)
plot!(ax,
    save_times,
    1/2 .- 1/2*exp.(-4γ * save_times) .* cos.(Ω * save_times),
    label = "analytic",
    color=:blue
)
axislegend(ax, position = :rt)
fig

# ![BloqadeNoisy]("../../../assets/BloqadeNoisy_tutorial/noisy_depolarizingrabi.png")

# ## Coherent noise in neutral atom simulators
# One of the advantages of neutral atoms is that they couple weakly to their environment. This means that incoherent noise is supressed. A more dominant source of noise is due to imperfect control, which causes fluctuation the Rabi power ``\Omega``, detuning ``\Delta``, and atoms positions ``\vec r_{ij}`` between shots. This is referred to as "coherent" noise because it preserves the coherence over a single shot, but averaging over many shots still produces a mixed state. This noise afffects the system globally and is distinct from noise due to coupling to a bath.
#
# To model this affect, we consider ``\Omega`` distributed according to ``G(\Omega) = \frac{1}{\sqrt{2\pi\sigma^2}}e^{-(\Omega - \bar \Omega)^2/2\sigma^2}``. Let the Hamiltonian again be ``\mathcal H = \frac{\Omega}{2}X``. The noiseless evolution of ``\langle Z \rangle`` is then ``\langle Z(t) \rangle = \cos(\Omega t)``. We then average ``\langle Z \rangle`` over the distribution in ``\Omega``:
# ```math
# \overline{\langle Z \rangle} = \frac{1}{\sqrt{2\pi\sigma^2}}\int_{-\infty}^{\infty}\cos(\Omega t)e^{-(\Omega-\bar\Omega)^2/2\sigma^2} d\Omega = \cos(\bar \Omega t)e^{-2\sigma^2t^2/4}
# ```
# Thus we see where incoherent noise results in an exponential envelope, coherent noise results in a Gaussian envelope. This result holds generally. Combining this with the result from pure depolarizing noise, we obtain an envelope in the form of an exponentially modified Gaussian:
# ```math
# \langle Z(t)\rangle = \cos(\bar \Omega t)e^{-\sigma^2t^2/2 - 4\gamma t}
# ```
#
# ### Implementation in BloqadeNoisy
#
# The stochastic wavefunction method allows for this experimental setting to be modelled by varying the parameters in the Hamiltonian between trajectories. In BloqadeNoisy, this is represented as a method which takes a Hamiltonian and returns another method that can be called to generate random samples. The levels of coherent, incoherent, and readout noise are contained in an `ErrorModel` object, which is constructed using
# 1. A method that takes a number of atoms and returns a confusion matrix
# 2. A method that takes a number of atoms and returns a set of collapse operators
# 3. A method that accepts a Hamiltonian and returns a method to generate random samples

γ = .01
σ = .1 * 2π
Ω = 2π
h = rydberg_h([(0.0,)]; Ω = Ω)
times = LinRange(0,5,400)

em = ErrorModel(
    n->I,
    n->[sqrt(γ) * mat(op) for op in [X, Y, Z]], 
    h->(()->rydberg_h(
        [(0.0,)]; 
        Ω = Ω + σ*randn())
    ) 
)

prob = NoisySchrodingerProblem(zero_state(1), times, h, em)
sim = emulate_noisy(prob, 2000, [mat(Z)]; report_error = true);

fig = Figure()
ax = Axis(fig[1, 1]; xlabel = "Rabi periods", ylabel = L"\langle Z \rangle", title="Coherent noise")
lines!(ax,
    times, sim.expectations[1],
    label = "simulated",
    color=:black
)
band!(ax, times, sim.expectations[1] .- sim.twosigma[1], sim.expectations[1] .+ sim.twosigma[1], alpha=0.2, color=:cyan)
scatter!(ax,
    times, 
    (t->cos(Ω*t)*exp.(-σ^2*t^2/2 - 4γ*t)).(times), 
    label = "analytic"
)
axislegend(ax, position = :rt)
fig

# ![BloqadeNoisy]("../../../assets/BloqadeNoisy_tutorial/noisy_coherentnoise_rabi.png")

# ## Noise on Aquila
# Aquila's noise model was calibrated using experimental data, and the parameters that are modelled are the following:
#
# | Parameter  | Desc. | Default value |
# | ---------- | ----- | ------------- |
# | ``\delta \Omega/\langle \Omega \rangle`` | Relative global Rabi drive fluctation | 0.018 (dim.) |
# | ``\delta \Omega_i / \langle \Omega \rangle`` | Relative local Rabi drive fluctation | 0.008 (dim.) |
# | ``\delta \Delta`` | Global detuning fluctuation | ``0.18 \ (rad / \mu s)`` |
# | ``\delta \Delta_i`` | Global detuning fluctuation | ``0.50 \ (rad / \mu s)`` |
# | ``\delta r_x, \delta r_y`` | Lattice site position uncertainty | ``0.05 \ \mu m`` |
# | ``\tau_{relaxation}`` | Relaxation time | ``100 \ \mu s`` |
# | ``\tau_{dephasing}`` | Dephasing time | ``50 \ \mu s`` |
#
# In addition, the affect of readout noise can also be modelled using BloqadeNoisy. Readout error in neutral atom simulators is highly local, so it can be modeled as a problility ``p_{0 \to 1}`` and ``p_{1 \to 0}`` of confusing ``|0\rangle`` and ``|1 \rangle`` and vice-versa. 
#
#
# | Parameter  | Desc. | Default value |
# | ---------- | ----- | ------------- |
# | ``p_{0 \to 1}`` | Probability of confusing 0 with 1 | 0.01 |
# | ``p_{1 \to 0}`` | Probability of confusing 1 with 0 | 0.08 |
#
# The effect of readout error can be modelled by a confusion matrix of the form ``C = \begin{pmatrix} 1-p_{01} & p_{10} \\ p_{01} & 1-p_{10} \end{pmatrix}^{\otimes N}``. This transforms the output probability distribution from ``p(z)`` to ``\tilde p(z) = \sum_{x} C_{zx}p(x)``, which affects the sampled bitstrings and expectation values of operators estimated from the machine.
#
# ### Using Aquila noise model
# BloqadeNoisy makes Aquila's noise model available to use. It is constructed by calling `Aquila()` and is passed as the fourth argument to `emulate_noisy`.

# ### Experimental validation
# The experimental data used to calibrate the noise model is taken from the Aquila whitepaper [3]. Readout error can be added to expectation values in the computational basis by passing `readout = true` to `emulate`. The operators must be of type `Diagonal`. Below, we show the estimation of a noisy expectation value incorporating the effect of readout error and compare to the experimental whitepaper data.

whitepaper_data = CSV.read(pkgdir(Bloqade, "lib", "BloqadeNoisy", "examples", "whitepaper_comparison", "data", "15MHz_long.csv"), DataFrame; delim = ",", header = false)
times = collect(whitepaper_data[1,:])
data = collect(whitepaper_data[2,:])
save_times = LinRange(0, last(times), 400)

Ω = 15.3
Δ = 0
H = rydberg_h([(0.0,)]; Ω = Ω, Δ = Δ)

prob = NoisySchrodingerProblem(zero_state(1), save_times, H, Aquila())
sim = emulate_noisy(prob, 1000, [mat(Op.n)]; readout_error = true);

fig = Figure()
ax = Axis(fig[1, 1]; xlabel = "Rabi periods", ylabel = L"\langle \hat{n} \rangle", title="Simulation vs Data")
scatterlines!(ax, times, data, marker = :diamond,
    markersize = 4, color = :green, linestyle = :dash,
    label = "Data"
)
plot!(ax, save_times, sim[1], color = :blue, label = "Sim")
axislegend(ax, position = :rt)
fig

# ![BloqadeNoisy]("../../../assets/BloqadeNoisy_tutorial/noisy_whitepapercomparison.png")

# The `Aquila()` method is shorthand for `load_error_model(JSON.parse(AQUILA))`. The `AQUILA` string is a JSON dictionary containing the preconfigured noise model, and this syntax allows the noise model to be modified.

default_error_model = JSON.parse(AQUILA)
dephasing_rate = 1/10
default_error_model["incoherent"]["dephasing rate"] = dephasing_rate

#create error model based on Aquila
new_error_model = load_error_model(default_error_model);

# ### Simulated scar experiment
#
# Many-body scars are product states that have a large overlap with a tower of eigenstates exhibiting atypical properties such as low entanglement. Ref [4] studies the scarring properties of the PXP model, given by the Hamiltonian
# ```math
# \mathcal H_{\text{PXP}} = \sum_{i}P_iXP_i + \mu \sum_{i}\hat n_i
# ```
# where ``P_i = \bigotimes_{\langle j, i \rangle}|0_i\rangle\langle 0_i|``, with ``\langle j, i\rangle`` running over the nearest neighbors of ``i``, and ``\mu`` is the chemical potential. Scarring is observed when states fail to thermalize, i.e. exectation values exhibit long-lived dynamic revivals. The PXP model can be approximately realized in a Rydberg atom array by operating in the blockaded subspace and tuning ``\Delta`` to cancel the mean-field contribution of the next-nearest-neighbor Van der Waals interactions. 
#
# BloqadeNoisy allows for estimation of expectation values at a fixed number of shots to emulate an experimental setting. We can use this to predict what a many-body scar experiment on Aquila would look like. Following [4], we first adiabatically prepare the ground state of the PXP model with a chemical potential ``\mu_i = -0.76`` and then a quench to ``\mu = 1.6``. 

Ω = 2π
C = 862690 * 2π
Rb = (C/Ω)^(1/6)
N = 12

atoms = generate_sites(ChainLattice(), N, scale = .65*Rb)
Δ_NNN = 1/(2N) * sum(
    [ 
        (r=norm(atoms[i] .- atoms[j]);
        r > Rb ? C/r^6 : 0)
        for i in 1:N for j in 1:N
    ]
)

μ_i = -.76 * 2π
μ_f = 1.6 * 2π

t_prep = 2 
t_quench = 2 

Δ_ad = piecewise_linear(clocks = [0, t_prep], values = [-40*2π, Δ_NNN - μ_i])
Δ_quench = piecewise_constant(clocks = [0, t_quench], values = [Δ_NNN - μ_f])
Δ = append(Δ_ad, Δ_quench)

times = LinRange(t_prep, t_prep+t_quench, 200)
H = rydberg_h(atoms; Ω = Ω, Δ = Δ)
ψ = solve(
    SchrodingerProblem(zero_state(N), t_prep+t_quench, H;
        save_on = true, saveat = times, save_start = false
    ),
    DP8()
);

expt_times = LinRange(t_prep, t_prep+t_quench, 70)
prob = NoisySchrodingerProblem(zero_state(N), expt_times, H, Aquila())
@time sim = emulate_noisy(prob, 10, [mat(chain(igate(N)-put(N, i=>Op.n) for i in 1:N))];
    readout_error = true, report_error = true, shots = 1000,
    ensemble_algo = EnsembleThreads()
)

fig = Figure()
ax = Axis(fig[1, 1]; xlabel = L"t (\mu s)", ylabel = L"\langle (1-\hat{n})^{\otimes N}\rangle", title="Many-body scar simulation")
lines!(ax, times, [abs(p[1])^2 for p in ψ.u],
    label = "ideal",
    color = :blue
)
errorbars!(ax, expt_times, sim.expectations[1], 
    sqrt.(sim.shot_error[1].^2 .+ sim.propagated_err[1].^2),
    color = :red
)
scatter!(ax, expt_times, sim.expectations[1], 
    label = "noisy", color = :red,
)
fig

# ![BloqadeNoisy]("../../../assets/BloqadeNoisy_tutorial/noisy_manybodyscar.png")

# ## Manybody Fidelity
# A Haar-random pure state ``|\psi\rangle`` from a Hilbert space with dimension ``D = 2^N`` produces probability amplitudes ``p(z) = |\langle z |\psi\rangle|^2`` that are distributed exponentially according to the Porter-Thomas distribution ``P_1(p) = De^{-Dp}`` in the limit of large ``D``. Haar-random sates are produced by chaotic quantum evolution, which we can achieve by randomly spacing ``N`` atoms and choosing ``\Omega(t)`` to be strong relative to the coupling and vary sufficiently over the interval. Under the influence of noise, the evolution can be desribed by
# ```math
# \rho(t) = F|\psi(t)\rangle \langle \psi(t)| + (1-F(t))\chi
# ```
# where ``\chi`` is a density matrix with ``r(z) = \langle z|\chi|z\rangle`` strongly peaked around ``1/D``, approximately ``P_2(r) = \delta(z-\frac{1}{D})``. The probability ``q(z) = \langle z|\rho|z\rangle`` is thus distributed according to the convolution
# ```math
# P_3(q) = \int_0^{q}\frac{1}{1-F}\delta\left(\frac{z}{1-F}-\frac{1}{D}\right)\frac{1}{F}De^{-D(q-z)/F}dz = \begin{cases}
# 0 & q < (1-F)/D\\
# \frac{D}{F}e^{(1-F)/F}e^{-Dq/F} & \text{otherwise}
# \end{cases}
# ```
# This distribution is the one described in [5].
#
# We consider single-atom depolarizing noise at a rate ``\gamma``, and we take ``F(t)`` to be the probability that no error has occurred after time ``t``. Since there are ``3N`` possible errors ocurring at a rate ``\gamma``, we find ``F(t) = 1-e^{-3N\gamma t}``.
#
# ### Implementation in Bloqade
# First, we set up a Hamiltonian and simulate noiseless evolution:

tend = 10
Ω = Waveform(t-> 2.5*2π*(sin(sqrt(10)*2π*t)+cos(sqrt(2)*2π*t)), tend)
R = (862690/2.5)^(1/6)

N = 10
D = 2^N
atoms = [(R*i+.05*randn(),) for i in 1:N]

h = rydberg_h(atoms; Ω = Ω)

ψ = solve(SchrodingerProblem(zero_state(N), tend, h), DP8()).u[end]

# First, we construct a single-atom depolarizing model on ``N`` qubits. Then, we repeat the simulation with different depolarizing rates. The `emulate` method can take a function of the solution to save. We save two quantities: the probability amplitudes ``|\langle z | \psi \rangle |^2`` and the fidelity ``F = \langle \psi| \rho |\psi \rangle``. 

depol(γ, N) = [sqrt(γ)*mat(put(N, i=>op)) for i in 1:N for op in [X,Y,Z]]
function sim_depol(γ)
    prob = NoisySchrodingerProblem(
        zero_state(N), 
        [0.0,tend], 
        h, 
        depol(γ, N)
    )
    sim = emulate_noisy(prob, 20, 
        sol -> [
            abs.(sol[end]).^2, 
            abs(sol[end]' * ψ)^2
        ];
        ensemble_algo = EnsembleThreads()
    )
    (simulation_series_mean(sim),
        simulation_series_err(sim))
end
depol_strengths = [.002, .004, .006]
p = [sim_depol(γ) for γ in depol_strengths];

# Lastly, we create a histogram of the probability amplitudes from the simulation for each level of depolarizing noise, and compare against the prediction:

colors = [:blue, :green, :purple]

fig = Figure()
ps = 0:1e-4:0.006
ax = Axis(fig[1, 1]; xlabel = L"p", ylabel = L"P(p)", title = "Probability distribution vs noise strength", yscale=log10)
xlims!(ax, 0, .006)
ylims!(ax, 3, 1f4)
stephist!(normalize!(abs2.(ψ), 1), color = :black, label = "γ = 0")
lines!(ax, ps, D .* exp.(-D .* ps), color = :black, linestyle = :dash)

for (p, c, r) in zip(p, colors, depol_strengths)
    F = exp(-r * 3N * tend)
    ps = (1-F)/D:1e-4:0.006
    stephist!(normalize(p[1][1], 1), color = c, label = "γ = $(@sprintf("%.3f", r))")
    lines!(ax, ps, D ./ F .* exp((1-F)/F) .* exp.(-D .* ps ./ F), color = c, linestyle = :dash)
    lines!(ax, [(1-F)/D, (1-F)/D], [0, D/F], color = c, linestyle = :dash)
end
axislegend(ax, position = :rt)
fig

# ![BloqadeNoisy]("../../../assets/BloqadeNoisy_tutorial/noisy_depol_dists.png")

# We can examine three different measures of fidelity: First, we have the actual state fidelity ``F = \langle \psi | \rho |\psi \rangle`` which is saved in the simulation. Next, we have the prediction from the depolarizing model ``F = e^{-3N\gamma t}``. Lastly, there is another quantity called the linear cross-entropy which acts as a proxy for the fidelity with chaotic Hamiltonians. The cross entropy is defined
# ```math
# \text{XEB} = \langle D^2 p(z)q(z) - 1\rangle
# ```
# where ``p(z) = |\langle z | \psi \rangle|^2`` and ``q(z) = \langle z | \rho |z \rangle``. Using the form from above ``\rho = F|\psi\rangle \langle \psi| + (1-F)\chi``, we see that
# ```math
# \langle p(z) q(z) \rangle = F\langle p^2(z)\rangle + (1-F)\langle p(z) r(z) \rangle
# ```
# Using the fact that ``P_1(p) = De^{-Dp}`` and ``P_2(r) = \delta(r-1/N)``, we compute
# ```math
# \langle p^2(z)\rangle  = D\int_0^\infty p^2e^{-Dp}dp = \frac{2}{D^2}
# ```
# and
# ```math
# \langle p(z) r(z) \rangle = D\int_0^\infty\int_0^\infty p\delta(r-\frac{1}{D})e^{-Dp/r}dpdr = \frac{1}{D^2}
# ```
# Substituting these in gives ``\text{XEB} = D^2(2/D^2)F + D^2(1-F)/D^2 - 1 = F``. Thus all three quantities estimate ``F``.

fig = Figure()
ax = Axis(fig[1, 1]; title = "Depolarizing fidelity and cross-entropy", xlabel = L"\gamma", ylabel = "fidelity")
errorbars!(ax, depol_strengths, [p[i][1][2] for i in 1:3], [p[i][2][2] for i in 1:3])
scatter!(ax, depol_strengths, [p[i][1][2] for i in 1:3], label = L"F")
lines!(ax, depol_strengths, exp.(-3N * tend .* depol_strengths), label = L"e^{-3\gamma N T}")
lines!(ax, depol_strengths, [(2^N*sum(p[i][1][1] .* abs.(ψ).^2)-1) for i in 1:3], label = "XEB")
axislegend(ax, position = :rt)
fig

# ![BloqadeNoisy]("../../../assets/BloqadeNoisy_tutorial/noisy_fidelitymeasures.png")

# ## Memory constraints
# When simulating large systems, memory can be an issue. The `NoisySchrodingerProblem` can also be used directly with the `DifferentialEquations` interface to simulate each trajectory manually if more control is required. The `randomize` function reinitializes the trajectory with a new sample from the specified distirbution of Hamiltonian parameters and chooses a random initial condition.

R = (862690/2.5)^(1/6)
atoms = generate_sites(SquareLattice(), 4, 3, scale = .85*R)
N = length(atoms)
tend = 3.0
Ω = 2.5*2π

h = rydberg_h(atoms; Ω = Ω, Δ = 0)

ψ = solve(SchrodingerProblem(zero_state(N), tend, h), DP8()).u;

p = zeros(2^N)
ntraj = 100
prob = NoisySchrodingerProblem(zero_state(N), [tend], h, Aquila())
for i in ProgressBar(1:ntraj)
    sample = randomize(prob)
    int = init(sample, DP8())
    solve!(int)
    p .+= abs2.(int.u)/ntraj
end

fig = Figure()
ax = Axis(fig[1, 1]; xlabel = "state", ylabel = "probability", title = "Memory-constrained simulation")
scatterlines!(ax, 
    [real(ψ[end]' * mat(put(N, i=>Op.n)) * ψ[end]) for i in 1:N],
    marker = :circle, markersize = 6,
    label = "ideal"
    )
scatterlines!(ax, [expectation_value_noisy(Aquila(), p, mat(put(N, i=>Op.n))) for i in 1:N], marker = :rect, markersize = 6, label = "noisy")
ylims!(ax, 0,1)
axislegend(ax, position = :rt)
fig

# ![BloqadeNoisy]("../../../assets/BloqadeNoisy_tutorial/noisy_numberdensity.png")

# ## References & Further Reading
# [1] https://qutip.org/docs/latest/guide/dynamics/dynamics-monte.html
#
# [2] https://lukin.physics.harvard.edu/files/lukin/files/physics_285b_lecture_notes.pdf (Chapter 6)
#
# [3] Wurtz, J. et al. (2023). Aquila: QuEra's 256-qubit neutral-atom quantum computer. arXiv preprint arXiv:2306.11727.
#
# [4] Daniel, Aiden, et al. "Bridging quantum criticality via many-body scarring." Physical Review B 107.23 (2023): 235108.
#
# [5] Boixo, Sergio, et al. "Characterizing quantum supremacy in near-term devices." Nature Physics 14.6 (2018): 595-600.

function find_largest(probs, num)
    if length(probs) ≤ num
        return 1:length(probs)
    end

    perm = sortperm(probs, rev = true)
    indices = perm[1:num]
    return indices
end

"""
    bitstring_hist!(ax, register; nlargest::Int, title="", kw...)

Plot the bitstring histogram.

# Arguments

- `ax`: the axis object from `CairoMakie`.
- `register`: the register to plot.

# Keyword Arguments

- `nlargest`: plot the first `nlargest` bitstrings.
- `title`: title of the plot.
- `kw`: other keyword arguments supported by `CairoMakie.bars!` function.
"""
function bitstring_hist!(ax, r::ArrayReg; nlargest::Int, title = "", kw...)
    ps = probs(r)
    indices = find_largest(ps, nlargest)

    obj = barplot!(ax, 1:length(indices), ps[indices]; kw...)
    return obj
end

function bitstring_hist!(ax, r::SubspaceArrayReg; nlargest::Int, title = "", kw...)
    state = statevec(r)
    probs = abs2.(state)
    indices = find_largest(probs, nlargest)

    obj = barplot!(ax, 1:length(indices), probs[indices]; kw...)
    return obj
end

"""
    bitstring_hist(r; kw...)

Plot the bitstring histogram.

# Arguments

- `register`: the register to plot.

# Keyword Arguments

- `nlargest`: plot the first `nlargest` bitstrings.
- `title`: title of the plot.
- `kw...`: other keyword arguments supported by `CairoMakie.bars!` function.
"""
function bitstring_hist(r; nlargest::Int, kw...)
    fig = CairoMakie.Figure()
    xticks_string = _xticks_string(r, nlargest)
    ax = Axis(fig[1, 1], xlabel="bitstring", ylabel="probability", xticks = (1:length(xticks_string), xticks_string), xticklabelrotation=π/3)

    bitstring_hist!(ax, r; nlargest, kw...)
    return fig
end
function _xticks_string(r::ArrayReg, nlargest::Int)
    ps = probs(r)
    indices = find_largest(ps, nlargest)
    return string.(indices .- 1; base = 2, pad = nqubits(r))
end
function _xticks_string(r::SubspaceArrayReg, nlargest::Int)
    state = statevec(r)
    probs = abs2.(state)
    indices = find_largest(probs, nlargest)
    return string.(space(r).subspace_v[indices]; base = 2, pad = nqubits(r))
end

using Bloqade

# Simulate nonequilibrium dynamics of a 12-site ring of Rydberg atoms.
#  This script generates Figure 2 in the example RydbergBlockade.

# First, define the geometry of the system, a ring of nsites.
nsites = 14;    # number of sites in the chain
distance = 9    # Distance between atoms, in microns

R = distance / (2 * sin(2 * pi / (nsites) / 2))                                       # Radius of the circle, using a little trigonometry
pos = [(R * sin(i * 2 * pi / (nsites)), R * cos(i * 2 * pi / (nsites))) for i in 1:nsites] # Positions of each atom
atoms = BloqadeLattices.AtomList(pos)                                         # Define the atom positions as an AtomList.

# Define the pulse by specifying a maximum omega and delta.
# Note that these parameters are computed using pulser_compare.py
Omega_max = 9.179086064116243
delta_0 = -20.397969031369428
delta_f = 9.179086064116243

# Define the timescales of the pulse
Trise = 2.0
Tramp = 6.0
Tfall = 2.0
total_time = Trise + Tramp + Tfall

# Define the detuning and Rabi fields as a function of time
Δ = piecewise_linear(clocks = [0.0, Trise, Trise + Tramp, total_time], values = [delta_0, delta_0, delta_f, delta_f]);
Ω = piecewise_linear(clocks = [0.0, Trise, Trise + Tramp, total_time], values = [0, Omega_max, Omega_max, 0]);

# Define the Hamiltonian and problem instance
h = rydberg_h(atoms; C = 5420158.53, Δ, Ω)
reg = zero_state(nsites);
problem = SchrodingerProblem(reg, total_time, h);

# Evolve the state to the final state
@time begin
    emulate!(problem)
end

# Compute the wavefunction probabilities to cross-check with pulser and quspin code
probability = abs.(reg.state) .^ 2
for p in reverse(sort(probability, dims = 1))[1:10]
    print(p, '\n')
end

using Test
using Documenter
using Bloqade
using BloqadeExpr
using BloqadeLattices

# doctest(BloqadeExpr; manual=false)
# doctest(BloqadeLattices; manual = false)

if "docstring" in ARGS
    # include("docstrings.jl")
    exit()
end

@testset "observables" begin
    include("observables.jl")
end

@testset "plots" begin
    include("plots.jl")
end

# # Adiabatic Evolution
# ## Background

# In this example, we will show how to use Bloqade to prepare ordered ground states in the Rydberg system. 
# The example is based on the experimental works in a [1D System (H. Bernien et al. (10.1038/nature24622)](https://www.nature.com/articles/nature24622)) and [2D system (S. Ebadi et al. (10.1038/s41586-021-03582-4))](https://www.nature.com/articles/s41586-021-03582-4).
# The Rydberg Hamiltonian can be found in the [Bloqade](@ref) page.

# Due to the strong Rydberg interactions, only one Rydberg excitation is allowed within the blockade radius (see the [Rydberg Blockade](@ref blockade) tutorial). With a positive detuning Δ, more Rydberg excitations 
# are favored (to lower the ground state(s) energy). The interplay of these two mechanisms allows the creation of different ordered states depending on the strength of the blockade radius and the detunings,
# such as the [``Z_N`` ordered states (H. Bernien et al. (10.1038/nature24622))](https://www.nature.com/articles/nature24622) in 1D and the checkerboard phase, the star phase, and a pure quantum phase (the striated phase) in 2D 
# (see the [experiment (S. Ebadi et al. (10.1038/s41586-021-03582-4))](https://www.nature.com/articles/s41586-021-03582-4) and [theory (R. Samajdar et al. (10.1103/PhysRevLett.124.103601))](https://journals.aps.org/prl/abstract/10.1103/PhysRevLett.124.103601) papers).

# Here, we use the Quantum Adiabatic Algorithm (QAA) to prepare these quantum many-body ground states. To do that, we can start with all atoms in the ground state 
# ``| 0 \rangle``, which is the ground state of the many-body Hamiltonian with a large negative detuning ``\Delta``. 
# Then, the Rabi frequency ``\Omega`` is turned on, and the detuning strength is ramped up from a large negative value to positive values. If this process is slow enough, the quantum state of the system stays close to the ground state of the 
# time-dependent Hamiltonian at time ``t``. At the end of this process, we arrive at a target Hamiltonian, and correspondingly, the prepared state is approximately the ground state of the final Hamiltonian.
# A quantum phase transition typically occurs during this process and one can probe the phase transition and critical phenomena by simulating and understanding the quantum dynamics.

# Let's start by importing the required libraries:

using Bloqade
using Bloqade.CairoMakie
using KrylovKit
using SparseArrays

# # Ground State Properties

# We start by probing the ground state properties of the Rydberg Hamiltonian in a 1D system. 
# We will use the 1D chain for simplicity and vary the parameters of the Rydberg Hamiltonian, calculating the corresponding ground state properties.
# Here, we consider a chain with 9 atoms, with each atom separated by a distance of 5.72 μm. 
# Please refer to the [Rydberg Blockade](@ref blockade) tutorial on tips for setting the separation distance for the atoms in preparing different ordered states.
# We can generate the system as follows using the function [`generate_sites`](@ref):

nsites = 9
atoms = generate_sites(ChainLattice(), nsites, scale = 5.72)

# We set the Rabi frequency to be ``Ω = 2π \times 4`` MHz, and study the ground state as a function of the detuning ``Δ``:

Ω = 2π * 4
Δ_step = 30
Δ = LinRange(-2π * 10, 2π * 10, Δ_step);

# The Rydberg density profile can be computed for each value of ``\Delta`` as: 

density_g = zeros(Δ_step, nsites)

for ii in 1:Δ_step
    h_ii = rydberg_h(atoms; Δ = Δ[ii], Ω) # create the Rydberg Hamiltonian
    h_m = mat(h_ii) # convert the Hamiltonian into a matrix
    vals, vecs, info = KrylovKit.eigsolve(h_m, 1, :SR) # find the ground state eigenvalue and eigenvector
    g_state = ArrayReg(vecs[1]) # creates the initial state with all atoms in ``| 0 \rangle`` state

    for jj in 1:nsites
        density_g[ii, jj] = rydberg_density(g_state, jj) # measure the density of Rydberg excitations on each site
    end
end

# To compare, we first plot the density profile when ``\Delta= -2π \times 10`` MHz: 

fig = Figure(size=(800, 320))
ax = Axis(fig[1, 1], xlabel = "Sites", ylabel = "Rydberg density", title = "Density Profile: 1D Chain, Δ = -2π * 10 MHz", xticks = 1:nsites)
barplot!(ax, 1:nsites, density_g[1, :])
fig

# We can see that the Rydberg densities in this case are close to 0 for all sites. In contrast, for ``\Delta= 2π \times 10`` MHz, the density shows a clear ``Z_2`` ordered profile:
fig = Figure(size=(800, 320))
ax = Axis(fig[1, 1], xlabel = "Sites", ylabel = "Rydberg density", title = "Density Profile: 1D Chain, Δ = 2π * 10 MHz", xticks = 1:nsites)
barplot!(ax, 1:nsites, density_g[30, :])
fig

# More generally, we can plot an order parameter as a function of ``\Delta`` to clearly see the onset of phase transition. 
# The order parameter can be defined as the difference of Rydberg densities on even and odd sites: 

order_para = map(1:Δ_step) do ii
    return sum(density_g[ii, 1:2:nsites]) - sum(density_g[ii, 2:2:nsites]) # density on odd sites - density on even sites
end

fig = Figure(size=(800, 320))
ax = Axis(fig[1, 1], xlabel = "Δ/2π (MHz)", ylabel = "Order parameter")
lines!(ax, Δ / (2π), order_para)
fig
# Below, we show that by slowly changing the parameters of the Hamiltonian, we can follow the trajectory of the ground states and adiabatically evolve the atoms from the ground state to the ``Z_2`` 
# ordered state.

# # Preparation of Ordered States in 1D 

# We first specify the adiabatic pulse sequence for the Rabi frequency by using the built-in waveform function [`piecewise_linear`](@ref):
total_time = 3.0;
Ω_max = 2π * 4;
Ω = piecewise_linear(clocks = [0.0, 0.1, 2.1, 2.2, total_time], values = [0.0, Ω_max, Ω_max, 0, 0]);

# The detuning sequence can also be created in a similar way:
U1 = -2π * 10;
U2 = 2π * 10;
Δ = piecewise_linear(clocks = [0.0, 0.6, 2.1, total_time], values = [U1, U1, U2, U2]);

# We plot the two waveforms:
fig = Figure(size=(960, 320))
ax1 = Axis(fig[1, 1], ylabel = "Ω/2π (MHz)")
ax2 = Axis(fig[1, 2], ylabel = "Δ/2π (MHz)")
Bloqade.plot!(ax1, Ω / (2π))
Bloqade.plot!(ax2, Δ / (2π))
fig
# We generate the positions for a 1D atomic chain again: 

nsites = 9
atoms = generate_sites(ChainLattice(), nsites, scale = 5.72)

# Note that just like the previous section, we specify the nearest-neighbor atoms to be separated by 5.72 μm in order to prepare a ``Z_2`` ordered state. 
# With the waveforms and atomic coordinates specified, the time-dependent Hamiltonian can be generated by:

h = rydberg_h(atoms; Δ, Ω)

# We then specify all atoms to initially be in the ground state, and set up the emulation problem by choosing an ODE solver:

reg = zero_state(9);
prob = SchrodingerProblem(reg, total_time, h);
integrator = init(prob, Vern8());

# The default behavior for the integrator is to use adaptive steps. One can use `TimeChoiceIterator` to specify the time points one would like to measure some observables.
# Here, we measure the Rydberg density on each site:

densities = []
for _ in TimeChoiceIterator(integrator, 0.0:1e-3:total_time)
    push!(densities, rydberg_density(reg))
end
D = hcat(densities...)';

fig = Figure(size=(800, 320))
ax = Axis(fig[1, 1], xlabel = "time (μs)", ylabel = "site", xticks=0:0.2:total_time, yticks=(0.5:1:nsites, string.(1:nsites)))
shw = heatmap!(ax, LinRange(0.0, total_time, size(D, 1)), LinRange(0.5, nsites - 0.5, size(D, 2)), real(D))
Colorbar(fig[1, 2], shw, label = "Rydberg density")
fig
# We can also confirm it by plotting the bitstring distribution at the final time step:

bitstring_hist(reg; nlargest = 20)

# To prepare the ``Z_3`` or ``Z_4`` states, we can reduce the separation between nearby atoms to 3.57 μm or 2.87 μm respectively.
# Please refer to the [Rydberg Blockade](@ref blockade) page on how to set the separation distance for preparing the ordered states.

# # Emulation in the Blockade Subspace

# In the above example, we have run the fullspace emulation without truncating the Hilbert space. 
# To speed up the emulation, we can also run it in the blockade subspace, throwing out the configurations of the Hilbert space that violate the blockade constraint.
# See the [Working with Subspace](@ref subspace) section of the manual for more details.
# This can be done by changing the register to a [`SubspaceArrayReg`](@ref) by feeding a subspace object.

# The subspace can be found by looking up the independent sets of the graph constructed by a subspace radius; here we choose the subspace radius to be 5.73 μm:

space = blockade_subspace(atoms, 5.73);

# Then create our register in the subspace:

reg = zero_state(space)

# The rest of the code will be the same as the fullspace case: 

prob = SchrodingerProblem(reg, total_time, h)
emulate!(prob)
bitstring_hist(prob.reg; nlargest = 20)

# # State Preparation in 2D

# Now we show how to prepare a 2D checkerboard phase. Most of the code will be the same as the 1D case, except that we will choose slightly different 
# parameters and specify a square lattice instead of a chain:

nx, ny = 3, 3
nsites = nx * ny
atoms = generate_sites(SquareLattice(), nx, ny, scale = 6.7)

# We create and plot the waveforms in the following manner:
total_time = 2.9
Ω_max = 2π * 4.3
Ω = piecewise_linear(clocks = [0.0, 0.3, 2.6, total_time], values = [0.0, Ω_max, Ω_max, 0]);

U = 2π * 15.0
Δ = piecewise_linear(clocks = [0.0, 0.3, 2.6, total_time], values = [-U, -U, U, U]);

fig = Figure(size=(800, 320))
ax1 = Axis(fig[1, 1], ylabel = "Ω/2π (MHz)")
ax2 = Axis(fig[1, 2], ylabel = "Δ/2π (MHz)")
Bloqade.plot!(ax1, Ω)
Bloqade.plot!(ax2, Δ)
fig

# Then, we use the waveforms and atom positions to create a Hamiltonian and define a time evolution problem:

h = rydberg_h(atoms; Δ, Ω)
reg = zero_state(9);
prob = SchrodingerProblem(reg, total_time, h);
integrator = init(prob, Vern8());

# Again, we can use `TimeChoiceIterator` to specify the time points for measuring some observables:
densities = [];
for _ in TimeChoiceIterator(integrator, 0.0:1e-3:total_time)
    push!(densities, rydberg_density(reg))
end
D = hcat(densities...)'

fig = Figure(size=(800, 320))
ax = Axis(fig[1, 1], xlabel = "time (μs)", ylabel = "site", xticks=0:0.2:total_time, yticks=(0.5:1:nsites, string.(1:nsites)))
shw = heatmap!(ax, LinRange(0.0, total_time, size(D, 1)), LinRange(0.5, nsites - 0.5, size(D, 2)), real(D))
Colorbar(fig[1, 2], shw, label = "Rydberg density")
fig

using Colors, ColorSchemes

"""
    plot(object; kw...)

Plot a given object from Bloqade. The object
can be a lattice object, an [`AtomList`](@ref),
or [`Waveform`](@ref).

!!! tip

    This function is not exported to avoid conflicts
    with other plotting packages, it is recommended to
    always use it as `Bloqade.plot`.
"""
function plot end

function plot! end

export plot_densities

include("waveform.jl")
include("lattices.jl")
include("bitstring_hist.jl")

function plot!(ax, wf::Waveform; kwargs...)
    clocks = sample_clock(wf)
    lines!(ax, clocks, BloqadeWaveforms._rm_err.(sample_values(wf, clocks) ./ (2π)); kwargs...)
    return ax
end

function plot(wf::Waveform; kwargs...)
    fig = CairoMakie.Figure()
    ax = Axis(fig[1, 1]; xlabel="time (μs)", ylabel = "value / 2π (MHz)")
    plot!(ax, wf; kwargs...)
    return fig
end

# # Quantum Monte Carlo Method

# In previous tutorials such as the [Adiabatic Evolution](@ref Adiabatic-Evolution) one, 
# [Exact Diagonalization (ED)](https://en.wikipedia.org/wiki/Exact_diagonalization) was used to produce the results. 
# While ED is numerically exact and works for smaller systems consisting of tens of atoms it scales poorly.
# An alternative method that Bloqade supports is Quantum Monte Carlo (QMC) under the BloqadeQMC module which can scale to hundreds of atoms with the caveat that it is exact up to statistical errors.

# It is worth clarifying that despite the name, QMC is a purely classical method that uses the Monte Carlo (MC) approach towards problems in quantum physics.
# To provide more context, the space we are generating samples from is a Hilbert space of quantum-mechanical configurations. 
# Furthermore, QMC is one of the best established methods in numerically tackling the analytically intractable integrals of quantum many-body physics that are beyond the reach of exact solutions. 

# ## Background
# 
# Typically, the integral or sum in question is the expectation value of some observable $\langle A \rangle_\psi = \sum_j a_j |\langle \psi | \phi_j \rangle |^2$ such as the energy, magnetization etc. 
# The issue we face is the *curse of dimensionality*, meaning the number of terms in this sum grows exponentially in system size. 
# We circumvent this curse by not calculating the whole sum, but instead sampling from the probability distribution given by $|\langle \psi | \phi_j \rangle |^2$, 
# favoring those terms that contribute significantly to the sum, i.e. have large weights $a_j$. 
# While doing so, it is essential that we explore the configuration space ergodically. 
# This means that configurations with a small but non-zero weight should have a chance of being reached, even though this will occur less frequently than for those with large weights. 
#
# While QMC is an umbrella term comprising many different implementations of this same core idea tailored to a specific class of quantum problems,
# BloqadeQMC currently implements the [SSE (Stochastic Series Expansion) by Anders Sandvik](http://physics.bu.edu/~sandvik/research/ssehistory.html), recently adapted for the Rydberg Hamiltonian by [E. Merali et al (10.48550/arXiv.2107.00766)](https://arxiv.org/abs/2107.00766).

# ## Getting Started with BloqadeQMC
# 
# We begin by importing the required libraries:

using BloqadeQMC
using Random

# In addition, we will import some libraries that can be used later to check our QMC against ED results for small system sizes: 

using Bloqade, Bloqade.CairoMakie
using Yao: mat, ArrayReg
using LinearAlgebra
using Measurements
using Measurements: value, uncertainty
using Statistics


# As an initial example, we recreate the hamiltonian for the $\mathbb{Z}_2$ phase in the 1D chain which we saw in the [Adiabatic Evolution](@ref Adiabatic-Evolution) tutorial. 

nsites = 9
atoms = generate_sites(ChainLattice(), nsites, scale = 5.72)

Ω = 2π * 4
Δ = 2π * 10
h = rydberg_h(atoms; Δ, Ω)


# Now we differ from the adiabatic evolution tutorial by passing the hamiltonian to [`rydberg_qmc`](@ref):

h_qmc = rydberg_qmc(h);

# The object h_qmc still contains all the previous information about the lattice geometry as well as the Hamiltonian parameters $\Omega$ and $\Delta$. 
# However, the object now also stores the distribution of weights from which the algorithm will sample. 
# Without going into all the details which can be found in [E. Merali et al (10.48550/arXiv.2107.00766)](https://arxiv.org/abs/2107.00766), 
# we can focus on those key elements of the SSE formalism that you will need to calculate observables from the samples. 
# This requires understanding what is meant by configuration space in the SSE formalism, what samples from that space look like and what their weights are. 

# ## Prelude: Massaging the Partition Function

# Before answering those questions, let us revisit the finite temperature partition function $Z = Tr(e^{-\beta H})$. 
# Indeed, $Z$ is the protagonist in the mathematical formalism of SSE. Massaging it through a few tricks and combinatorics will help us answer the questions and prepare us for 
# the diagram below.
#
# The core idea is the following: Instead of calculating the trace analytically, we can first write out the Taylor series of the exponential:

# ```math
# Z = Tr(e^{-\beta H}) = Tr(\sum_{n=0}^{\infty} \frac{\beta^n}{n!}(-\hat{H})^n)
# ```

# next, we insert the usual identities over a set of basis states $\{\alpha_p\}$, giving:

# ```math
# Z = \sum_{\{\alpha_p\}} \sum_{n=0}^{\infty}\frac{\beta^n}{n!} \prod_{p=1}^n \langle\alpha_{p-1}| -\hat{H} | \alpha_p\rangle
# ```

# Finally, we split the Hamiltonian into a sum of local Hamiltonians where each term acts on only one or two atoms. 
# (For example, the latter includes the Rydberg interaction term.) Formally, we will write $H = - \sum_{t, a} \hat{H}_{t,a}$  where the labels $t$ symbolizes whether the term is diagonal ($t=1$) or off-diagonal ($t=-1$) and $a$ specifies the atoms the term acts on. 
# This leads to the last crucial step in massaging the partition function: We switch the order of the n-fold product and sum. 
# From each copy of the total Hamiltonian, we pick one of the local terms and multiply these in a new n-fold product:

# ```math 
# Z =  \sum_{\{\alpha_p\}} \sum_{n=0}^{\infty} \sum_{S_n} \frac{\beta^n}{n!} \prod_{p=1}^n \langle\alpha_{p-1}| - \hat{H}_{t_p, a_p} | \alpha_p\rangle
# ```

# For further technical details, please refer to Section 2.1 of [E. Merali et al (10.48550/arXiv.2107.00766)](https://arxiv.org/abs/2107.00766)

# Why is this crucial? This procedure of picking local terms produced something we will refer to as an *operator sequence* and denote by $S_n$ with $n$ being the length of this sequence. 
# We investigate what this looks like in the section below.

# ## The SSE Configuration Space
# Let us consider a system consisting of four Rydberg atoms. One state in the SSE configuration space of this system could look like the following:

# ![SSE](../../../assets/QMC_tutorial/SSEconfig.png)

# We define each element of the diagram above as follows:

# * The four circles correspond to four atoms, with filled circles being excited atoms $|r\rangle$ and white circles representing the ground state $|g\rangle$.
# * The blue, red and black boxes situated either on one horizontal line or sitting between two lines stand for the local Hamiltonian terms we mentioned earlier. The interested reader may find the full definition of the local terms in Section 3 of [E. Merali et al (10.48550/arXiv.2107.00766)](https://arxiv.org/abs/2107.00766)
# * The seven copies of four atoms/six boxes are the the visual equivalent of looking at the sixth expansion order in the Taylor series introduced above. Each SSE *sample* will correspond to a particular expansion order $m$ since the infinite Taylor series gave rise to an intractable sum which we can use the core idea of MC to sample from.

# Putting the pieces together, we should be able to understand the general idea of the weight distribution stored in the rydberg_qmc object. 
# That distribution is given by the matrix elements defined by the local operators (boxes) sandwiched in between two configurations of the physical system (two copies of the four vertically stacked atoms). 
# The picture as a whole is what defines one sample in the SSE configuration whose overall weight is given by the product of the matrix elements of each operator.

# It is worth stating at this point that a precise understanding is not necessary to successfully run a simulation using BloqadeQMC. 
# We have included this peek into the backend in order for the reader to have some notion of what we mean when we refer to the *number of operators sampled* in the energy calculations later on
# (equivalent to the number of boxes in the diagram above).

# ## Running a Simulation using BloqadeQMC
# 
# Now that we have defined the configuration space, let us traverse it and generate samples from it. 
# It is worth pointing out that the samples generated are no longer random and independent as they are in traditional MC but rely on Markov Chain Monte Carlo (MCMC). 
# In MCMC, the samples are no longer independent but form a chain in which the probability of the next sample depends on the current sample.

# Before jumping into the code, let us touch on the prototypical example of how such a chain might be built: via the Metropolis-Hastings algorithm. This recipe has three main steps:
# 1) Randomly propose a new configuration, 
# 
# 2) accept the proposal according to a probability given by the ratio of the weights of the current and proposed configuration, 
#
# ```math
# P = min(\frac{W_{current}}{W_{proposed}}, 1)
# ```
# 
# 3) and repeat.

# Now, let us define the parameters than govern the length of the chain, i.e. how long we let the simulation run for:

EQ_MCS = 100;
MCS = 100_000;

# Note that two parameters are required. MCMC simulation is typically split into two phases: first the equilibration phase, also referred to as the *burn-in*, followed by the sampling phase.
# While the mathematical theorems surrounding Markov Chains guarantee under reasonable assumptions these chains eventually converge to the desired probability distribution, 
# it does take some time until this is the case.

# While there is no formula that will tell you when precisely equilibration has been reached, a good heuristic is plotting an observable such as the energy. 
# You will see its value initially fluctuate but stabilize around a value which you can then assume is its equilibrium expectation value.

# ![Equilibration](../../../assets/QMC_tutorial/equilibration.png)

# Now, we are almost ready to run the simulation.
 
M = 50;
ts = BinaryThermalState(h_qmc, M);   
# BinaryThermalState is an object necessary in the backend to store the instantaneous SSE configuration during the MC steps.
d = Diagnostics();                   
# Diagnostics are a feature that can be used by the advanced user to analyse performance and extract further information from the backend.

# Next, we choose the inverse temperature β to be large enough for the simulation to approximate the ground state. 
# If your system is gapped, then a finite value for β will be enough to reach the ground state. If the gap closes, then you will need to scale β with the system size.

β = 0.5;

rng = MersenneTwister(3214);


# Finally, we initialize the pseudorandom number generator. We can now execute the simulation.

# Note that `mc_step_beta!` returns three objects which can be used for computations during each MC step. 
# `ts` stores the instantaneous SSE configuration, `h_qmc` is the same object as before, 
# `lsize` is related to the arrays used to carry out a MC step and depend on the operator sequence of the current configuration. 

# Furthermore, `SSE_slice` stores a sample of the atom configuration taken from the current SSE configuration, in this case chosen to be the first vertical slice.

[mc_step_beta!(rng, ts, h_qmc,β, d, eq=true) for i in 1:EQ_MCS] # equilibration phase

densities_QMC = zeros(nsites)
occs = zeros(MCS, nsites)

for i in 1:MCS # Monte Carlo Steps
    mc_step_beta!(rng, ts, h_qmc,β, d, eq=false) do lsize, ts, h_qmc
        SSE_slice = sample(h_qmc,ts, 1)
        occs[i, :] = ifelse.(SSE_slice .== true, 1.0, 0.0)
    end
end

for jj in 1:nsites
    densities_QMC[jj] = mean(occs[:,jj])
end


# Let us plot the results.

fig = Figure()
ax = Axis(fig[1, 1]; xlabel="Site number", ylabel="Occupation density")
results_plot = barplot!(ax, densities_QMC)
results_plot

# As expected, we see a $\mathbb{Z}_2$ pattern has emerged, just as we saw using the exact diagonalization method. 
# So let us try an example that goes beyond what is feasible with ED. 

# We run the same code as before, substituting the 1D chain with 9 atoms for a 2D square lattice with 100 atoms.

nx = ny = 10;
nsites = nx*ny;
atoms = generate_sites(SquareLattice(), nx, ny, scale = 6.51);

# ![100atoms](../../../assets/QMC_tutorial/Checkerboard_10x10.png)

# ## Calculating Observables using BloqadeQMC

# The final question we will address in this tutorial is how to calculate observables using BloqadeQMC. 
# We will choose to investigate the energy during a detuning sweep. 
# Furthermore, we will limit ourselves to a system size which ED can also handle such that we may compare the results from both methods.
 
# Let us start by returning to the 1D chain and defining the Hamiltonian parameters.
# We will keep the constant Rabi drive from before, i.e. $\Omega = 2\pi \times 4$ MHz. For the detuning, we will choose the following ramp.

nsites = 9;
atoms = generate_sites(ChainLattice(), nsites, scale = 5.72);

Δ_step = 15;
Δ = LinRange(-2π * 9, 2π * 9, Δ_step);


# Now, we only need to make two small changes to our previous MC code.
# First, for each value of $\Delta$ specified in this ramp, we will run a separate QMC simulation that will produce one data point in the final energy plot. 
# Second, we need to store the number of operators contained in each sample. Yes, this is where the picture we introduced earlier comes in. 
# This number will fluctuate from sample to sample as we build the Markov chain. It is directly returned by the `mc_step_beta!()` function.

# We can then use the number of operators to compute the energy due to the following observation. Firstly, we know from statistical physics that:

# ```math
# \langle E \rangle = -\frac{\partial ln Z}{\partial \beta}
# ```

# Yet in the SSE formalism we can find another expression for the expectation value $\langle E \rangle$. Let us work backwards and consider the SSE expectation value of the length of the operator sequence:
# ```math
# \begin{aligned}
# \langle n \rangle &= \frac{1}{Z} Tr(\sum_{n=0}^\infty n \frac{(-\beta \hat{H})^n}{n!}) \\
#                   &= \frac{1}{Z} Tr(\sum_{n=1}^\infty n \frac{(-\beta \hat{H})^n}{n!}) \\
#                   &= \frac{1}{Z} Tr(\sum_{n=1}^\infty \frac{(-\beta \hat{H})^n}{(n-1)!}) \\
#                   &= \frac{1}{Z} Tr(\sum_{n=0}^\infty (-\beta \hat{H}) * \frac{(-\beta \hat{H})^n}{n!})
# \end{aligned}
# ```

# where in the second line we dropped the vanishing $n=0$ term and in the fourth line we shifted the sum over n by 1 and obtained the extra factor $-\beta \hat{H}$. From this, we directly read of the SSE formula for the energy expectation value:
# ```math
# \langle E \rangle = -\frac{\langle n \rangle}{\beta}
# ```

using BinningAnalysis

energy_QMC = []

for ii in 1:Δ_step
    h_ii = rydberg_h(atoms; Δ = Δ[ii], Ω)
    h_ii_qmc = rydberg_qmc(h_ii)
    ts_ii = BinaryThermalState(h_ii_qmc,M)
    d_ii = Diagnostics()

    [mc_step_beta!(rng, ts_ii, h_ii_qmc, β, d_ii, eq=true) for i in 1:EQ_MCS] #equilibration phase
    
    ns = zeros(MCS)

    for i in 1:MCS # Monte Carlo Steps
        ns[i] = mc_step_beta!(rng, ts_ii, h_ii_qmc, β, d_ii, eq=false)
    end

    energy(x) = -x / β + h_ii_qmc.energy_shift  # The energy shift here ensures that all matrix elements are non-negative. See Merali et al for details.
    BE = LogBinner(energy.(ns)) # Binning analysis
    τ_energy = tau(BE)
    ratio = 2 * τ_energy + 1
    energy_binned = measurement(mean(BE), std_error(BE)*sqrt(ratio)) 
    append!(energy_QMC, energy_binned)
end

# There is one last point worth addressing when calculating expectation values using a MCMC method. 
# As mentioned previously, the samples are not statistically independent, instead they are correlated due to the Markov Chain property.
# This point is crucial. After all, Monte Carlo is exact only in a statistical sense. We must construct error bars around the mean values generated by our simulation.
# The correlation of samples has the effect of reducing the effective variance, thus purporting an accuracy we cannot in fact justify. 

# One method of addressing this issue is via binning analysis. 
# The idea is to bin small sequences of samples together and average over them. 
# This gives rise to an reduced effective sample size given by:

# ```math
# N_{eff} = \frac{N_{orig}}{2\tau + 1}$ 
# ```
# where $\tau$ is the autocorrelation time.

# We use this effective sample size to rescale the standard error by $\sqrt{2\tau + 1}$. 
# For details, please see the documentation of the [BinningAnalysis](https://github.com/carstenbauer/BinningAnalysis.jl) package. 
# If the error bars thus achieved are still too large, increasing the number of samples taken, i.e. the number of Monte Carlo steps can help alleviate the problem.

# Finally, let us carry out the ED calculation as well and plot both results together.

energy_ED = zeros(Δ_step)

for ii in 1:Δ_step
    h_ii = rydberg_h(atoms; Δ = Δ[ii], Ω)
    h_m = Matrix(mat(h_ii)) 
    energies, vecs = LinearAlgebra.eigen(h_m) 

    w = exp.(-β .* (energies .- energies[1]))
    energy_ED[ii] = sum(w .* energies) / sum(w)
end

fig = Figure()
ax = Axis(fig[1, 1]; xlabel="Δ/2π", ylabel="Energy")
scatter!(ax, Δ/2π, energy_ED, label="ED", marker=:x);
errorbars!(ax, Δ/2π, value.(energy_QMC), uncertainty.(energy_QMC))
scatter!(ax, Δ/2π, value.(energy_QMC); label="QMC", marker=:x)
axislegend(ax, position=:rt)
fig

# We see that using the QMC, we have achieved the same results as for the ED with high accuracy.

# As a final note, it is possible to also calculate other observables in the SSE formalism if they are products of the operators present in the Hamiltonian itself. 
# For example, to calculate $\langle X \rangle$, one would count the number of times the off-diagonal operator $\sigma_x$ appears in each sample and take its average. 
# For more examples and derivations, please see [A. Sandvik (10.1088/0305-4470/25/13/017)](https://iopscience.iop.org/article/10.1088/0305-4470/25/13/017/pdf)*

# To conclude this tutorial, we will leave with one final plot of the staggered magnetization which acts as an order parameter 
# to observe the transition from the disordered to the $\mathbb{Z}_2$ phase achieved before:

densities_QMC = []
order_param_QMC = []

for ii in 1:Δ_step
    h_ii = rydberg_h(atoms; Δ = Δ[ii], Ω)
    h_ii_qmc = rydberg_qmc(h_ii)
    ts_ii = BinaryThermalState(h_ii_qmc,M)
    d_ii = Diagnostics()

    [mc_step_beta!(rng, ts_ii, h_ii_qmc, β, d_ii, eq=true) for i in 1:EQ_MCS] #equilibration phase
    
    order_param = zeros(MCS)

    for i in 1:MCS # Monte Carlo Steps
        mc_step_beta!(rng, ts_ii, h_ii_qmc, β, d_ii, eq=false) do lsize, ts_ii, h_ii_qmc
            SSE_slice = sample(h_ii_qmc, ts_ii, 1) # occ = 0,1
            spin = 2 .* SSE_slice .- 1 # spin = -1, 1
            order_param[i] = abs(sum(spin[1:2:end]) - sum(spin[2:2:end]))/length(spin)
        end
    end

    BD = LogBinner(order_param)
    τ_energy = tau(BD)
    ratio = 2 * τ_energy + 1
    energy_binned = measurement(mean(BD), std_error(BD)*sqrt(ratio)) 
    append!(order_param_QMC, measurement(mean(BD), std_error(BD)*sqrt(ratio)) )
end

fig = Figure()
ax = Axis(fig[1, 1]; xlabel="Δ/2π", ylabel="Stag mag")
errorbars!(ax, Δ/2π, value.(order_param_QMC), uncertainty.(order_param_QMC))
fig_order = scatter!(ax, Δ/2π, value.(order_param_QMC); label="", marker=:x)
axislegend(ax, position=:rt)
fig

# # Maximum Weight Independent Set
# ## Background
# In the [The Maximum Independent Set Problem](@ref mis-tutorial) tutorial, 
# we provide a detailed example on how to solve the Maximum Independent Set (MIS) problem
# using neutral-atom quantum computers. 
# The first algorithm proposal and experimental demonstration can be found in 
# [H. Pichler et al. (10.48550/arXiv.1808.10816)](https://arxiv.org/pdf/1808.10816.pdf) and [S. Ebadi et al. (10.48550/arXiv.2202.09372)](https://arxiv.org/abs/2202.09372).
# In this tutorial, we present a more advanced example of using neutral atom quantum computers
# to solve the [Maximum Weight Independent Set](https://en.wikipedia.org/wiki/Independent_set_(graph_theory)) (MWIS) problem 
# on a weighted unit disk graph, with arbitrary weights for each vertex. The MWIS problem 
# seeks to find an independent set whose weights sum to the maximum possible value.

# We first import the required packages to compute MWIS classically:
using Random
Random.seed!(42)
using Graphs
using GenericTensorNetworks
using GenericTensorNetworks: unit_disk_graph
using Bloqade, Bloqade.CairoMakie

# We now specify the atom locations and construct an example  
# unit disk graph on a square lattice with nearest-neighbor connections. 
# The atoms represent vertices on the problem graph, 
# and all vertices closer than a distance 1.5 are connected by an edge:
locs = [(1, -1), (4, 0), (1, 1), (2, 0), (0, 0), (2, 2), (2, -2), (3, 1), (3, -1)];
g = unit_disk_graph(locs, 1.5)
show_graph(g, map(x->60 .* x, locs); vertex_colors = ["white" for i in 1:nv(g)])

# We then assign random weights to each vertex for this example problem:
weights = [rand() for i in 1:nv(g)];

# We can solve the MWIS problem classically for this graph
# using the [GenericTensorNetworks](https://github.com/QuEraComputing/GenericTensorNetworks.jl) package. 
# The MWIS is shown in red.
wmis_problem = IndependentSet(g, weights)
configs_mapped = GenericTensorNetworks.solve(GenericTensorNetwork(wmis_problem), ConfigsMax())[]
MIS_config = configs_mapped.c[1]
show_graph(g, map(x->60 .* x, locs), vertex_colors = [iszero(MIS_config[i]) ? "white" : "red" for i in 1:nv(g)])

# # Quantum Adiabatic Algorithm to Solve the MWIS Problem

# The quantum adiabatic algorithm (QAA) can be performed with the Hamiltonian:

# $H_{\text{QA}}(t) = \sum_{v \in V} (- \Delta_v(t) n_v + \frac{\Omega_v(t)}{2} \sigma_v^x) + \sum_{(u, w) \in E} U_{u,w} n_u n_w$

# Here, we work in the limit of $\Delta, \Omega \ll U$, where 
# the non-independent set space of the graph can be neglected 
# (on neutral-atom quantum hardware, this corresponds 
# to the limit where the interaction energy is much stronger than other energy scales). 
# In this limit, we can restrict ourselves to the Rydberg blockade subspace (see the [Rydberg Blockade](@ref blockade) tutorial) of the graph 
# and ignore the interaction term $\sum_{(u, w) \in E} U n_u n_w$ in the Hamiltonian. 
# Note that in this tutorial, we also do not include the long-range interaction tail in the Hamiltonian. 
# The vertex weights of the MWIS problem in this Hamiltonian can be implemented on the hardware 
# with individual atom detunings (specifying $\Delta_v(t)$ for each atom).

# The QAA can be designed by first initializing all qubits to the ground state of 
# $H_{\text{QA}}(t = 0)$ where $\Delta(t = 0) = -\Delta_0 < 0 $ and $\Omega(t = 0) = 0$; 
# the many-body ground state is basically with all atoms in the ground state ``| g \rangle ``.
# We then change the parameters by turning up $\Omega(t)$ to a finite value and then to 0, 
# and sweeping $\Delta(t)$ to $\Delta_0 > 0$ after some final time $t_f$.  

# By the adiabatic theorem, when the time evolution is sufficiently slow, 
# the system should follow the instantaneous ground state and end up in the 
# solution to the MWIS problem.  

# ## Building Pulse Sequences
# Since we are considering the MWIS problem, we can implement individual
# atom detuning with $\Delta(t)_i = w_i \times \Delta(t)$.  

# Let's first build and plot the individual pulse waveforms.
# We use the following function to build the Hamiltonian and the corresponding waveforms for the adiabatic evolution of the system:
function build_adiabatic_sweep(graph, Ω_max::Float64, Δ_max::Float64, t_max::Float64, weights::Vector{Float64})
    Ω = Waveform(t -> Ω_max * sin(pi * t / t_max)^2, duration = t_max)
    Δ = map(1:nv(graph)) do idx
        return Waveform(t -> weights[idx] * Δ_max * (2 * t / t_max - 1), duration = t_max)
    end
    h = SumOfX(nv(graph), Ω) / 2 - SumOfN(nv(graph), Δ)
    return h, Ω, Δ
end

# Here, we choose $\Delta_{\max} / \Omega_{\max} = 3$, with $\Omega_{\max} = 2 \pi \times 4$ MHz:
Ω_max = 2π * 4
Δ_max = 3 * Ω_max
t_max = 1.5
H, Ω, Δ = build_adiabatic_sweep(g, Ω_max, Δ_max, t_max, weights);

fig = Figure(; size=(700, 200))
ax1 = Axis(fig[1, 1]; ylabel = "Ω/2π (MHz)")
ax2 = Axis(fig[1, 2]; ylabel = "Δ/2π (MHz)")
Bloqade.plot!(ax1, Ω)
for i in 1:nv(g)
    Bloqade.plot!(ax2, Δ[i])
end
fig

# ## Compute the MIS Probability and the Adiabatic Timescale

# Here we compute the MWIS probability of the graph as a function of time. 
# In addition, we would like to extract the adiabatic timescale $T_{\text{LZ}}$ from the Landau-Zener fitting: 
# $1 - P_{\text{MWIS}} = e^{a - T/T_{\text{LZ}}}$. 
# To do this, we find the first instance time $T^*$
# such that $P_{\text{MWIS}}(T) > 0.9$, and 
# then continue to run evolutions to $2.5T^*$ to extract $T_{\text{LZ}}$. 
# See [H. Pichler et al. (10.48550/arXiv.1808.10816)](https://arxiv.org/pdf/1808.10816.pdf) 
# for more details on the procedure to extract the Landau-Zener timescale.

# We run the simulation in the blockade (independent set) subspace:
t_list = []
P_MWIS = [] # MIS probability 
subspace = independent_set_subspace(g);

total_time = 1.5
for t in 0.1:total_time*0.25:total_time*2.5
    h = build_adiabatic_sweep(g, Ω_max, Δ_max, t, weights)[1]
    r = zero_state(subspace)
    prob = SchrodingerProblem(r, t, h)
    emulate!(prob)
    p = config_probability(prob.reg, g, BitVector(MIS_config))

    push!(t_list, t)
    push!(P_MWIS, p)
end

# We can compute the adiabatic timescale by fitting a Landau-Zener curve to the 
# MIS probability: 
using CurveFit
y = broadcast(log, 1 .- P_MWIS[P_MWIS.>0.9])
a, b = linear_fit(t_list[P_MWIS.>0.9], y)
T_LZ = -1 / b;

# Finally, we plot the results:
fig = Figure(; size=(800, 300))
ax1 = Axis(fig[1, 1]; ylabel = "MWIS Probability", xlabel = "Time (μs)")
ax2 = Axis(fig[1, 2]; ylabel = "log(1 - MWIS Probability)", xlabel = "Time (μs)")

scatter!(ax1, t_list, P_MWIS)
scatter!(ax2, t_list, broadcast(log, 1 .- P_MWIS))
lines!(ax2, t_list, a .+ b .* t_list)

fig

function plot(atoms::AtomList; kw...)
    return BloqadeLattices.img_atoms(atoms; kw...)
end

"""
    plot_densities(atoms::AtomList, densities::AbstractVector; color_scheme=ColorSchemes.bwr)

Given `atoms` which contains the coordinates for the atoms and a vector containing the Rydberg densities,
plot the Rydberg densities over the atoms.
"""
function plot_densities(atoms::AtomList, densities::AbstractVector; color_scheme=ColorSchemes.bwr)
    length(atoms) == length(densities) || throw(ArgumentError("The number of atoms is not equal to the number of Rydberg density values."))
    plot(atoms, colors = "#" .* hex.(get(color_scheme, densities, :clamp)))
end

"""
    rydberg_density(reg, i::Int) -> Real

Calculates the rydberg density at site `i`.

```math
\\langle n_i \\rangle
```
"""
rydberg_density(reg, i::Int) = real(expect(put(nqubits(reg), i => Op.n), reg))

"""
    rydberg_density(reg) -> Vector

Return the rydberg density at each site.
"""
rydberg_density(reg) = [rydberg_density(reg, i) for i in 1:nqubits(reg)]

"""
    rydberg_corr([op=Op.n], reg) -> Matrix

Calculates the rydberg correlation matrix.

```math
\\langle \\text{op}_i \\text{op}_j \\rangle
```

here `op` can be `Op.n`, `X` or `Y`.

# Arguments

- `op`: the correlation function, default is `Op.n`.
- `reg`: required, the register object.
"""
rydberg_corr(reg) = rydberg_corr(Op.n, reg)

function rydberg_corr(op, reg)
    return [expect(chain(nqubits(reg), put(i => op), put(j => op)), reg) for i in 1:nqubits(reg), j in 1:nqubits(reg)]
end


"""
    get_average_rydberg_densities(atoms, reg; [C=2π * 862690 * MHz*µm^6], Ω[, ϕ, Δ], [dt=1e-3 * μs])

Return average Rydberg densities throughout an evolution.

# Arguments

- `atoms`: a collection of atom positions.
- `reg`: required, the register object.

# Keyword Arguments

- `C`: optional, default unit is `MHz*µm^6`, interation parameter,
    see also [`RydInteract`](@ref).
- `Ω`: optional, default unit is `MHz`, Rabi frequencies, divided by 2, see also [`SumOfX`](@ref).
- `ϕ`: optional, does not have unit, the phase, see [`SumOfXPhase`](@ref).
- `Δ`: optional, default unit is `MHz`, detuning parameter, see [`SumOfN`](@ref).
- `dt`: optional, default unit is `μs`, time step for the evolution.
- `solver`: optional, default solver is `Vern8()`, the solver for the SchrodingerProblem, see [`SchrodingerProblem`](@ref).
"""
function get_average_rydberg_densities(atoms, reg::AbstractRegister; C::Real = 2π * 862690, Ω = nothing, ϕ = nothing, Δ = nothing, dt::Real=1e-3, solver = Vern8())
    if isnothing(Ω) && isnothing(ϕ) && isnothing(Δ)
        error("At least one of Ω, ϕ or Δ is needed for determining the duration of the evolution.")
    end

    # To get the duration of the evolution, first we collect all the waveforms
    allwaveforms = [Ω, ϕ, Δ] 
    allwaveforms = allwaveforms[allwaveforms.!=nothing] # Get rid of the non-specified (Ω, ϕ, Δ)
    allwaveforms = reduce(vcat, allwaveforms) # We flatten the list such that `allwaveforms` is a list of nonzero waveforms 
    allwaveforms = isa(allwaveforms, Waveform) ? [allwaveforms] : allwaveforms

    # The duration of the evolution is well-defined if and only if the durations of all waveforms are the same
    duration = allwaveforms[1].duration
    for i = 2 : length(allwaveforms)
        if allwaveforms[i].duration != duration
            error("The durations of waveforms are not consistent.") 
        end
    end

    # Start the evolution 
    h = rydberg_h(atoms, C=C, Δ=Δ, Ω=Ω, ϕ=ϕ)
    prob = SchrodingerProblem(reg, duration, h, progress=true);
    integrator = init(prob, solver);
    densities = []
    for _ in TimeChoiceIterator(integrator, 0.0:dt:duration)
        normalize!(reg) 
        push!(densities, rydberg_density(reg)) 
    end

    return densities
end

using PythonCall: pysysmodule, pyosmodule

const pybloqade_module = PythonCall.pynew()

function init_bloqade()
    jl = pybloqade_module
    sys = pysysmodule
    os = pyosmodule
    if C.CTX.is_embedded
        # in this case, Julia is being embedded into Python by juliacall, which already exists
        pycopy!(jl, sys.modules["bloqade"])
    end
end

if ccall(:jl_generating_output, Cint, ()) == 1   # if we're precompiling the package
    let
        nsites = 4
        atoms = generate_sites(ChainLattice(), nsites, scale = 5.72)
        total_time = 3.0
        Ω_max = 2π * 4
        Ω = piecewise_linear(clocks = [0.0, 0.1, 2.1, 2.2, total_time], values = [0.0, Ω_max, Ω_max, 0, 0])
        # The detuning sequence can also be created in a similar way.
        U1 = -2π * 10
        U2 = 2π * 10
        Δ = piecewise_linear(clocks = [0.0, 0.6, 2.1, total_time], values = [U1, U1, U2, U2])
        show(devnull, MIME"text/plain"(), Δ)
        h = rydberg_h(atoms; Δ, Ω)
        show(devnull, MIME"text/plain"(), h)
        reg = zero_state(nsites)
        prob = SchrodingerProblem(reg, total_time, h)
        show(devnull, MIME"text/plain"(), prob)
        emulate!(prob)
    end
end

module Bloqade

using Reexport


@reexport using Yao
@reexport using BloqadeMIS
@reexport using BloqadeODE
@reexport using BloqadeExpr
@reexport using BloqadeKrylov
@reexport using YaoSubspaceArrayReg
@reexport using BloqadeWaveforms

# partially reexport
@reexport using Measurements: ±, Measurement
@reexport using BloqadeLattices:
    BloqadeLattices,
    AbstractLattice,
    GeneralLattice,
    HoneycombLattice,
    SquareLattice,
    TriangularLattice,
    ChainLattice,
    LiebLattice,
    KagomeLattice,
    GeneralLattice,
    RectangularLattice,
    AtomList,
    # interfaces
    generate_sites,
    offset_axes,
    rescale_axes,
    MaskedGrid,
    make_grid,
    random_dropout,
    clip_axes,
    lattice_sites,
    lattice_vectors,
    make_kdtree,
    grouped_nearest,
    collect_atoms

export rydberg_density, rydberg_corr, bitstring_hist, bitstring_hist!, get_average_rydberg_densities

using CairoMakie
using Colors, ColorSchemes

include("plots/plots.jl")
include("observables.jl")
include("precompile.jl")

end

# [CPU Acceleration] (@id multithreading)

Bloqade has multithreading-support built-in for faster simulation on multi-core CPUs.

## Backends

This is accomplished through separate Sparse-Matrix dense-Vector (SpMV) *backends* that a user can explicitly choose from to further fine-tune performance. These backends target the CSC format Sparse Matrices that are generated for simulation from Hamiltonian problems. Bloqade also uses other Sparse Matrix formats as well to maximize memory efficiency but with any backend that performs multithreading, the same parallelized functions will be used.

There are three backends to select from:

* `BloqadeExpr` - the default that Bloqade starts with on first installation. Even if you start Julia with multiple threads, when Bloqade has this backend it *will not perform any multithreading*.
* `ThreadedSparseCSR` - Converts CSC matrices to CSR format and uses a simple nested for-loop to perform the SpMV multiplication. The code for this was taken from the [`ThreadedSparseCSR`](https://github.com/BacAmorim/ThreadedSparseCSR.jl) package and migrated into Bloqade to use a more up-to-date version of the [`Polyester`](https://github.com/JuliaSIMD/Polyester.jl) multithreading library, hence the name.
* `ParallelMergeCSR` - Takes the conjugate transpose (adjoint) of CSC matrices and uses QuEra's [`ParallelMergeCSR`](https://github.com/QuEraComputing/ParallelMergeCSR.jl) SpMV package.

!!! compat "Limited Compatibility for ParallelMergeCSR"

    ParallelMergeCSR is currently a *Linux-only* package and may be unreliable/fail to run on other operating systems. You will still be able to take advantage of multithreading through the `ThreadedSparseCSR` backend.

`ThreadedSparseCSR` is ideal for smaller system sizes or if you are performing simulations with the full Hilbert space (in which case the Hamiltonian matrix has a rather even distribution of non-zero elements per row).

`ParallelMergeCSR` is ideal for very large system sizes or if you are performing simulations using the Blockade [subspace](@ref subspace) where the imbalance in the number of non-zero entries per row may be larger than if a full Hilbert space simulation was performed. `ParallelMergeCSR` performs some calculations before the actual matrix-vector multiplication occurs to find the ideal distribution of work across multiple threads which means for smaller system sizes more benefit might be obtained through `ThreadedSparseCSR`.

## Using Multithreading

To enabled multithreading you will need to first import `BloqadeExpr`.

```julia
julia>using BloqadeExpr
```

You can verify which backend you currently have enabled through:

```julia
BloqadeExpr.backend
```

To set a new backend, pass in the name as a string using the `set_backend` function (you can pass in `"BloqadeExpr"`, `"ThreadedSparseCSR"`, or `"ParallelMergeCSR"`):

```julia
BloqadeExpr.set_backend("ThreadedSparseCSR")
```

You will be prompted to restart the Julia session upon which you should also launch Julia with the desired number of threads:

```
julia -t num_threads
```

So long as the backend is not explicitly changed again through `BloqadeExpr.set_backend`, the selected backend will persist.

# [Interacting with Neutral Atom Hardware](@id schema)

Bloqade contains its own schema used to represent Hamiltonians in an IR (Intermediate Representation) that can then be executed via simulator/hardware as well as converted to and from other formats. Furthermore, tools such as [`hardware_transform`](@ref) and [`validate`](@ref) are available to check that user-defined Hamiltonians are capable of being executed on hardware and if not, transform them to be able to do so.

!!! warning "3-Level Support"
    The schema and conversion capabilities are currently not available for 3-level Hamiltonians

## Transforming Hamiltonians to Hardware Compatible Form

We start with creating a hamiltonian:

```@repl schema_example
using Bloqade, BloqadeSchema
Δ = constant(;duration=1.1, value=1.2*2π); 
Ω = linear_ramp(duration=1.1, start_value=0.0, stop_value=2π*1.0); 
ϕ = Waveform(t->2.2*2π*sin(t)^2, duration=1.1);
atoms = generate_sites(ChainLattice(), 4, scale=1.0);
h = rydberg_h(atoms; Δ = Δ, Ω = Ω, ϕ = ϕ)
```

To transform the Hamiltonian into something the hardware is capable of supporting, we can pass it through [`hardware_transform`](@ref).

!!! warning "Limitations on Transformations"
    While `hardware_transform` may attempt to adjust atom positions so that they conform to hardware position resolution capabilities, the function will NOT move atoms such that they satisfy minimum spacing constraints. The `validate` function presented later will explicitly indicate which atoms are in violation of the position constraints but will require the user to make the necessary changes.

    Furthermore, `hardware_transform` requires that all waveforms the Hamiltonian could use (Rabi frequency, detuning, and phase) are explicitly specified even if they are not used. To indicate non-use of a waveform, [`BloqadeWaveforms.constant`](@ref) should be used with the value set to zero.

`hardware_transform` accepts information from [`get_device_capabilities`](@ref) (already called as a default argument) which provides information on the machine's capabilities and returns the transformed hamiltonian along with additional information regarding the difference (error) between the originally defined lattice geometry and waveforms versus their transformed versions through a [`HardwareTransformInfo`](@ref) instance.


```@repl schema_example
transformed_h, transform_info = hardware_transform(h);
transformed_h
transform_info
dump(transform_info)
```

## Validating Hamiltonians


We can see if this hamiltonian or any other hamiltonian we create will run on hardware with the help of [`validate`](@ref). 
```@repl schema_example
validate(transformed_h)
```

In this case, the waveforms have been successfully transformed but there are still some issues with the atom positions. We can rescale their positions, regenerate the Hamiltonian and validate again to make sure the changes are correct.

```@repl schema_example
atoms = generate_sites(ChainLattice(), 4, scale=4.0);
fixed_h = rydberg_h(atoms; Δ = Δ, Ω = Ω, ϕ = ϕ) # Keep older waveforms with new atom geometry
transformed_h, _ = hardware_transform(fixed_h)
validate(transformed_h)
```

No violations are present meaning the new Hamiltonian has passed validation and can now be executed on hardware.

## Converting Between Formats

You can convert the Hamiltonian to and from:
* JSON Object format
* Julia Dictionary representation
* Schema representation
* Amazon Braket representation
to store the Hamiltonian for other applications or execute it in Bloqade/Neutral Atom hardware. 

!!! note "Internal Validation"
    By default, all conversion functions invoke [`validate`](@ref) internally to ensure the Hamiltonian is capable of being run on hardware. If a violation is detected, the Hamiltonian is not converted. For JSON and Schema representations, this can be bypassed by invoking the "no validation" variants [`to_schema_no_validation`](@ref) and [`to_json_no_validation`](@ref) respectively. This bypass ability is not available for dictionary representation and Amazon Braket representation (which requires the Hamiltonian is already in [`TaskSpecification`](@ref) format).

### Schema

[`to_schema`](@ref) allows you to convert a Hamiltonian to Bloqade's native schema format ([`TaskSpecification`](@ref)) along with an optional
[`SchemaTranslationParams`](@ref) argument to specify the number of shots and device capabilities for validation.

```@repl schema_example
h_schema = to_schema(transformed_h)
from_schema(h_schema) # to convert back to Hamiltonian
```

### JSON
[`to_json`](@ref) allows you to convert a Hamiltonian to a JSON Object along with an optional
[`SchemaTranslationParams`](@ref) argument to specify the number of shots and device capabilities for validation.
```@repl schema_example
h_json = to_json(transformed_h)
from_json(h_json) # to convert back to Hamiltonian
```

### Dictionary

[`to_dict`](@ref) allows you to convert a Hamiltonian to a Julia dictionary along with an optional 
[`SchemaTranslationParams`](@ref) argument to specify the number of shots and device capabilities for validation.
```@repl schema_example
h_dict = to_dict(transformed_h)
from_dict(h_dict) # to convert back to Hamiltonian
```

### Amazon Braket
[`to_braket_ahs_ir`](@ref) allows you to convert a [`TaskSpecification`](@ref) instance into an [`Braket.IR.AHSProgram`](https://github.com/awslabs/Braket.jl/blob/main/src/raw_schema.jl#L604) that can be submitted for execution on Neutral Atom hardware such as [QuEra's 256-qubit Aquila machine](https://www.quera.com/aquila) via [Amazon Braket](https://aws.amazon.com/braket/).
```@repl schema_example
h_schema = to_schema(transformed_h)
h_braket = to_braket_ahs_ir(h_schema)
```

!!! info "One-Way Conversion"
    Unlike the previous conversion functions, `from_braket_ahs_ir` does not exist meaning it is not possible to obtain a [`TaskSpecification`](@ref) from a `Braket.IR.AHSProgram`.

!!! warning "No Validation"
    [`to_braket_ahs_ir`](@ref) does no validation on its input. It is assumed that the [`TaskSpecification`](@ref) given to it is already validated. Therefore, it is possible to produce a `Braket.IR.AHSProgram` that is incapable of being run on Neutral Atom hardware and may cause the Braket API to reject it.

## Submitting to Amazon Braket

To submit to Neutral Atom hardware on Amazon Braket, Bloqade provides [`submit_to_braket`](@ref) which can submit BOTH the native Bloqade representation of Hamiltonians (`BloqadeExpr.RydbergHamiltonian`) as well as the [`TaskSpecification`](@ref) representation.

!!! warning "Implicit Transformation and No Validation for TaskSpecification"
    For any `BloqadeExpr.RydbergHamiltonian` passed in, [`hardware_transform`](@ref) is invoked to ensure it is compatible with hardware. On the other hand, [`TaskSpecification`](@ref) types are assumed to already be valid.


[`submit_to_braket`](@ref) requires that AWS credentials are given either explicitly through an [`AWS.AWSCredentials`](https://github.com/JuliaCloud/AWS.jl/blob/master/src/AWSCredentials.jl#L32) type or by setting the environment variables in the shell running Bloqade with the credentials. The credentials (and instructions for setting environment variables!) can be found through your AWS account's "Command line or programmatic access" option.

Let us try to submit the Hamiltonian we made earlier. We remind ourselves that our Hamiltonian is currently the following:

```@repl schema_example
fixed_h
```

(Recall we had to modify the atom positions in order to pass validation!)

Now we define the number of shots (how many times the Hamiltonian will be executed on hardware) as well as the credentials, allowing [`submit_to_braket`](@ref) to automatically handle transforming the Hamiltonian to fit within hardware capabilities. By default, [`submit_to_braket`](@ref) will submit to QuEra's Aquila Neutral Atom hardware and take into account its capabilities for Hamiltonian transformation.

```julia
using AWS
access_key_id = "your_access_key_id"
secret_key = "your_secret_key"
token = "your_token"
credentials = AWS.AWSCredentials(access_key_id, secret_key, token)
task = submit_to_braket(fixed_h, 100; credentials=credentials)
```

If submission was successful you will see something like 
```julia
AwsQuantumTask(...)
```
in the REPL with the Task ARN (Amazon Resource Name) as a string in the parentheses.

## Inspecting Results from Braket

To see the status of our task we can use `state` from the `Braket.jl` package.

```julia
using Braket
Braket.state(task)
```

`state` can return a `String` that is either: `"CANCELLED"`, `"FAILED"`, `"COMPLETED"`, `"QUEUED"`, or `"RUNNING"`.

To obtain results, the `result` function from `Braket.jl` can be used

```julia
res = Braket.result(task)
```

!!! info "Braket.result is Blocking"
    Per the docstring for [`result`](https://github.com/awslabs/Braket.jl/blob/main/src/task.jl#L292), the function is **BLOCKING** "until a result
    is available, in which case the result is returned, or the task enters a
    terminal state without a result (`"FAILED"` or `"CANCELLED"`)...".

To obtain the raw measurements (pre- and post-Hamiltonian application) of the atoms, the `measurements` field can be accessed:

```julia
res.measurements
```

## Reference

```@docs
get_device_capabilities
get_device_capabilities_SI
hardware_transform_Ω
hardware_transform_ϕ
hardware_transform_Δ
hardware_transform_atoms
hardware_transform
HardwareTransformInfo
validate
to_json
to_json_no_validation
to_dict
to_schema
to_schema_no_validation
to_braket_ahs_ir
submit_to_braket
from_json
from_dict
from_schema
execute
TaskSpecification
TaskOutput
ValidationViolations
```

```@meta
CurrentModule = Bloqade
```

# Waveforms

Waveforms are essential ingredients for generating the Rydberg Hamiltonian. By controlling the waveforms of ``\Omega``, ``\Delta``, and ``\phi``, one can prepare the ground states of certain target Hamiltonians and study their non-equilibrium dynamics. 
Bloqade supports several built-in waveforms and allows the users to specify waveforms by inputting functions. It also supports different operations of waveforms, such as waveform smoothening, composing, and more.

The generated waveforms can be directly used to build the time-dependent Hamiltonians. Please see the [Hamiltonians](@ref) section for more details.

## Creating Waveforms

In Bloqade, the waveforms are defined as a [`Waveform`](@ref) object,
which is a created by providing a callable object and a real number `duration`:

Bloqade gives users the flexibility to specify general waveforms by inputting functions. The following code constructs a sinusoidal waveform with a time duration of 2 μs:

```@example waveform
using Bloqade, Bloqade.CairoMakie
waveform = Waveform(t->2.2*2π*sin(2π*t), duration = 2);
Bloqade.plot(waveform)
```
In our documentation, we use the [`CairoMakie`](https://docs.makie.org/) for plotting.

Bloqade supports built-in waveforms for convenience (see References below). 
For example, the codes below create different waveform shapes with a single line:

```@example waveform
waveform = piecewise_linear(clocks=[0.0, 0.2, 0.5, 0.8, 1.0], values= 2π* [0.0, 1.5, 3.1, 3.1, 0.0]); 
Bloqade.plot(waveform)
```

```@example waveform
waveform = piecewise_constant(clocks=[0.0, 0.2, 0.5, 0.7], values= 2π*[0.0, 1.5, 3.1]);
Bloqade.plot(waveform)
```

```@example waveform
waveform = linear_ramp(duration=0.5, start_value=0.0, stop_value=2π*1.0);
Bloqade.plot(waveform)
```

```@example waveform
waveform =  constant(duration=0.5, value=2π*2.1);
Bloqade.plot(waveform)
```

```@example waveform
waveform = sinusoidal(duration=2, amplitude=2π*2.2); 
Bloqade.plot(waveform)
```

In some cases, users may have their own waveforms specified by a vector of clocks and a vector of signal strengths. To build a waveform from the two vectors, we can directly use the functions [`piecewise_linear`](@ref) or [`piecewise_constant`](@ref), corresponding to different interpolations. 

```@example waveform
clocks = collect(0:1e-1:2);
values1 = 2π*rand(length(clocks));
wf1 = piecewise_linear(;clocks, values=values1); 
values2 = 2π*rand(length(clocks)-1)
wf2 = piecewise_constant(;clocks, values=values2); 

fig = Figure(size=(960, 400))
ax1 = Axis(fig[1, 1])
ax2 = Axis(fig[1, 2])
Bloqade.plot!(ax1, wf1)
Bloqade.plot!(ax2, wf2)
fig
```

For more advanced interpolation options, please see the [JuliaMath/Interpolations](http://juliamath.github.io/Interpolations.jl/latest/) package.

## Operations on Waveforms

Bloqade also supports several operations on the waveforms. 

Waveforms can be sliced using the duration syntax `start..stop`, e.g.:

```@example waveform
wf = 2π*sinusoidal(duration=2.2);
wf1 = wf[1.1..1.5];
Bloqade.plot(wf1)
```
Note that time starts from `0.0` again, so the total duration is `stop - start`.

Waveforms can be composed together via `append`:

```@example waveform
wf2 = linear_ramp(;start_value=0.0, stop_value=1.1*2π, duration=0.5);
waveform = append(wf1, wf2); 
Bloqade.plot(waveform)
```

where the waveform `wf2` is appended at the end of `wf1`. 

Sharp points in waveforms may result in bad performance in practice (e.g. for adiabatically preparing a ground state of a target Hamiltonian).
It is sometimes preferred to smoothen the waveform using
the moving average methods. One can use the [`smooth`](@ref)
function to create a smoothened waveform from a piecewise linear
waveform:

```@example waveform
wf = piecewise_linear(clocks=[0.0, 2.0, 3.0, 4.0], values=2π*[0.0, 3.0, 1.1, 2.2]);
swf = smooth(wf;kernel_radius=0.1);

fig = Figure(size=(960, 400))
ax1 = Axis(fig[1, 1])
ax2 = Axis(fig[1, 2])
Bloqade.plot!(ax1, wf)
Bloqade.plot!(ax2, swf)
fig
```

## Waveform Arithmetics

Bloqade also supports several arithmetics on the waveforms. If two waveforms have the same duration, we can directly add up or subtract the strength of them, simply by using `+` or `-`: 

```@example waveform
wf1 = linear_ramp(;duration=2.2, start_value=0.0, stop_value=1.0*2π);
wf2 = sinusoidal(duration = 2.2, amplitude = 2.2*2π);
wf3 = wf1 + wf2; 
wf4 = wf1 - wf2;

fig = Figure(size=(960, 400))
ax1 = Axis(fig[1, 1])
ax2 = Axis(fig[1, 2])
Bloqade.plot!(ax1, wf3)
Bloqade.plot!(ax2, wf4)
fig

```

To increase the strength of a waveform by some factors, we can directly use `*`:

```@example waveform
wf = linear_ramp(;duration=2.2, start_value=0.0, stop_value=1.0*2π);
wf_t = 3 * wf;

fig = Figure(size=(960, 400))
ax1 = Axis(fig[1, 1])
ax2 = Axis(fig[1, 2])
Bloqade.plot!(ax1, wf)
Bloqade.plot!(ax2, wf_t)
fig

```

Such operations can also be broadcasted by using `.*`:
```@example waveform
wf2, wf3 = [2.0, 3.0] .* wf1; 

fig = Figure(size=(960, 400))
ax1 = Axis(fig[1, 1])
ax2 = Axis(fig[1, 2])
Bloqade.plot!(ax1, wf2)
Bloqade.plot!(ax2, wf3)
fig
```


## References

```@docs
BloqadeWaveforms.Waveform
Waveform(f; duration::Real)
BloqadeWaveforms.:(..)
sample_values
sample_clock
piecewise_linear
piecewise_constant
piecewise_linear_interpolate
piecewise_constant_interpolate
linear_ramp
constant
sinusoidal
BloqadeWaveforms.LinearAlgebra.norm
append
smooth
smooth(kernel, Xi::Vector, Yi::Vector, kernel_radius::Real)
Kernels.biweight
Kernels.cosine
Kernels.gaussian
Kernels.logistic
Kernels.parabolic
Kernels.sigmoid
Kernels.triangle
Kernels.tricube
Kernels.triweight
Kernels.uniform
```

# Working with Units

Unit conversion can be both tedious and prone to errors when working with simulation
of real quantum hardware. 
In Bloqade, the physical variables can support units explicitly from the [Unitful](https://github.com/PainterQubits/Unitful.jl) package.
Explicit units will be converted to our
default units set automatically.  In other words,  you can use a different unit set to create the Hamiltonian other than the default units, and not worry about conversion yourself. 
For detailed information about 
the default unit of the Hamiltonian, please refer to the [Bloqade](@ref) page.

```@repl units
using Bloqade
using Unitful: kHz, µm
rydberg_h([(1, ), (2, )], C = 2π * 109.2kHz * µm^6)
```
In the above example, we have assigned the parameter `C_6` with the unit `kHz * μm^6`, which is automatically
converted to the default unit `MHz * µm^6` in Bloqade. 

Other than the Hamiltonian, we can also specify units on waveforms, e.g.: 

```@example units
using Unitful: rad, ms

wf = piecewise_linear(clocks=[0.0ms, 0.1ms, 0.2ms], values= [0.1, 1.1, 2.1] .* (rad/ms))
Bloqade.plot(wf)
```
From this plot, we can see that the units for `clocks` and `values` have been converted to `μs` and `MHz` respectively. 

# [Registers and Observables] (@id observables)

Bloqade follows the register interface in [Yao](https://yaoquantum.org). It uses a register to 
represent a device and its internal quantum state.
For Bloqade, the most commonly used register types are `ArrayReg`
and `SubspaceArrayReg`. They both use a dense array to store
the corresponding quantum state. The only difference is that `SubspaceArrayReg` also stores
a subspace object. In this section, we will only cover how to create registers and perform operations on them in the full Hilbert space. For subspace operations, please refer to the [subspace](@ref) page. We will also discuss a few convenient wrappers on commonly used observables for Rydberg systems. 

In the analog mode, we use the states ``|g\rangle`` (ground state) and ``|r\rangle`` (Rydberg state) to encode a qubit. To be consistent with the standard language of qubits, we refer the states ``|g\rangle`` and ``|r\rangle`` as ``|0\rangle`` and ``|1\rangle`` here.

## Basic Interface

To create a register with all atoms being in the ground state ``| 00..00 \rangle``, we can use 
the function [`zero_state`](@ref) by specifying the number of qubits:

```@repl registers
using Bloqade
zero_state(5) # creates a 5-qubit register
```

To create a more general product state in the computational basis, one can use the [`product_state`](@ref) function by inputting its bitstring:

```@repl registers
product_state(bit"10011")
```
where `bit"10011"` is a special Julia string literal defined for bitstrings.

One can also construct the [`ArrayReg`](@ref) or [`SubspaceArrayReg`](@ref) directly from arrays, e.g.:

```@repl registers
ArrayReg(rand(ComplexF64, 2^5))
```

For a subspace register, one can create in the following way:

```@repl registers
space = Subspace(5, [0, 2, 3, 7])
state = rand(ComplexF64, length(space))
reg = SubspaceArrayReg(state, space)
```

Here, ``[0, 2, 3, 7]`` are base-10 integer representations of the corresponding states in bitstrings.
For a more detailed guide on how to work in the subspace, please see
[subspace](@ref).

## Operations on Registers
You can perform various operations on registers via the standard [Yao](https://yaoquantum.org)
register interface.
This includes, e.g., 
- applying operators on quantum 
    states by using [`apply!`](@ref), 
- measuring bitstrings with a 
    projection on the quantum state by using [`measure!`](@ref), 
- calculating the expectation value of certain observables by      using [`expect`](@ref),
- inspecting the internal state of the register by using [`statevec`](@ref).

```@repl registers
reg = rand_state(3)
measure(reg; nshots=5)
expect(put(3,1=>X), reg)
statevec(reg)
apply!(reg, put(1=>X))
```

For a more detailed introduction of the register interface, please
refer to [Yao:Registers](https://docs.yaoquantum.org/dev/man/registers.html).


## Convenient Wrappers

Bloqade also provides a few convenient wrappers on some commonly used observables for Rydberg systems, including the Rydberg density and two-point correlation functions: 

```@docs
rydberg_density
```
For example, if we want to measure the Rydberg density at each site or at a specific site, we can use the code below:

```@repl registers
reg = rand_state(10)
n_each = rydberg_density(reg)
n_2 = rydberg_density(reg, 2)
```
To access the two-point correlation functions, we can use the [`rydberg_corr`](@ref) function below: 

```@docs
rydberg_corr
```

This function will output a matrix that stores the correlation function for each pair of sites: 

```@repl registers
nn_corr = rydberg_corr(Op.n, reg)
```

It is worth mentioning that besides `Op.n`, other single-site operators including the Pauli operators `X`, `Y` and `Z` can also be used. 

To directly obtain the time-dependent Rydberg density under Hamiltonian evolution, we can use the highly-wrapped function [`get_average_rydberg_densities`](@ref)
```@docs
get_average_rydberg_densities
```

## Create General Observables using Operator Expressions

Bloqade makes use of Yao's block system to represent
operator expressions. 
For example, one can construct the Rydberg
correlation operator as:

```@repl registers
corr(n, i, j) = chain(n, put(i=>Op.n), put(j=>Op.n))
```

You can thus create any kinds of quantum operators in this way
and use it with the [`expect`](@ref) or [`measure`](@ref)
function, e.g.: 

```@repl registers
reg = rand_state(10)
corr_XY = chain(10, put(2=>Op.X), put(4=>Op.Y))
expect(corr_XY, reg) 
```

Because the Hamiltonian is also an operator expression,
it can be used as an observable too:

```@repl registers
r = rand_state(5)
pos = [(i, ) for i in 1:5]
h = rydberg_h(pos; Ω=2π*0.1)
expect(h, r)
```

Please refer to the [Hamiltonians](@ref) to see other operators that are supported in building the Hamiltonian.



## References

```@docs
arrayreg
apply!
measure!
measure
expect
statevec
zero_state
rand_state
product_state
SubspaceArrayReg
set_zero_state!
X
Y
Z

```

```@meta
CurrentModule = Bloqade
```

# [Emulation of the Quantum Dynamics](@id emulation)

After we create the Rydberg Hamiltonian and the register for storing the quantum information, we can 
simulate the quantum many-body dynamics. The coherent dynamics of
the system is governed by the Schrödinger equation. The emulation interface of Bloqade is designed in a  
define-and-run style. With Bloqade, we have two major types of emulation:

- ODE-solver based emulation for most of the problems.
- Krylov based emulation for piecewise constant problems or QAOA-like problem.



### Define the ODE Emulation Problem

ODE solvers are the major backend we use for most of the exact quantum 
dynamics simulation. The ODE solvers for Bloqade are powered by the [DifferentialEquations.jl package](https://diffeq.sciml.ai/).

Bloqade provides a special problem type [`SchrodingerProblem`](@ref)
that supports most of the 
[integrator interface](https://diffeq.sciml.ai/stable/basics/integrator/)
of `DifferentialEquations`, and most of
[the solver options](https://diffeq.sciml.ai/stable/basics/common_solver_opts/). Here, we introduce some common use cases of the integrator and solver options. For more advanced usage of the solvers,
please refer to the above link.

```@docs
BloqadeODE.SchrodingerProblem
```

## Run ODE-based Emulation

To run the emulation, you need to define the exact evolution and solver
you would like to run with via [`BloqadeODE.SchrodingerProblem`](@ref), and then feed the corresponding object to the
`emulate!` function:

```@docs
emulate!
```

For example, we can simulate the quantum dynamics of a time-dependent Hamiltonian with the following:

```@example evolution
using Bloqade
atoms = generate_sites(SquareLattice(), 3, 3; scale=5.1);
clocks = [0.0, 0.1, 0.2, 0.3, 0.4];
wf = piecewise_constant(;clocks, values=2π*[1.0, 2.0, 3.0, 4.0]);
h = rydberg_h(atoms; Δ=2π*2.0, Ω=wf); # create the Hamiltonian 
reg = zero_state(length(atoms)); # create fullspace register
ev = SchrodingerProblem(reg, 0.3, h) # the second input is the total time
emulate!(ev)
```
With `emulate!`, the quantum state stored in `reg` has been updated to the state after the time evolution. 

If you want to do operations during the real-time evolution,
such as measuring observables, you can instead
using the integrator interface with `for` loop and with `TimeChoiceIterator` on your desired clocks, e.g.:

```@example evolution
integrator = init(ev, Vern8())
for _ in TimeChoiceIterator(integrator, [0.1, 0.25])
    ev.reg # state at selected time
    @show measure(ev.reg)[] # measure the state at each time
end
```

You can use any function on the `reg` object. For calculating observables, 
please see the [Registers and Observables](@ref observables) section.

!!! tip

    Remember to make sure your operation does not mutate your state so that
    it won't affect the evolution itself, since the entire time evolution
    is simulated by mutating the state vector stored in
    `reg`. Avoid using any function that has a `!` in its name
    (indicating that it mutates its arguments per [Julia convention](https://docs.julialang.org/en/v1/manual/style-guide/#bang-convention))
    on the register `info.reg` unless you are certain about what you are
    doing.



## Choose an ODE Solver

One of the most powerful tools of the Julia ecosystem is the [DifferentialEquations](https://docs.sciml.ai/DiffEqDocs/stable/) ecosystem
that implements many different solvers. These solvers have different advantages and trade-offs. Since simulating a quantum many-body Schrödinger equation has some
special properties compared to a general ODE problem, we will discuss some
general heuristics in this section on how to choose a good ODE solver and
how to check if your simulation converges. Because the stiffness of the many-body Schrödinger equation is unknown, we will opt instead to use non-stiff problem algorithms or auto-switching algorithms.

For most of the cases, one can use the `VCABM` solver for a large system simulation. However, this method requires more memory, which can be a bottleneck with GPUs.

The `Vern` family is another set of solvers that is good for the many-body
Schrödinger equation, such as `Vern6`, `Vern7`, and `Vern8`. They also
have relatively good memory usage when utilizing GPUs.

For a more detailed list of solvers, please refer to [DifferentialEquations:Full List of Solvers](https://diffeq.sciml.ai/stable/solvers/ode_solve/#Full-List-of-Methods).
For more detailed explanation on ODE solvers, please refer to [DifferentialEquations:Recommended Methods](https://diffeq.sciml.ai/stable/solvers/ode_solve/#Recommended-Methods).

!!! tip "Default Solver and Auto-Switching"
    Bloqade uses the Dormand-Prince solver (`DP8`) by default for all `SchrodingerProblem` instances. For dealing with potentially stiff equations one can take advantage of `DifferentialEquations` auto-switching algorithms where a default solver can be supplied but upon encountering stiffness can switch to a specific solver. A recommended combination for Bloqade is `AutoVern9(Rodas5)` although other combinations are possible (see [DifferentialEquations: Pre-Built Stiffness Detecting and Auto-Switching Algorithms](https://docs.sciml.ai/DiffEqDocs/stable/solvers/ode_solve/#Pre-Built-Stiffness-Detecting-and-Auto-Switching-Algorithms))

If you are familiar with MATLAB or Python, you may wish to compare the same
methods that you use in MATLAB or Python; you can find the corresponding
solvers in Julia in [DifferentialEquations:Translations from MATLAB/Python/R](https://diffeq.sciml.ai/stable/solvers/ode_solve/#Translations-from-MATLAB/Python/R).


## Adaptive Steps in ODE Solvers

Our ODE solvers use adaptive steps by default. It provides a significant speedup
compared to standard fixed-step methods (see [our benchmark here](https://github.com/yardstiq/bloqade_benchmarks/tree/main#results)).
However, if one expects to retrieve the results during the time evolution, e.g.,
plotting Rydberg densities with the evolution time, fixed-step methods are sometimes 
preferred.

More specifically, when the adaptive steps are turned on the time steps can become large.
However, if one is interested in measuring some observables in smaller time steps, then the adaptive step method will not produce accurate results for the finer time step, instead outputting results at the specific adaptive steps. 
In this situation, it's better to use fixed-step methods at the times where the observables are measured.

One can use the code below to turn off the adaptive steps when setting up the [`SchrodingerProblem`](@ref):

```@example evolution
atoms = generate_sites(SquareLattice(), 3, 3; scale=5.1);
h = rydberg_h(atoms; Δ=2π*2.0, Ω= 2π*1.0); # create the Hamiltonian 
reg = zero_state(length(atoms)); 
prob = SchrodingerProblem(reg, 3.0, h, adaptive = false, dt=1e-3);
```

Here, we've specified the fixed time step as `dt = 1e-3`.
If one only wants the final state of the evolution or if the intervals between each chosen time are much larger than the maximum step size, then adaptive steps are preferred.

### Define the Krylov Emulation Problem

The Krylov-based method expects time-independent Hamiltonians. One can define such a time evolution via a [`KrylovEvolution`](@ref) object.

```@docs
KrylovEvolution
```

## Run Krylov-based Emulation

We can run the Krylov-based emulation in a similar way using [`emulate!`](@ref):

```@repl evolution
emulate!(KrylovEvolution(reg, clocks, h))
```

However, as its name suggests, the Krylov-based emulation is not a standard ODE problem that DiffEq  supports. Thus, it does not support the ODE problem interface, but is more like a gate-based interface. For example, the object `KrylovEvolution` is iterable:

```@example evolution
for (step, reg, duration) in KrylovEvolution(reg, clocks, h)
    @show step
    @show reg
    @show duration
    println("==========")
end
```

## Krylov vs ODE Solvers

The [`KrylovEvolution`](@ref) uses the Krylov subspace methods to simulate the
time evolution of time-independent operators ``\exp(i\Delta t_i H)``, where ``\Delta t_i`` is the duration of time-independent Hamiltonian ``H`` at time ``t``. This method is more efficient when the evolution itself is a discrete evolution, e.g. in QAOA and with
[`piecewise_constant`](@ref) waveforms. As for other cases, ODE solvers
are usually more efficient than [`KrylovEvolution`](@ref).

# [Working with Subspace](@id subspace)

Due to the strong Rydberg interactions, only one Rydberg excitation is allowed if the atoms are close to each other. 
We typically take this as the blockade radius, ``R_b``, which is the 
distance for which the Rydberg interaction is the same as the Rabi frequency, ``\Omega`` (see [Rydberg Blockade](@ref blockade)). This is the so-called blockade constraint. 

In Bloqade, we can take advantage of this effect by allowing users to run emulation in a truncated subspace, i.e., by throwing out states that violate the blockade constraint. 
This can help accelerate the simulation and enables simulation for a larger system size. 
In this section, we will show how to create a blockade subspace, create registers in the subspace, 
obtain the Hamiltonian matrix in the subspace, and run emulation in the subspace.

!!! note
    Note that the blockade radius ``R_b`` is the distance for which the Rydberg interaction is the same as the Rabi frequency, ``\Omega``. 
    For accurate simulation, however, it's not recommended to throw away the states that's close to the blockade radius. In other words, it's safer to set the subspace radius ``R_s`` to be smaller than ``R_b``, where we throw away the blockade violated states when the atoms are within ``R_s``. 
    For example, if we set ``R_s = 1/2 * R_b``, we will be throwing away states that have interaction energies at least ``2^6*\Omega``, which will be a good approximation. 
    See the [Rydberg Blockade](@ref blockade) page for recommendations on how to set ``R_b``, ``R_s``, and the atom lattice separation, ``a``.


## Create the Blockade Subspace

One can create a blockade subspace via the `blockade_subspace` method if we know the atomic positions: 

```@docs
blockade_subspace
```

For example, we can construct a blockade subspace of a square lattice
using the code below:

```@example subspace
using Bloqade
atoms = generate_sites(SquareLattice(), 3, 3, scale=5.1)
space = blockade_subspace(atoms, 5.2)
```
We first created a ``3*3`` square lattice with nearest neighbor atoms separated by ``5.1`` μm. 
Then we have created a
blockade subspace with the subspace radius, ``R_s``, being ``5.2`` μm. 
This means that if two atoms have a separation distance that is smaller than (or equal to)
``5.2`` μm, 
then the blockade subspace does not contain states where both of them being in the Rydberg states.
For the dictionary shown, the left is the new index of the states in the blockade subspace; 
in this case, there are 63 allowed states, which is much smaller than the full Hilbert space size 512.
The vectors on the right correspond to the base-10 representations of the states in bitstrings. 

Here `space` is of the type `Subspace`:

```@docs
Subspace
```

Other than using atomic positions and the subspace radius, we can also use a graph to create a subspace. In this case, the subspace 
corresponds to the space composed by the [independent sets](https://en.wikipedia.org/wiki/Independent_set_(graph_theory)) of this graph. Bloqade has an explicit function for this, by using a graph as 
an input, and produces the subspace as the output. Here is an example code:

```@example subspace
using Graphs

g = SimpleGraph(5)
edge_set = [(1,2), (1, 4), (2, 5), (3, 4)]
for (i,j) in edge_set
    add_edge!(g, i, j)
end 
space = independent_set_subspace(g)
```


## Create Registers in the Subspace

One can create a register in the subspace by feeding the `space` object instead of an integer for the common register interfaces, e.g.:

```@repl subspace
zero_state(space)
product_state(bit"000_000_001", space)
```

Alternatively, if you have an existing state stored as a subtype of `AbstractVector`, you can also create the register using
the constructor:

```@repl subspace
state = rand(ComplexF64, length(space))
reg = SubspaceArrayReg(state, space)
```

## Obtain the Hamiltonian Matrix in the Subspace

The matrix projected in the subspace of a given Hamiltonian can be obtained via
[`mat`](@ref) as well, e.g.:

```@repl subspace
atoms = generate_sites(SquareLattice(), 3, 3, scale=5.1);
space = blockade_subspace(atoms, 5.2);
h1 = rydberg_h(atoms; Δ=2.0*2π, Ω=1.0*2π)
mat(h1, space)
```


## Other Operations in the Subspace

All other operations in the subspace are the same as the fullspace
case. 
For example, to run an emulation in the subspace, one just need to use the
subspace register [`SubspaceArrayReg`](@ref) instead of the fullspace register [`ArrayReg`](https://docs.yaoquantum.org/dev/man/registers.html#Array-Registers).
The rest of the code are the same:

```@example subspace
reg = zero_state(space)
prob = SchrodingerProblem(reg, 1.0, h1)
emulate!(prob)
statevec(reg)
```

Measurements on the subspace register is the same as that in the full space. 


## Create Constrained Local Hamiltonians in the Subspace

Although we are able to emulate our Hamiltonian problem in the projected subspace, the long-range tail of  
the Rydberg interactions will be present in the subspace Hamiltonian. In certain cases, you may not want the long-range tail by only simulating a constrained short-range Hamiltonian, e.g. [the PXP model](https://arxiv.org/abs/2011.09486).
In this case, we can use Bloqade to easily deal with such problems for an arbitrary graph in an arbitrary dimension. 

Let us take the PXP model in 1D as an example. We first create a 1D chain and then generate a subspace by projecting out states that have nearest-neighbor interactions. 

```@example subspace
atoms = generate_sites(ChainLattice(), 10, scale=5.1)
space = blockade_subspace(atoms, 5.2)
register = product_state(bit"0101010101", space)
h = 2π * 4.0 * SumOfX(length(atoms)) - 2π * 1.0 * SumOfN(length(atoms))
prob = SchrodingerProblem(register, 0.2, h)
emulate!(prob)
```
After creating the subspace, we have built a Hamiltonian by explicitly summing up the Rabi frequency term  and the detuning term by using [`SumOfX`](@ref) and [`SumOfN`](@ref) respectively. 
In this way, we have created a local constraint Hamiltonian (without the long-range interaction tail). Futhermore, if we want to emulate 
quantum dynamics under this Hamiltonian, we just need to create a subspace register and emulate the system under the created Hamiltonian.

# [GPU Acceleration] (@id cuda)

!!! danger "CUDA.jl Version 3 Required"

    Bloqade currently does not work with the latest version (4.x) of the [CUDA](https://github.com/JuliaGPU) package. As a workaround you will need to install version 3. The installation instructions below should already address this.

Bloqade supports CUDA acceleration. To use
CUDA acceleration, you will need a NVIDIA graphics processing unit (GPU).

## Installation

To use CUDA accelerators, you need to install the [CUDA](https://github.com/JuliaGPU/CUDA.jl) package and the [Adapt](https://github.com/JuliaGPU/Adapt.jl) package:

```julia
pkg> add CUDA@3 Adapt
```

This will automatically download all the needed dependencies of
the CUDA toolkit. This functionality requires CUDA toolkit
11.6+ and CUSPARSE 11.4+. You can check your version via

```julia
julia> CUDA.version()
```

## Using CUDA

Converting your CPU-based simulation to CUDA-based simulation
is extremely simple: just use the `adapt` function from `Adapt`
on the register object, which will convert the CPU-based
register to a CUDA-based register, e.g.:

```julia
using CUDA, Adapt
reg = zero_state(5)
dreg = adapt(CuArray, reg) # device register
```

For emulation, you can call `adapt` on your emulation object
to convert everything (emulation intermediate memory, etc.)
into the GPU memory, e.g.:

```julia
adapt(CuArray, KrylovEvolution(reg, clocks, h))
```

To perform operations after emulation (such as calculating the rydberg density) 
you will need to move the object out of GPU memory. This can be done so via `adapt` again:

```julia
# get the problem onto the GPU and perform emulation there:
gpu_prob = adapt(CuArray, SchrodingerProblem(register, time_span, hamiltonian))
integrator = init(gpu_prob, Vern9())
emulate!(integrator)

# get the problem off the GPU for subsequent processing/analysis:
prob = adapt(Array, gpu_prob)
```

Other code written with Bloqade should work with CUDA
automatically.

# The Julia Programming Language

The Bloqade project is built in the [Julia](https://julialang.org) programming language. 
For those who are not familiar with Julia, here is a quick start for some basic Julia grammar,
and a guide for learning more about Julia and advanced usage.

## Why Julia?

- **Fast**. As you might have heard, Julia is very fast; there are various benchmarks online.
    It can be used to even write Basic Linear Algebra Subroutine (BLAS) to reach performance that is on par with the
    manually optimized assembly with C (check [Octavian](https://github.com/JuliaLinearAlgebra/Octavian.jl)).
- **Generic**. The language itself and its ecosystem are built to be generic, and the compiler can specialize
    on generic methods automatically. Thus, you will find that a lot things can be combined easily, and they will
    **just work**, e.g. plugging in the `Measurement` number from 
    [Measurement.jl](https://github.com/JuliaPhysics/Measurements.jl) into your ODE solver, you will get error propagation **automatically**; plugging in Tropical numbers or in general a semi-ring algebra into a tensor-network contraction function, you can
    [solve optimization problems with tensor networks](https://github.com/QuEraComputing/GenericTensorNetworks.jl), and so on.
- **Differentiable**. The language is differentiable, which means you can calculate the derivatives
    using an automatic differentiation (AD) engine on the whole language. The AD ecosystem in Julia is very well developed and supported. 
    The current stable AD engine
    is powered by [Zygote](https://arxiv.org/abs/1907.07587) and the next generation AD engine includes
    [Diffractor (check the video talk on ACM SIGPLAN)](https://www.youtube.com/watch?v=mQnSRfseu0c) and
    [Enzyme](https://enzyme.mit.edu).
- **Extensible**. The language is designed to be compiler friendly. It supports staged programming
    as well as compiler plugins. This makes supporting new hardware much easier. As a result, Julia
    can conveniently support multiple different hardware, such as [CUDA](https://github.com/JuliaGPU/CUDA.jl),
    [oneAPI](https://github.com/JuliaGPU/oneAPI.jl), [TPU](https://github.com/JuliaTPU/XLA.jl), and potentially quantum computers in the future.
- **Easy**. With all these powerful features, the language itself is still rather easy to learn. Let's go to
    the [quick start](#Quick-Start) section to skim through the basic syntax.


!!! info

    Multi-stage programming (MSP) is a variety of metaprogramming in which compilation is divided into a series of intermediate phases, allowing type-safe run-time code generation. Statically defined types are used to verify that dynamically constructed types are valid and do not violate the type system. 

    -- Wikipedia

## Quick Start

### Variables and Some Basic Types
In Julia, you can define a variable similar to how you define it in Python. 
For example, you can define a `x` using `=` (assignment):

```@repl quick-start
x = 1
```

Every variable has a type. You can check it using `typeof`:

```@repl quick-start
typeof(x)
```

By default, Julia displays the output of the last operation. You can suppress the output by adding `;` (a semicolon) at the end.

### Functions
In Julia, you can also define short-form, one-line functions using `=` (assignment) similar to how you write things mathematically.

```@repl quick-start
f(x) = 2x
```

Typing the function's name gives information about the function. To call it, we must use parentheses:

```@repl quick-start
f
f(2)
```

For longer functions, we use the following syntax with the `function` keyword and `end`:

```@repl quick-start
function g(x, y)
	z = x + y
	return z^2
end
```

### Control Flows
In Julia, there are `for`, `if` and `while` control flows. For example, the `for` loop looks like:

```@repl quick-start
s = 0
for i in 1:10
    s += 1
end
```

we can now check the value of `s` by typing it again:

```@repl quick-start
s
```

Here, `1:10` is a **range** representing the numbers from 1 to 10:

```@repl quick-start
typeof(1:10)
```

the `if else` statement looks like the following:

```@repl quick-start
if s < 10
	# do something
elseif 10 < s < 13
	# do something
else
	# do something
end
```

### Matrix and Array
Julia carries its own `Array` type. If you use Python, it is similar to `numpy.array` in Python except:
1. index starts from 1,
2. the multi-dimensional index is column-wise.
You can also use list comprehension:

```@repl quick-start
[i for i in 1:10]
```

It works for multi-dimensional case too:

```@repl quick-start
[(i, j) for i in 1:10, j in 1:5]
```

Most functions involving matrices and arrays follow the same convention as `numpy` or `MATLAB`. For example, you can create a random matrix using:

```@repl quick-start
rand(5, 5)
```

If you have questions about using a function, you can always type the question mark `?` in your REPL following the function name:
```julia
julia> ?rand
```

### Package Manager & Environments
Julia carries its own package manager. You can use it as a normal package:
```julia
julia> using Pkg
```
To install a package, you can use:
```julia
julia> Pkg.add("Bloqade")
```
To remove a package, you can use:
```julia
julia> Pkg.rm("Bloqade")
```
All Julia programs **run inside an environment**. The default is the global environment. It is usually recommended to run your notebook in a local environment, so you won't hit **any version conflicts** between different packages. 

## Resources

For more resources, check the official website [julialang.org/learning](https://julialang.org/learning):

```@raw html
<style>
  iframe {
    width: 1px;
    min-width: 100%;
    min-height: 1000px;
  }
</style>
<iframe id="myIframe" src="https://julialang.org/learning/"></iframe>
<script>
  iFrameResize({ log: true }, '#myIframe')
</script>
```

# [Maximum Independent Set](@id mis)

[Rydberg Blockade](@ref blockade) is one of the most important properties of neutral-atom quantum computing based on Rydberg states. 
It naturally encodes the [independent set](https://en.wikipedia.org/wiki/Independent_set_(graph_theory)) constraint. 
More specifically, Rydberg blockade implies that two atoms cannot be both excited to the Rydberg state ``|r\rangle`` if they are close to each other, 
whereas independent set constraint means two vertices cannot be both in the independent set when they are connected by an edge.
Thus, one can consider atoms in the Rydberg state as vertices in an independent set. See the proposal in [H. Pichler, et al.](https://arxiv.org/pdf/1808.10816.pdf) for more details. 

In particular, one can use the ground state of the [Rydberg Hamiltonian](@ref Hamiltonians) to encode the [maximum independent set problem](https://en.wikipedia.org/wiki/Independent_set_(graph_theory)), 
which is to find the largest independent set of a given graph. 
For a particular subclass of geometric graphs, the so-called unit disk graphs, 
the Rydberg Hamiltonian can encode the solution without any overhead in the number of qubits. 
In fact, an experimental demonstration of quantum optimization has been realized in solving the maximum independent set problem up to 289 qubits in [S. Ebadi, et al.](https://arxiv.org/abs/2202.09372).

In Bloqade, we provide several functions to support the simulation of solving independent set problems on neutral-atom quantum computers.
We list them here in this section.

## The Maximum Independent Set Problem
In graph theory, an independent set is a set of vertices in a graph such that no two of which are connected by an edge.
The problem of finding maximum independent sets (MIS) is NP-hard, i.e., it is unlikely to be solved in a time polynomial to the problem size.
However, for a graph with a small to intermediate size, various solution space properties, including finding the MIS size and enumerating all MISs, can be computed using the package [`GenericTensorNetworks`](https://github.com/QuEraComputing/GenericTensorNetworks.jl); please also refer to the related manual pages [the independent set problem](https://queracomputing.github.io/GenericTensorNetworks.jl/dev/tutorials/IndependentSet/) and [the maximal independent set problem](https://queracomputing.github.io/GenericTensorNetworks.jl/dev/tutorials/MaximalIS/).

A tutorial on how to solve the MIS problem using Bloqade is detailed in the [MIS tutorial](@ref mis-tutorial) page.

In the following, we list the APIs in the module `BloqadeMIS`, many of which support the simulation of variational quantum algorithms for solving the MIS problem.

## References

```@autodocs
Modules = [BloqadeMIS]
```

# [Contributing to Bloqade](@id contrib)

If you are interested in contributing to this package,
please consider going through this guide to help make your
development workflow as smooth as possible.

Contributing to documentation and unit tests are always great ways to get yourself familiar
with the community and workflows.

## CLI Tool

There is a CLI tool in this repository at `.ci/run` that can help
you simplify your workflow substantially. You can run `.ci/run -h` in your
terminal to see the help message. or run `.ci/run <command> -h`
to see the help message of each command.
Below are some common use cases.

## Documentation

## Setup Documentation

If you are editing the documentation, you can use the `serve` command:

```sh
.ci/run doc serve
```

to serve the documentation locally, and it will automatically update
the served webpage while you are editing. 

If you wish to just build the documentation, you can use `build` command,
which will run the build:

```sh
.ci/run doc build
```

## Light-weight Documentation Build

Due to the "ancient" technology used by Documenter,
it cannot render single page while editing, which
causes the `doc serve` command to be very slow
when you are editing. We provide a light-weight build setup
to workaround this by removing all literate examples
from the documentation. You can enable this by:

```sh
.ci/run doc build --light
.ci/run doc serve --light
```

## Setting Up Environments

The Bloqade package itself is a meta-package that simply re-exports
component packages that live in the `lib` directory. Thus, one will need to
`dev` the corresponding component package to make sure they are
using the `master` branch version while developing. You can always
do this manually in Julia's Pkg mode via the `dev` command. For example, in the
`Bloqade` environment (the `Bloqade/Project.toml` file), one will need
to run the following command:

```julia
pkg> dev lib/BloqadeExpr lib/BloqadeKrylov lib/BloqadeLattices lib/BloqadeMIS lib/BloqadeODE lib/BloqadeWaveforms
```

This can be done automatically using the CLI tool via:

```sh
.ci/run dev
```

How does this work? The `.ci/run dev` command actually calls the `Pkg.develop`
command from Julia's package manager. Because we want to use the local
changes of the package, one will need to `dev` the corresponding package to 
make the changes happen in your current environment, e.g one will need to `dev` 
the `lib/BloqadeExpr` package to apply changes in `BloqadeExpr` module.

We also provide a convenient tool to setup this more automatically by
looking up dependencies in `lib` in one's `Project.toml` file,

```sh
.ci/run dev <path/to/your/environment>
```

will `dev` all the Bloqade dependencies in your environment.

See also [Modifying A Dependency](https://pkgdocs.julialang.org/v1/getting-started/#Modifying-A-Dependency)
for more detailed explanations.

### Create New Examples

Create a new example project called `my_new_examples` in `examples`
and setup the dependencies of `Bloqade`:

```sh
.ci/run example create my_new_example
```

### Build a Single Example

Build a single example at `build/my_example` to jupyter notebook:

```sh
.ci/run example build my_example
```

### Run Unit Tests

If you are developing unit tests or would like to verify that changes made to any of Bloqade's code have not broken existing functionality, you can run unit tests for a specific sub-package like so:
```sh
.ci/run test path_to_sub_package
```
You can also run ALL tests for the package using 
```sh
.ci/run testall
```

# [Installation](@id install)

You can copy the following line to your Julia REPL
to install the latest stable version of this package:

```julia
pkg> add Bloqade
```

## Low-Latency Usage of Bloqade Component Packages

The Bloqade project contains multiple packages. For development on top of functionality,
(especially for those who do not need the ODE solvers), we recommend you use the corresponding
component packages. The following is a list of component packages and what they do (WIP = work-in-progress)

- BloqadeExpr: Expressions and API definitions for Bloqade.
- BloqadeKrylov: Krylov-subspace based emulation.
- BloqadeLattices: objects, functions for lattices.
- BloqadeMIS: tools for working with maximum-independent sets in Rydberg system.
- BloqadeODE: ODE-based emulation.
- BloqadePython: WIP, python wrapper for the Bloqade package.
- BloqadeQMC: WIP, Stochastic Series Expansion for Rydberg system.
- BloqadeSchema: WIP, the schema for creating a task for Bloqade and QuEra machine.
- BloqadeWaveforms: the waveform objects.
- YaoSubspaceArrayReg: register object and functions in a subspace.

All the non-WIP packages are registered in the General registry. Thus, you can add them
as your dependency by directly running `pkg> add <component package>` in your Julia REPL.

## Try the Latest Version of Bloqade

Some users may want to try the latest version of Bloqade
for bug fixes, new features, etc. One can use `git` to clone the
repo to try the latest version of the entire package. This
requires one to setup the local project environment via `dev`.
Please refer to the page [Contributing to Bloqade](@ref) for more information.

If you only want to try the latest version of a specific
Bloqade package, just add `#master` after the package name, e.g.:

```julia
pkg> add BloqadeExpr#master
```

## Using Bloqade with Amazon EC2

Bloqade can be deployed on any personal computer although some users might benefit from the extra performance offered by large computational resources from different providers. To address that, Bloqade is also available on the Amazon Web Services (AWS) Marketplace, and can run on Amazon EC2 instances by deploying Amazon Machine Images (AMIs) onto them. More information about the AMIs and how to deploy them onto EC2 instances can be found below.

### Bloqade AMIs

There are two AMIs offered by the Bloqade team:

#### Bloqade AMI (Base Image)

Built on top of Ubuntu Server 20.04 LTS, this image includes
- The latest version of Julia and Bloqade
- [Yao.jl](https://yaoquantum.org/)
- [Revise.jl](https://github.com/timholy/Revise.jl)
- [BenchmarkTools.jl](https://juliaci.github.io/BenchmarkTools.jl/stable/)

#### Bloqade CUDA AMI

Built on top of an Amazon DLAMI (Deep Learning AMI) on Ubuntu 20.04, this AMI includes everything from the Base Image above along with:

- NVIDIA CUDA
- cuDNN
- NCCL
- GPU Drivers
- Intel MKL-DNN
- Docker
- NVIDIA-Docker
- EFA support
- Support for Block devices

as well as:

- [CUDA.jl](https://github.com/JuliaGPU/CUDA.jl)
- [Adapt.jl](https://github.com/JuliaGPU/Adapt.jl) 

Both of which are needed for Bloqade to take advantage of GPUs (see [GPU Acceleration](@ref cuda) for more on how to do this). 

### Disclaimers
!!! info
    - Deploying Bloqade on Amazon EC2 instances will incur a cost on the user that will depend on the AWS resources utilized.  
    - Support on deploying Bloqade on AWS can be obtained via AWS Support. This is a one-on-one support channel that is staffed 24x7x365 with experienced support engineers. To learn more, follow [this link](https://aws.amazon.com/premiumsupport/).

### Step 0: Set Your AWS Region

For general guidelines on launching EC2 instances, check out the [Amazon EC2 tutorial](https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/EC2_GetStarted.html).
Bloqade can technically be run from any location but its images are hosted on servers in AWS' North Virginia (N. Virginia) region. To get started as easily as possible, set your AWS region location to N. Virginia (us-east-1).

![Step 0](assets/Bloqade_EC2/Step0.png)

### Step 1: Access the EC2 Service

Now to really get started. On your AWS account portal, type EC2 on the search bar and access the EC2 Service

![Step 1](assets/Bloqade_EC2/Step1.png)

### Step 2: Launch Your Instance

Find the "Launch Instance" button, circled in red, to create one. To see all currently running instances, click the "Instances (running)" button, indicated by the red arrow.

![Step 2](assets/Bloqade_EC2/Step2.png)

### Step 3: Name Your Instance

Give your instance a memorable name...

![Step 3](assets/Bloqade_EC2/Step3.png)

### Step 4: Choose an Image

...and choose Bloqade as an image. This will put the AMI on the instance which has Bloqade and all its dependencies ready to go.

To find the Bloqade image you can search for it by typing in "Bloqade" in the search bar: 

![Step 4.1](assets/Bloqade_EC2/Step4.1.png)

Upon hitting enter, ensure you're in the "AWS Marketplace AMIs" section and select which image you'd like to use:

![Step 4.2](assets/Bloqade_EC2/Step4.2.png)

Upon reviewing the information on the AMI and hitting "Continue" you'll be returned to the Instance page to continue customizing it.

### Step 5: Select Your Instance

Select the EC2 instance type. Note that the rate at which your charged is dependent on which instance you select. Those with larger RAM/power usually charge more. For simple usage, we recommend an `m2.xlarge` instance as a basic choice. If you are looking for GPU support consider the `g4dn.xlarge` instance as a starting point.

More information on available instances and the ability to compare between them you can visit [instances.vantage.sh](https://instances.vantage.sh/).

![Step 5](assets/Bloqade_EC2/Step5.png)

### Step 6: Generate a Key Pair

In order to access your instance from your local machine's terminal you will need to generate a key pair in advance. Click on "Create new key pair" as circled in the image. 

![Step 6.1](assets/Bloqade_EC2/Step6.1.png)

Give your key pair a memorable name and once you have selected your desirable key pair type and file format click "Create key pair".

![Step 6.2](assets/Bloqade_EC2/Step6.2.png)

A download should happen in your browser that gives you your private key. If you are a PuTTY user you will need to import this key into your client. If you are are a Linux/macOS user using an SSH client from the terminal, you should put the key in your `~/.ssh` folder although any other location will work with the caveat being you will have to specify the exact path to the key when invoking `ssh` as an argument to the command.

You will also need to run the following command to set the proper permissions on the private key:
```bash
chmod 400 </path/to/your_key>
```

After launching your instance there will be two ways you can connect to it, shown in the later steps of this guide.

### Step 7: Tune Your Instance Some More

Select your security group. This depends on either your personal setup, company security practices, or AWS best practices.

![Step 7](assets/Bloqade_EC2/Step7.png)

### Step 8: Blast Off!

Launch your instance!

![Step 8.1](assets/Bloqade_EC2/Step8.1.png)

You should be presented with the following screen:

![Step 8.2](assets/Bloqade_EC2/Step8.2.png)

If you click on the instance hyperlink or the "View all instances" button, you'll be brought to the Instances page which shows all currently running as well as previously terminated/stopped instances. This page is also accessible from EC2 service page, 
accessible via the directions in [Step 2](#step-2-launch-your-instance).

Select your instance from the "Instances" menu by clicking the checkbox next to the desired instance. A "Connect" button should be clickable in the upper right corner.

![Step 8.3](assets/Bloqade_EC2/Step8.3.png)

This should bring you to a "Connect to instance" page where you can navigate to the "SSH client" section.

![Step 8.4](assets/Bloqade_EC2/Step8.4.png)

From here you have one of two choices to connect with your instance:

!!! warning "Default User Notice"
    When logging in to your EC2 instance, the recommended user to login as is the `ubuntu` user (the default, non-root user from the Ubuntu base images the Bloqade AMIs are based off of). Using `root` is not advised and unsupported by the Bloqade team. You will notice the "SSH Client" section in the photo above still gives the `ssh -i ...` command with "root" as the username. This must be changed to `ubuntu` IF you intended to use Option 1 below. Option 2 already accounts for this.

#### Option 1: Instant Command Line Access

If you just want to connect to the instance as fast as possible and plan on either:

- Keeping the instance alive for the duration of your work
- Terminating (the equivalent of completely deleting an instance) and starting new instances frequently

Just copy and paste the example at the very bottom (the command starting with `ssh -i ...`), changing the user to `ubuntu` from `root`. If your key is not located in the `~/.ssh` folder for Linux/macOS users, you will need to either navigate to the folder you have the key stored to in the command line and execute the command there OR specify the full path to the key as the string in front of `-i`. 


#### Option 2: OpenSSH Config File

If you plan on reusing the same instance (stopping and starting it, thereby preserving your work on the EBS (Elastic Block Storage), essentially the hard drive of your instance) instance that the EC2 instance uses by default, you can set defaults for signing in by creating (if the file does not exist)/editing (if the file does exist) your OpenSSH `config` found in your `~/.ssh` folder. Just add the following using `vim` or your favorite text editor:
```
Host AWS
    HostName <DNS NAME, ex: ec2-3-93-200-58.compute-1.amazonaws.com>
    User ubuntu
    IdentityFile ~/.ssh/<PATH TO YOUR KEY>.pem
```
You can find your DNS name by following the steps mentioned in Option 1 but focusing on Step 4, which is "Connect to your instance using its Public DNS".

Upon saving the changes, you should be able to access your instance by running `ssh AWS` in your command line.

### Step 9: Shutting Down Your Instance

In order to shut down your instance, you can return to the "Instances" menu shown in [Step 8](#step-8-blast-off), select your instance, and click the "Instance State" Drop down. 

You can either:
- Stop your Instance - This preserves any files you may have created working in the instance that were on the EBS but will come at a cost, determinable [here](https://aws.amazon.com/ebs/pricing/). You may reuse the instance by selecting it again in the "Instances" menu and selecting "Start".
- Terminating your Instance - This does NOT preserve any files and means you will lose any work not transferred off the instance to your local machine. Termination deletes the EBS instance that your instance uses and you will not be charged afterwards for storage.

## Using Bloqade with qBraid Lab

As an alternative to the AWS marketplace, Bloqade is also available working out-of-the-box through qBraid Lab.
[qBraid](https://www.qbraid.com/) supports Google login, is free-to-use, and requires little to no setup.

### qBraid Bloqade Jupyter Lab Image

Built on top of Ubuntu Server 20.04 LTS, this image includes
- The latest version of Julia and Bloqade
- [Yao.jl](https://yaoquantum.org/)
- [Revise.jl](https://github.com/timholy/Revise.jl)
- [BenchmarkTools.jl](https://juliaci.github.io/BenchmarkTools.jl/stable/)
- Jupyter Lab interface with dedicated Julia and Python kernels
- Integrated Terminal for interactive command-line sessions

See [qBraid system info](https://docs.qbraid.com/en/latest/lab/system.html) for more.

### Step 0: Redeem Access Key

Login to [account.qbraid.com](https://account.qbraid.com/). On the left side of your dashboard, inside the **Plan** card, click **Manage**.

![qBraidStep 0.1](assets/Bloqade_qBraid/Step0.1.png)

Scroll down to find the card marked **Access Key**. Enter code `NEUTRALATOM` and click **Submit**. This will grant you access to the Bloqade Lab image as well as a number of other premium features.

![qBraidStep 0.2](assets/Bloqade_qBraid/Step0.2.png)


### Step 1: Select Image & Launch Lab

At the top of your account page, open the image drop down. Select the option named `Bloqade_2vCPU_4GB`, and then click **Launch Lab**. Pulling the Bloqade image may take 2-3 minutes the first time. The next time you launch Lab, it will load much more quickly.

![qBraidStep 2](assets/Bloqade_qBraid/Step1.png)


### Step 2: Develop with Notebooks or from Command-Line

Once qBraid Lab is loaded, you are all set! No further setup is required. In the middle of your screen you can click the **Julia 1.9** kernel to open a new Jupyter Notebook configured with the Julia executable. Alternatively, you can click to open **Terminal** and run an interactive `julia` session from the command-line. In this qBraid Lab image, Bloqade is pre-installed and pre-compiled, so you should be able to get started `using Bloqade` right away.

![qBraidStep 3](assets/Bloqade_qBraid/Step2.png)


#### Julia Configuration

In qBraid Lab, the `JULIA_DEPOT_PATH` is set to `/opt/.julia`. This default setting means that any additional Julia packages installed will be stored at the system level, and therefore *will not persist between sessions*. To persist additional packages, caches, configs, and other Julia updates, they must be saved at the user level (e.g. `/home/jovyan/.julia`). This can be done by updating the depot path:

```bash
export JULIA_DEPOT_PATH="/foo/bar:$JULIA_DEPOT_PATH"
```

See [Julia environment variables](https://docs.julialang.org/en/v1/manual/environment-variables/#JULIA_DEPOT_PATH) for more.


### Step 3: Explore More Features

The Environment Manager, located in the right sidebar of qBraid Lab, provides a graphical user interface for creating and managing Python virtual environments. This particular Lab image comes with a pre-installed Bloqade Python Wrapper environment. Clicking **Activate** will create a corresponding IPykernel, and allow you to run Jupyter Notebooks using the `bloqade` Python package.

In the bottom right corner qBraid Lab, click **Start Tour** for an interactive walkthrough. You can re-start the tour and access other useful links from the **Help** drop-down in the top menu bar. To stop and/or restart your session, click **File** > **Hub Control Panel** > **Stop My Server**. For more on qBraid environments, kernels, notebooks, and other features or troubleshooting, see [qBraid Lab Docs](https://docs.qbraid.com/en/latest/index.html).

## Build System Images to Accelerate Start-up Time

Since Bloqade is a large package, its loading time
and time-to-first-simulation can be very long.
You can build system images to save all the compilation
results in a binary to accelerate its loading/compilation
time. This is useful when you have lots of interactive
programming needs with Bloqade.

To build a system image for your environment, please use
the [PackageCompiler](https://julialang.github.io/PackageCompiler.jl/dev/)
or use the Julia VSCode plugin's [build system image feature](https://www.julia-vscode.org/docs/stable/userguide/compilesysimage/)

## Contributing to Bloqade 

Please `git clone` this repository to a directory of your choice on your local machine and refer to [Contributing to Bloqade](@ref contrib) to see how to set up your development environment for Bloqade.

```@meta
CurrentModule = Bloqade
```

# Hamiltonian in a 3-level system

The Hamiltonian in a 3-level system is similar to a 2-level system. It also 
consists of Rabi terms, detuning terms, and Rydberg interaction between 
atoms but with more levels. The convention we used for a 3-level system 
Hamiltonian is 
```math
i \hbar \dfrac{\partial}{\partial t} | \psi \rangle = \hat{\mathcal{H}}(t) | \psi \rangle,  \\

\begin{aligned} 
    \frac{\mathcal{H}(t)}{\hbar} = & \sum_i \frac{\Omega_i^{\mathrm{hf}}(t)}{2}\left(e^{i \phi_i^{\mathrm{hf}}(t)}|0_i\rangle\langle 1_i|+e^{-i \phi_i^{\mathrm{hf}}(t)}| 1_i\rangle\langle 0_i|\right)-\sum_i \Delta_i^{\mathrm{hf}}(t)|1_i\rangle\langle 1_i| \\ 
    & +\sum_i \frac{\Omega_i^{\mathrm{r}}(t)}{2}\left(e^{i \phi_i^{\mathrm{r}}(t)}|1_i\rangle\langle r_i|+e^{-i \phi_i^{\mathrm{r}}(t)}| r_i\rangle\langle 1_i|\right)-\sum_i\left[\Delta_i^{\mathrm{hf}}(t)+\Delta_i^{\mathrm{r}}(t)\right]\left|r_i\right\rangle\left\langle r_i\right| \\ 
    & +\sum_{i<j} V_{i j}\left|r_i\right\rangle\left\langle r_i|\otimes| r_j\right\rangle\left\langle r_j\right| .
\end{aligned}
```

Here, ``|0\rangle`` and ``|1\rangle`` represent two different hyperfine levels 
in a atom. And ``|r\rangle`` represent the Rydberg level we use for entangling 
different atoms. There are two seperated pulses: the first one couples two 
hyperfine levels ``|0\rangle`` and ``|1\rangle`` and the second couples the 
hyperfine level ``|1\rangle`` and the Rydberg level ``|r\rangle``. We use two 
different superscripts ``\mathrm{hf}`` and ``\mathrm{r}`` to indicate them 
respectively.

With `ArrayReg` in `YaoArrayRegister`, we use ``|0\rangle``, ``|1\rangle``, and ``|2\rangle`` to 
represent ``|0\rangle``, ``|1\rangle``, and ``|r\rangle``, respectively. 


## Interface for the 3-level Hamiltonian

The interface for defining a 3-level Rydberg Hamiltonian is [`rydberg_h_3`](@ref). It is similar as the 
2-level interface [`rydberg_h`](@ref). The only difference is that, in 3-level you need to specify the Rabi term 
``(\Omega, \phi)`` and the detunning term ``(\Delta)`` for both hyperfine coupling 
``(\Omega^{\mathrm{hf}}, \phi^{\mathrm{hf}}, \Delta^{\mathrm{hf}})`` and rydberg coupling 
``(\Omega^{\mathrm{r}}, \phi^{\mathrm{r}}, \Delta^{\mathrm{r}})``. And both time-dependent and site-dependent waveforms are supported for each parameter (see [Hamiltonians](@ref) for details about defining different waveforms).


## Pulse sequences and quantum gates

We can use two hyperfine levels to represent a qubit. In this case 
single-qubit gates can be directly obtained using hyperfine coupling in the 
3-level system, and two-qubit gates can also be implemented by the coupling 
between ``|1\rangle`` and ``|r\rangle`` with the assist of Rydberg interation 
between different Rydberg atoms. In general, any n-qubit unitary can be 
approximated by a 3-level Rydberg pulse sequence. Hence, the 3-level Rydberg 
system is universal for qubit quantum computation.

### Single-qubit gates

Here is an example for applying a Pauli ``X`` gate (acting on hyperfine levels 
``|0\rangle`` and ``|1\rangle``) to each site. Notes that single qubit gates 
could be parallelize, that is implementing the same single qubit gate on 
different sites with only one pulse.
```@repl 3-level-single-qubit
using Bloqade
atoms = generate_sites(ChainLattice(), 5, scale=5)
h = rydberg_h_3(atoms; Ω_hf = 1.0)
reg = zero_state(5; nlevel = 3); # the initial state is an all-zero state
prob = KrylovEvolution(reg, 0.0:1e-2:pi, h); # an X gate is a π-pulse
emulate!(prob);
measure(reg) # the final state is an all-one state
```

### Two-qubit gates

Two-qubit gates can be implemented with the assist of Rydberg interaction 
between two atoms. Here we give two example of different implementation of 
the CZ-gate using the 3-level Rydberg system. 

- 5-pulse CZ-gate
- The Levine-Pichler gate

Notes that the gate set of arbitrary single-qubit gate + CZ-gate is universal. 
Hence, 3-level Rydberg system is universal for quantum computing.

### 5-pulse CZ-gate

Suppose we have two atoms which are cloesed to each other so that there is 
Rydberg blockade between them. And the first atom is the controlling qubit 
while the second atom is the target qubit. 
```@repl 3-level-5-pulse-CZ
using Bloqade
atoms = generate_sites(ChainLattice(), 2; scale = 4)
```

There are 5 steps in total for the CZ-gate. 
1. Apply an X-gate (hyperfine π-pulse) on each qubit to flip ``|0\rangle`` and ``|1\rangle``
2. Apply an Rydberg π-pulse on the controlling qubit
3. Apply an Rydberg 2π-pulse on the target qubit
4. Apply an Rydberg π-pulse on the controlling qubit
5. Apply an X-gate (hyperfine π-pulse) on each qubit to flip ``|0\rangle`` and ``|1\rangle``

To understand the above steps, let us consider two different cases when the 
controlling qubit starts with ``|0\rangle`` and ``|1\rangle``.
- If the controlling qubit starts with ``|0\rangle``, then after step 2 it will be 
excited into the Rydberg state ``|r\rangle``. Because of the Rydberg blockade, the 
pulse in step 3 act trivially but a global phase -1 onto the target qubit. 
This means nothing changes but a global phase -1 if controlling qubit is ``|0\rangle``.
- If the controlling qubit is started with ``|1\rangle``, then after step 2 it will 
become the hyperfine state ``|0\rangle`` which will not affect the pulse in step 3. 
In this case, the 2π-pulse will cause a phase -1 only if the target qubit 
is ``|1\rangle`` after step 2 (which means the target qubit starts with ``|0\rangle``). This 
means a Z-gate upto a global phase -1 is applied on the target qubit when 
the controlling qubit is ``|1\rangle``.

The following codes implement the above 5-steps of the CZ-gate.
```@repl 3-level-5-pulse-CZ
using Bloqade
using Yao
atoms = generate_sites(ChainLattice(), 2; scale = 4)
st = zeros(ComplexF64, 9); st[[1, 2, 4, 5]] .= 1/2; # [1, 2, 4, 5] are indices for hyperfine states
reg = arrayreg(st; nlevel = 3)  # initialize the state with 1/2 (|00⟩ + |01⟩ + |10⟩ + |11⟩) 
hs = [
    rydberg_h_3(atoms; Ω_hf = [1.0, 1.0]),  # hyperfine pulse for step 1
    rydberg_h_3(atoms; Ω_r = [1.0, 0.0]),   # Rydberg pulse for step 2
    rydberg_h_3(atoms; Ω_r = [0.0, 1.0]),   # Rydberg pulse for step 3
    rydberg_h_3(atoms; Ω_r = [1.0, 0.0]),   # Rydberg pulse for step 4
    rydberg_h_3(atoms; Ω_hf = [1.0, 1.0]),  # hyperfine pulse for step 5
]   # Hamiltonians for step 1-5
ts = [π, π, 2π, π, π]   # pulse time for step 1-5
step = 1e-3; # Krylov time step
for i = 1:5
    prob = KrylovEvolution(reg, 0.0:step:ts[i], hs[i])
    emulate!(prob)
end
state(reg)[1, 2, 4, 5]  # equivalent to 1/2 (|00⟩ + |01⟩ + |10⟩ - |11⟩) 
```

#### The Levine-Pichler gate

A more efficient way to implementing the CZ-gate is using the 
[Levine-Pichler gate](https://journals.aps.org/prl/abstract/10.1103/PhysRevLett.123.170503). 
Comparing to the above 5-pulse CZ-gate, the Levine-Pichler gate uses shorter 
sequence and less time. 

Consider two atoms which are closed to each other. If we apply a pulse that 
couples ``|1\rangle`` and ``|r\rangle`` with the Rabi frequency 
``\Omega^\mathrm{r}``, detunning ``\Delta^\mathrm{r}``, and duration 
``\tau``, then the dynamics of four hyperfine state are different.

- ``|00\rangle`` will not change during the pulse
- ``|01\rangle`` (``|10\rangle``) will oscillate between ``|01\rangle`` and ``|0r\rangle`` (``|10\rangle`` and ``|r0\rangle``) with a frequency ``\Omega^\mathrm{r}``
- ``|11\rangle`` will oscillate between ``|11\rangle`` and ``|w\rangle = \frac{1}{2}\left( |1r\rangle + |r1\rangle \right)`` with a frequency ``\sqrt{2}\Omega^\mathrm{r}`` (this is an approximation when the Rydberg blockade is strong enough such that the population of ``|rr\rangle`` could be ignored)

The Levine-Pichler gate consists of two global pulses. Together with a global hyperfine pulse for rotation-Z gates, we will get a CZ-gate.

1. A global Rydberg pulse with parameters ``\frac{\Delta^\mathrm{r}}{\Omega^\mathrm{r}} \approx 0.377371``, ``\phi^\mathrm{r} = 0``, ``\Omega^\mathrm{r}\tau \approx 4.29268``
2. A global Rydberg pulse with parameters ``\frac{\Delta^\mathrm{r}}{\Omega^\mathrm{r}} \approx 0.377371``, ``\phi^\mathrm{r} \approx 3.90242``, ``\Omega^\mathrm{r}\tau \approx 4.29268``
3. A global hyperfine pulse with parameters ``\Delta^\mathrm{r}\tau = 2\pi - \alpha \approx 3.90242``, ``\Omega^\mathrm{r} = \phi^\mathrm{r} = 0``

The first pulse completes a full cycle of oscillation for ``|11\rangle`` while it 
does not complete a cycle for ``|01\rangle`` and ``|10\rangle``. The only difference 
between the first and the second pulse is the parameter ``\phi^\mathrm{r}``. This 
difference causes a change of the rotation axis on the Bloch sphere, such that the 
second pulse completes another full cycle of oscillation for ``|11\rangle`` while it 
also brings back ``|01\rangle`` and ``|10\rangle``. After these two pulses has a unitary representation 
```math
\begin{pmatrix}
1 & & & \\
& e^{i\alpha} & & \\
& & e^{i\alpha} & \\
& & & e^{i(2\alpha-\pi)}
\end{pmatrix},
```
which is a CZ-gate with single qubit rotation gates ``R_Z(\alpha)`` on each qubit.
The following picture (Fig 2 c) in [the original paper](https://journals.aps.org/prl/abstract/10.1103/PhysRevLett.123.170503)) 
demonstrates the process of the first pulse and the second pulse.
![](assets/levine-pichler.png)

Here are codes for the Levine-Pichler gate.
```@repl 3-level-levine-pichler
using Bloqade
using Yao
st = zeros(ComplexF64, 9); st[[1, 2, 4, 5]] .= 1/2; # [1, 2, 4, 5] are indices for hyperfine states
reg = arrayreg(st; nlevel = 3); # initialize the state with 1/2 (|00⟩ + |01⟩ + |10⟩ + |11⟩) 
atoms = generate_sites(ChainLattice(), 2; scale = 4);
Ω_r = 1.0; ϕ_r = 3.90242; Δ_r = 0.377371*Ω_r;   # define parameters
τ = 4.29268/Ω_r; α = 2.38076;   # define pulse durations
step = 1e-3;    # Krylov step
hs = [
    rydberg_h_3(atoms; Ω_r = Ω_r, Δ_r = Δ_r),   # global Rydberg pulse for step 1
    rydberg_h_3(atoms; Ω_r = Ω_r, ϕ_r = ϕ_r, Δ_r = Δ_r),    # global Rydberg pulse for step 2
    rydberg_h_3(atoms; Δ_hf = 1.0), # global hyperfine pulse for R_Z-gate in step 3
]
ts = [τ, τ, 2π - α]
for i = 1:3 # simulation
    prob = KrylovEvolution(reg, 0:step:ts[i], hs[i])
    emulate!(prob)
end
state(reg)[[1, 2, 4, 5]]  # desired state 1/2 (|00⟩ + |01⟩ + |10⟩ - |11⟩) 
```

### Predefined pulse sequences for different quantum gates

Instead of defining pulse sequences manually, we provide lots of predefined pulse 
sequences for basic quantum gates. For more details, please refer to the package 
[`BloqadeGates`](https://github.com/QuEraComputing/Bloqade.jl/tree/master/lib/BloqadeGates).


## References

The 3-level Rydberg Hamiltonian:

```@docs
rydberg_h_3
```

The following operators only for 3-level system are also supported by Bloqade.

### Single site operators

```@docs
X_01
X_1r
N_1
N_r
Pu_01
Pu_1r
Pd_01
Pd_1r
Bloqade.BloqadeExpr.Z_01
Bloqade.BloqadeExpr.Z_1r
XPhase_01
XPhase_1r
```

### Sum of operators

```@docs
SumOfX_01
SumOfX_1r
SumOfXPhase_01
SumOfXPhase_1r
SumOfN_1
SumOfN_r
SumOfZ_01
SumOfZ_1r
```

```@meta
CurrentModule = Bloqade
```

# Bloqade

```@raw html
<p>
Welcome to the documentation page for Bloqade, a &nbsp;
    <a href="https://julialang.org">
        <img src="https://raw.githubusercontent.com/JuliaLang/julia-logo-graphics/master/images/julia.ico" width="16em">
        Julia Language
    </a>
    &nbsp; package for quantum computation and quantum dynamics based on neutral-atom architectures.
```

Neutral-atom quantum computers have two major modes of computation: the first mode is a "digital mode" to do universal, digital quantum computation that uses two ground states ``|0\rangle`` and ``|1\rangle`` to encode the qubit, which has long coherence time, and one Rydberg state ``|r\rangle`` to entangle the qubits; the second mode is an "analog mode" as a programmable quantum simulator that uses one ground state ``|g\rangle`` and one Rydberg state ``|r\rangle``, where the quantum dynamics is governed by a Rydberg Hamiltonian ``\hat{\mathcal{H}}`` described below.

Currently, Bloqade enables the easy design and fast execution of quantum dynamics in the analog mode,  based on the neutral-atom quantum computing architecture. Besides fast full Hilbert-space simulation on CPUs, the main features include the design of arbitrary-layout quantum registers ([Lattices](@ref)), easy waveform generation ([Waveforms](@ref)), simulation in subspace constrained by the Rydberg blockade ([Working with Subspace](@ref subspace)), multithreaded CPU ([CPU Acceleration](@ref multithreading)) and GPU-accelerated simulation ([GPU Acceleration](@ref cuda)), and more.

## Installation

```@raw html
<p>
To install Bloqade,
    please <a href="https://docs.julialang.org/en/v1/manual/getting-started/">open
    Julia's interactive session (known as REPL)</a>, press <kbd>]</kbd> key in the REPL to use the package mode, and then add the QuEra Julia registry via:
</p>
```

For the stable release, type:

```julia
pkg> add Bloqade
```

Or for the current master:

```julia
pkg> add Bloqade#master
```

For a more advanced installation guide, please see the [Installation](@ref install) page.

## What does Bloqade Do?


In the analog mode, Bloqade simulates the time evolution of a quantum state under the Schrödinger equation where the Hamiltonian is the interacting Rydberg Hamiltonian ``\hat{\mathcal{H}}``, 

```math
i \hbar \dfrac{\partial}{\partial t} | \psi \rangle = \hat{\mathcal{H}}(t) | \psi \rangle,  \\

\frac{\mathcal{H}(t)}{\hbar} = \sum_j \frac{\Omega_j(t)}{2} \left( e^{i \phi_j(t) } | g_j \rangle  \langle r_j | + e^{-i \phi_j(t) } | r_j \rangle  \langle g_j | \right) - \sum_j \Delta_j(t) \hat{n}_j + \sum_{j < k} V_{jk} \hat{n}_j \hat{n}_k.
```

Following the atomic physics nomenclature, ``\Omega_j``, ``\phi_j``, and ``\Delta_j``  denote the Rabi frequency, laser phase, and the detuning of the driving laser field on atom (qubit) ``j`` coupling the two states  ``| g_j \rangle `` (ground state) and `` | r_j \rangle `` (Rydberg state); ``\hat{n}_j = |r_j\rangle \langle r_j|`` is the number operator, and ``V_{jk} = C_6/|\mathbf{x}_j - \mathbf{x}_k|^6`` describes the Rydberg interaction (van der Waals interaction) between atoms ``j`` and ``k`` where ``\mathbf{x}_j`` denotes the position of the atom ``j``; ``C_6`` is the Rydberg interaction constant that depends on the particular Rydberg state used. For Bloqade, the default ``C_6 = 862690 \times 2\pi \text{ MHz μm}^6`` for ``|r \rangle = \lvert 70S_{1/2} \rangle`` of the ``^{87}``Rb atoms; ``\hbar`` is the reduced Planck's constant. Sometimes, we also refer the states ``|g\rangle`` and ``|r\rangle`` as ``|0\rangle`` and ``|1\rangle`` as well in the analog mode.

Starting from an initial quantum state ``| \psi_{\text{ini}} \rangle``, Bloqade simulates its time evolution under the Hamiltonian ``\hat{\mathcal{H}}(t)``, given the qubit positions and the time-dependent profiles for  ``\Omega_j``, ``\phi_j``, and ``\Delta_j``. Bloqade then outputs the real-time-evolved state ``| \psi(t) \rangle``, which can then be used for measuring different observables.

More specifically, here are the steps to program neutral-atom quantum computers using Bloqade:

- specify atom positions (see [Lattices](@ref))
- program waveforms of Hamiltonian parameters (see [Waveforms](@ref))  
- create the Hamiltonian (see [Hamiltonians](@ref))
- specify the initial state (see [Registers and Observables](@ref observables))
- emulation (see [Emulation](@ref emulation))
- measurements & observables (see [Registers and Observables](@ref observables)).

The default units for various quantities are: 

|  Quantity  | Default Unit |
|:----------:|:------------:|
|   Length   |      μm      |
|    Time    |      μs      |
| ``\Omega`` |    rad/μs    |
|  ``\phi``  |     rad      |
| ``\Delta`` |    rad/μs    |

You may often find ``\Omega`` and ``\Delta`` written in units of MHz. If you see something like “``\Omega`` is 4 MHz”, it means ``\Omega = 2\pi \times 4`` MHz ``= 25.13`` rad/μs. Using MHz also makes it very easy to understand the pulse time duration it takes to flip the atom from ``|g\rangle`` to ``|r\rangle`` (and vice versa), i.e., a π-pulse. For example, for a π-pulse which means ``\Omega\,t = \pi``, if ``\Omega = 2\pi \times 4`` MHz, then it takes ``t = 0.125`` μs to do the π-pulse.

## A Simple Example

Let's try a simple example of simulating quantum many-body dynamics governed by the Rydberg Hamiltonian. 

We start by loading the Bloqade Module:

```@repl quick-start
using Bloqade
```

As one can see from the Rydberg Hamiltonian, the interactions between Rydberg atoms depend on their positions. Bloqade provides several built-in [Lattices](@ref) structures for specifying the atom positions. For instance, we can use the following codes to quickly generate a chain of 10 atoms in 1D: 

```@repl quick-start
nsites = 10;
atoms = generate_sites(ChainLattice(), nsites, scale = 5.74)
```
We have set the distance between nearest-neighbor atoms to be 5.74 μm. Note that the default unit of length is μm as shown in the table above.

Let's set both ``\Omega`` and ``\Delta`` to be constants (and ``\phi = 0``). Since all the variable parameters in the Hamiltonian are specified, we can now create an interacting Rydberg Hamiltonian by using [`rydberg_h`](@ref): 

```@repl quick-start
h = rydberg_h(atoms; Ω = 4 * 2π, Δ = 0)
```

To create more complicated waveforms for ``\Omega`` and ``\Delta`` and find the supported utilities, please refer to the [Waveforms](@ref) page.

Let's create an initial state with all the atoms in the ground state by using [`zero_state`](@ref).

```@repl quick-start
reg = zero_state(10)
```

We are interested in measuring observables of the final quantum state of the Rydberg system starting from the initial state and evolving under the Rydberg Hamiltonian over some time duration. We can first create the problem and then directly simulate the time evolution.

```@repl quick-start
prob = SchrodingerProblem(reg, 1.6, h)
integrator = init(prob, Vern8());
emulate!(prob);
```
Here, we have chosen the ODE-based solver (`Vern8()`) by using [`SchrodingerProblem`](@ref) and set the total evolution time to be 1.6 μs.

After simulating the time evolution and get the final state, we can measure the Rydberg population at each site for the final state: 

```@repl quick-start
rydberg_populations = map(1:nsites) do i
    rydberg_density(prob.reg, i)
end
```
`prob.reg` is the register storing the final state after the time evolution.

## Benchmarks

![](https://github.com/yardstiq/bloqade_benchmarks/blob/main/chain.png?raw=true)


## Have Suggestions or Interested in Contributing?

- [File an issue](https://github.com/QuEraComputing/Bloqade.jl/issues) to report a bug or request a feature.
- Check out the [Contributing to Bloqade](@ref) guide if you would like to make your own changes and make a [Pull Request](https://github.com/QuEraComputing/Bloqade.jl/pulls) when you would like your work to be reviewed

# Lattices

We can use Bloqade to simulate the quantum evolution of information stored in neutral atoms. Present-day neutral-atom hardware permits the arrangement of atoms in a regular lattice structure and even in nearly arbitrary geometries in 1D, 2D, and 3D.
This makes neutral atom platform a natural playground for quantum simulation of statistical models and quantum matters. With Bloqade, we support several built-in lattice structures and also allow the users to specify atom positions by inputting coordinates.
Please refer to the [Rydberg Blockade](@ref blockade) page for recommendations on how to set the lattice constants for different lattices.

## Types of Lattices

A crystal lattice is completely determined by a set of Bravais lattice vectors (in unit of μm) plus the locations of atoms within a unit cell.
A [Bravais lattice](https://en.wikipedia.org/wiki/Bravais_lattice) is an infinite array of discrete points generated by a set of discrete translation operations described by
```math
\mathbf{R} = n_1 \mathbf{a}_1 + n_2 \mathbf{a}_2 + \ldots + n_d \mathbf{a}_d,
```
where ``d`` is the dimension of space, ``n_1, \ldots, n_d \in Z`` are integers.
The unit cell of a Bravais lattice is defined by specifying its lattice vectors ``(\mathbf{a}_1, \mathbf{a}_2, \ldots, \mathbf{a}_d)``.
To create a simple lattice, we first specify the locations of the atoms within a unit cell and then specify the lattice vectors of the Bravais lattice. For example, for a triangular lattice, we need just one site (atom) at the location `(0.0, 0.0)` in the unit cell and then lattice vectors `(1.0, 0.0)` and `(0.5, 0.5*sqrt(3))`:

```@repl quick-start
using Bloqade
triangular = GeneralLattice([(1.0, 0.0), (0.5, 0.5*sqrt(3))], [(0.0, 0.0)])
```

For composite lattices, one should provide multiple sites as the second argument to specify their locations in a unit cell. For example, the honeycomb lattice can be defined by:
```@repl quick-start
honeycomb = GeneralLattice([(1.0, 0.0), (0.5, 0.5*sqrt(3))],
    [(0.0, 0.0), (0.5, 0.5/sqrt(3))])
```


We provide a few shorthands for several useful lattices, including the [`ChainLattice`](@ref), [`SquareLattice`](@ref), [`HoneycombLattice`](@ref), [`TriangularLattice`](@ref), [`LiebLattice`](@ref), and [`KagomeLattice`](@ref) shown below. 
One can use [`lattice_vectors`](@ref) and [`lattice_sites`](@ref) to access the lattice vectors and site locations in a unit cell as described in the above section.

##### [`ChainLattice`](@ref)
```@example quick-start
using Bloqade
chain = ChainLattice()
```

```@example quick-start
# to make the plot look good in both light and dark backgrounds.
BloqadeLattices.DEFAULT_BACKGROUND_COLOR[] = "#FFFFFF"

# to show the lattice vectors (rescaled a bit to shrink the head).
unitvectors(lattice::AbstractLattice{2}) = [((0.0, 0.0), v) for v in lattice_vectors(lattice)]

Bloqade.plot(generate_sites(chain, 10); vectors=[((0.0, 0.0), (0.9, 0.0))], bond_linewidth=0.015)
```

!!! note
    You can see the above visualization in one of the following editors
    * a [VSCode](https://github.com/julia-vscode/julia-vscode) editor,
    * a [Jupyter](https://github.com/JunoLab/Juno.jl) notebook,
    * or a [Pluto](https://github.com/fonsp/Pluto.jl) notebook,
    
    but not in a Julia REPL which does not have a graphical display.
    

```@example quick-start
lattice_vectors(chain)
```

```@example quick-start
lattice_sites(chain)
```

Once we have defined certain lattice shapes (which have fixed lattice vectors and site positions in the unit cell), we can generate the atom positions by 
specifying the number of atoms and the scale size of the lattice. 
This is done by using the function [`generate_sites`](@ref) , which will return a [`AtomList`](@ref) instance containing the coordinates of each atom, e.g.:  

```@example quick-start
atoms = generate_sites(HoneycombLattice(), 3, 5; scale = 4.5)
```
where `scale` defines the unit distance in the unit μm of the lattice, and `3, 5` specifies the repetitions of unit cells in each lattice vector direction. The default `scale` is 1 μm.

Here are some examples of other lattices:

##### [`SquareLattice`](@ref)
```@example quick-start
square = SquareLattice()
Bloqade.plot(generate_sites(square, 10, 10); vectors=unitvectors(square), bond_linewidth=0.015)
```

Note that the indices showing on the sites are consistent with the indices of the qubits for performing computation. 
In other words, if we want to do measurement or apply operations on individual sites (qubits), we can refer to the numbering on the atoms for convenience. 
For more details on how to generate Hamiltonians by using the lattice as an argument, please see the section [Hamiltonians](@ref).

```@example quick-start
lattice_vectors(square)
```
```@example quick-start
lattice_sites(square)
```

##### [`HoneycombLattice`](@ref)
```@example quick-start
honeycomb = HoneycombLattice()
Bloqade.plot(generate_sites(honeycomb, 5, 5); vectors=unitvectors(honeycomb), bond_linewidth=0.015)
```



##### [`TriangularLattice`](@ref)
```@example quick-start
triangular = TriangularLattice()
Bloqade.plot(generate_sites(triangular, 8, 8); vectors=unitvectors(triangular), bond_linewidth=0.015)
```


##### [`LiebLattice`](@ref)
```@example quick-start
lieb = LiebLattice()
Bloqade.plot(generate_sites(lieb, 5, 5); vectors=unitvectors(lieb), bond_linewidth=0.015)
```


##### [`KagomeLattice`](@ref)
```@example quick-start
kagome = KagomeLattice()
Bloqade.plot(generate_sites(kagome, 5, 5); vectors=unitvectors(kagome), bond_linewidth=0.015)
```


## Sorting Sites and Other Operations on Lattices

We also support different operations on the generated lattices. For instance, one can apply some predefined filters, e.g. [`rescale_axes`](@ref), [`clip_axes`](@ref), [`offset_axes`](@ref), to manipulate atom locations:

```@example quick-start
atoms = generate_sites(HoneycombLattice(), 3, 5; scale = 4.5)
rescale_axes(atoms, 0.8)
```
where the above operation rescales the coordinates of the original `sites` by a factor of `0.8`. 

The code below restricts the atoms sitting in the window `(0.0, 5.0), (0.0, 6.0)` and throw away those outside this area: 

```@example quick-start
clip_axes(atoms, (0.0, 5.0), (0.0, 6.0))
```

Furthermore, we can shift the origin of the `atoms` by some vector `(5.0, 5.0)` simply by typing the code:

```@example quick-start
offset_axes(atoms, 5.0, 5.0)
```


To sort the atoms by their x-coordinates, one can convert these locations to a [`MaskedGrid`](@ref) representation of the atoms:
```@example quick-start
atoms_in_grid = make_grid(atoms)
```

Then one can get the sorted atoms by typing:
```@example quick-start
sorted_atoms = collect_atoms(atoms_in_grid)
```

Note that the sorting will change the index numbering of the atoms. 

You can also delete atoms given their index number:
```@example quick-start
deleteat!(atoms, 8, 9, 13, 14, 18, 20, 23)
atoms
```

Note that this permanently changes the contents of `atoms` and just like sorting atoms, will change the index numbering albeit to preserve the integer sequence without gaps.



## User-Defined Arbitrary Geometries

One can also generate atoms located at arbitrary positions by directly inputting the coordinates of the atoms:
```@repl quick-start
atom_coordinate = AtomList([(0.0, 0.0), (0, 5), (0, 8), (5, 2), (6, 7), (9, 6)])
```

## Query Neighbors

One can use [`make_kdtree`](@ref) to generate a [k-d tree](https://en.wikipedia.org/wiki/K-d_tree) data type for the efficient querying of neighborhoods in a low-dimensional space.
```@example quick-start
tree = make_kdtree(sorted_atoms)
```

The return value is a `KDTree` instance, which is defined in the package [`NearestNeigbors`](https://github.com/KristofferC/NearestNeighbors.jl). One can use it to query the neighbors of an atom: e.g. one can find the 20 nearest neighbors of the 5-th site by typing:
```@example quick-start
neighbors = grouped_nearest(tree, 5, 20)
```

The return value is a [`DistanceGroup`](@ref) instance, and the indices of the second nearest neighbors are:
```@example quick-start
neighbors[2]
```

One can select and display these atoms with the correct labeling by typing:
```@example quick-start
Bloqade.plot(sorted_atoms[neighbors[2]]; texts=string.(neighbors[2]))
```

It shows the correct second nearest neighbors of the site 5.
One can check the docstring of [`Bloqade.plot`](@ref) to know more about how to customize lattice visualization.

## References

```@docs
AbstractLattice
GeneralLattice
SquareLattice
RectangularLattice
HoneycombLattice
TriangularLattice
ChainLattice
LiebLattice
KagomeLattice

lattice_vectors
lattice_sites
BloqadeLattices.dimension
generate_sites
offset_axes
random_dropout
rescale_axes
clip_axes

MaskedGrid
AtomList
make_grid
collect_atoms

img_atoms
img_maskedgrid
ByDensity

AbstractRegion
Parallelepiped
Parallelepiped(vecs)
Parallelepiped(vecs::T) where {T<:Real}

distance
generate_sites_in_region

BoundedLattice
parallelepiped_region

two_body_interaction_matrix
rydberg_interaction_matrix

```

# [Hardware Capabilities](@id capabilities)

Although tools such as those that Bloqade offers in its [Schema](@ref schema) can automatically transform user-created Hamiltonians to conform to [QuEra's Quantum Processor *Aquila*](https://www.quera.com/aquila) requirements with minimal user intervention, the following information may still be helpful in designing Hamiltonians to run on hardware.

## Programmatic Access

You can obtain the values from the human-readable form below programmatically through the [`BloqadeSchema.get_device_capabilities`](@ref) function which returns `BloqadeSchema.DeviceCapabilities`, a named tuple.

```@repl
using BloqadeSchema
device_capabilities = get_device_capabilities();
BloqadeSchema.pprint(device_capabilities)
device_capabilities.rydberg.global_value.detuning_max # get the maximum global detuning value
```

The field names for each value have been provided below but will require you to provide the proper prefix like in the example above (e.g. the Minimum Rabi Frequency is under `rabi_frequency_min` which exists under `global_value` under `rydberg` in the `DeviceCapabilities` tuple, and should be access via *`your_device_capabilities_instance`*`.rydberg.global_value.rabi_frequency_min`)

## *Aquila* Capabilities

### Task

| Capability              | Field              | Value |
|:------------------------|:-------------------|:------|
| Minimum Number of Shots | `number_shots_min` | 1     |
| Maximum Number of Shots | `number_shots_max` | 1000  |

### Lattice Geometry

| Capability                              | Field                  | Value   |
|:----------------------------------------|:-----------------------|:--------|
| Maximum Number of Qubits                | `number_qubits_max`    | 256     |
| Maximum Lattice Area Width              | `width`                | 75.0 µm |
| Maximum Lattice Area Height             | `height`               | 76.0 µm |
| Minimum Radial Spacing between Qubits   | `spacing_radial_min`   | 4.0 µm  |
| Minimum Vertical Spacing between Qubits | `spacing_vertical_min` | 4.0 µm  |
| Position Resolution                     | `position_resolution`  | 0.1 µm  |
| Maximum Number of Sites                 | `number_sites_max`     | 256     |

### Global Rydberg Values

| Capability                       | Field                          | Value                 |
|:---------------------------------|:-------------------------------|:----------------------|
| Rydberg Interaction Constant     | `c6_coefficient`               | 5.42×10⁶ rad/μs × µm⁶ |
| Minimum Rabi Frequency           | `rabi_frequency_min`           | 0.00 rad/μs           |
| Maximum Rabi Frequency           | `rabi_frequency_max`           | 15.8 rad/μs           |
| Rabi Frequency Resolution        | `rabi_frequency_resolution`    | 0.0004 rad/μs         |
| Maximum Rabi Frequency Slew Rate | `rabi_frequency_slew_rate_max` | 250.0 rad/µs²         |
| Minimum Detuning                 | `detuning_min`                 | -125.0 rad/μs         |
| Maximum Detuning                 | `detuning_max`                 | 125.0 rad/μs          |
| Detuning Resolution              | `detuning_resolution`          | 2.0×10⁻⁷ rad/μs       |
| Maximum Detuning Slew Rate       | `detuning_slew_rate_max`       | 2500.0 rad/µs²        |
| Minimum Phase                    | `phase_min`                    | -99.0 rad             |
| Maximum Phase                    | `phase_max`                    | 99.0 rad              |
| Phase Resolution                 | `phase_resolution`             | 5.0×10⁻⁷ rad          |
| Minimum Time                     | `time_min`                     | 0.0 µs                |
| Maximum Time                     | `time_max`                     | 4.0 µs                |
| Time Resolution                  | `time_resolution`              | 0.001 µs              |
| Minimum Δt                       | `time_delta_min`               | 0.05 µs               |

```@meta
CurrentModule = Bloqade
```

# Hamiltonians

Quantum Hamiltonians encode the essential physical properties of a quantum system. For the analog mode of neutral-atom quantum computers, the quantum dynamics is governed by the Rydberg Hamiltonian ``\hat{\mathcal{H}}``:

```math
i \hbar \dfrac{\partial}{\partial t} | \psi \rangle = \hat{\mathcal{H}}(t) | \psi \rangle,  \\

\frac{\mathcal{H}(t)}{\hbar} = \sum_j \frac{\Omega_j(t)}{2} \left( e^{i \phi_j(t) } | g_j \rangle  \langle r_j | + e^{-i \phi_j(t) } | r_j \rangle  \langle g_j | \right) - \sum_j \Delta_j(t) \hat{n}_j + \sum_{j < k} V_{jk} \hat{n}_j \hat{n}_k,
```

where ``\Omega_j``, ``\phi_j``, and ``\Delta_j``  denote the Rabi frequency, laser phase, and the detuning of the driving laser field on atom (qubit) ``j`` coupling the two states  ``| g_j \rangle `` (ground state) and `` | r_j \rangle `` (Rydberg state); ``\hat{n}_j = |r_j\rangle \langle r_j|`` is the number operator, and ``V_{jk} = C_6/|\mathbf{x}_j - \mathbf{x}_k|^6`` describes the Rydberg interaction (van der Waals interaction) between atoms ``j`` and ``k`` where ``\mathbf{x}_j`` denotes the position of the atom ``j``; ``C_6`` is the Rydberg interaction constant that depends on the particular Rydberg state used. For Bloqade, the default ``C_6 = 862690 \times 2\pi \text{ MHz μm}^6`` for ``|r \rangle = \lvert 70S_{1/2} \rangle`` of the ``^{87}``Rb atoms; ``\hbar`` is the reduced Planck's constant.

One can use the Rydberg Hamiltonian to 
understand the ground state properties of the corresponding system and to generate interesting quantum dynamics. 
The Rydberg Hamiltonian is generally specified by atom positions ``\mathbf{x}_j``, Rabi frequencies ``\Omega_j``, laser phase ``\phi_j``, and detunings ``\Delta_j``. In Bloqade, 
we can easily create a Hamiltonian by inputting these variable parameters into the function [`rydberg_h`](@ref). Furthermore, by inputting waveforms for the Rabi frequency and 
detuning, we can easily generate time-dependent Hamiltonians. 

## Building Time-Independent Hamiltonians

To specify the Hamiltonian, we first need to specify the atom positions, which determine the Rydberg interactions strengths ``V_{jk}`` between pairs of atoms. Here, we generate a square lattice by using the code below:

```@repl hamiltonian
using Bloqade
atoms = generate_sites(SquareLattice(), 3, 3, scale=6.3)
```

Please refer to the [Lattices](@ref) page for more details on how to generate lattices and the relevant operations. 

Then, the Hamiltonian can be simply built by inputting the generated atom positions `atoms` and by specifying the strength of the detuning `Δ`, Rabi frequency `Ω`, and laser phase `ϕ`:

```@repl hamiltonian
h0 = rydberg_h(atoms; Δ=1.2*2π, Ω=1.1*2π, ϕ=2.1)
```

Note that the default value for the Rydberg interaction constant is ``C_6 = 2\pi \times 862690 \text{ MHz μm}^6`` to match the default unit used on the hardware. For more information about units, please 
refer to [Bloqade](@ref). Instead of using the default value for ``C_6``, the users are free to set their own values. For instance, if the users would like to have a chain lattice with nearest-neighbor atoms separated by 1 μm, and interaction strength to be a particular value, say, ``2\pi * 10.0^6 \text{ MHz μm}^6``, it can be done with the following code:

```@repl hamiltonian
atoms = generate_sites(ChainLattice(), 9, scale=1.0)
h0 = rydberg_h(atoms; C=2π*10.0^6, Δ=1.2*2π, Ω=1.1*2π, ϕ=2.1)
```


## Building Time-Dependent Hamiltonians

One can also directly use waveforms (instead of constant values of detuning, Rabi frequency, and laser phase) to build a time-dependent Hamiltonian. 
First, let us again use the  [`generate_sites`](@ref) to create a list of atom coordinates: 

```@repl hamiltonian
atoms = generate_sites(ChainLattice(), 5, scale=5.72)
```

Then, we generate the time-dependent pulses for ``\Omega`` and ``\Delta`` by using 
[`piecewise_linear`](@ref). For details on how to create waveforms and the built-in functions, please refer to the page [Waveforms](@ref). 

```@repl hamiltonian
Ω1 = piecewise_linear(clocks=[0.0, 0.1, 2.1, 2.2], values=2π*[0.0, 6.0, 6.0, 0]);
Δ1 = piecewise_linear(clocks=[0.0, 0.6, 2.1, 2.2], values=2π*[-10.1, -10.1, 10.1, 10.1]);
```

The time-dependent Hamiltonian can then be easily generated by inputting the waveforms into the function [`rydberg_h`](@ref):

```@repl hamiltonian
h1 = rydberg_h(atoms; Δ=Δ1, Ω=Ω1)
```

By specifying the time of `h1`, we can access the Hamiltonian at a particular time, e.g.: 

```@repl hamiltonian
ht= h1 |> attime(0.5)
```

## Building Hamiltonians with Site-Dependent Waveforms

In certain cases, the user may want to build a Hamiltonian that has site-dependent ``\Omega_j``, ``\phi_j``, and ``\Delta_j``, which may or may not have time dependence.

For the time-independent Hamiltonian, one can for example build a Hamiltonian like: 

```@repl hamiltonian
h0 = rydberg_h(atoms; Δ=1.2*2π*rand(length(atoms)), Ω=1.1*2π*rand(length(atoms)), ϕ=2.1)
```

For time-dependent Hamiltonians, here is an example:

```@repl hamiltonian
atoms = generate_sites(ChainLattice(), 5, scale=5.72)
Δ1 = map(1:length(atoms)) do idx
    Waveform(t-> idx*sin(2π*t), duration = 2)
end
h =rydberg_h(atoms; Δ=Δ1)
```


## Hamiltonian Expressions

Bloqade uses "block"s from [Yao](https://yaoquantum.org/) to build symbolic hamiltonian
expressions. This gives users the flexibility to define various  
kinds of Hamiltonians by simply writing down the expression.

Please refer to the References section below for the types of operators supported by Bloqade.

As an example, we can explicitly add up some Hamiltonian terms to compose a new Hamiltonian, e.g.:

```@repl hamiltonian
using Bloqade
h = 2π*1.1*SumOfX(5, 1.0) + 2π*1.2*SumOfZ(5, 1.0)
```

## Convert Hamiltonians to Matrices

An Hamiltonian expression can be converted to a matrix via the [`mat`](https://docs.yaoquantum.org/dev/man/blocks.html#YaoAPI.mat-Tuple{AbstractBlock})
interface from Yao:

```@docs
mat
```

This method will return the most compact matrix representation of the operator,
e.g.:

```@repl hamiltonian
mat(X) # will return a PermMatrix
mat(ht) # will return a SparseMatrixCSC
```

The Hamiltonian matrix can also be created in a subspace, such as the
blockade subspace (see also [Working with Subspace](@ref subspace)). This will allow one to simulate larger system sizes because of the smaller truncated Hilbert space.

For the Rydberg Hamiltonian, we can create a subspace via the [`blockade_subspace`](@ref)
method, e.g.:

```@repl hamiltonian
space = blockade_subspace(atoms, 7.5)
```

The above code means that the blockade subspace only includes states where there is only one Rydberg excitation 
within the distance of 7.5 μm, which we call the subspace radius ``R_s``. If we have a chain of atoms separated by 5.72 μm, the blockade subspace 
does not contain states with nearest-neighbor atoms being simultaneously excited to the Rydberg state `` | r \rangle ``.

Once we have defined the space, we can convert the Hamiltonian to a matrix in a subspace basis via the codes below:

```@repl hamiltonian
h_m = mat(ht, space)
```

We can see that the size of the Hamiltonian matrix in the blockade subspace is much smaller than that in the full Hilbert space.

## Diagonalization of the Hamiltonian

Bloqade doesn't provide any built-in diagonalization tool, as there are many existing 
tools in the Julia ecosystem. Here, we demonstrate how to use the [KrylovKit](https://github.com/Jutho/KrylovKit.jl) package for this purpose as follows:

```@repl hamiltonian
using KrylovKit
vals, vecs, info = KrylovKit.eigsolve(h_m,  1, :SR)
```

where the `vals` and `vecs` store the calculated eigenvalues and eigenvectors respectively. 

## Low-Level Representation of the Hamiltonian

Besides the symbolic representation, in order to achieve the best possible performance, we use a lower-level representation of the Hamiltonian in Bloqade,
which is the `Hamiltonian` and `StepHamiltonian` type:

```@docs
BloqadeExpr.Hamiltonian
BloqadeExpr.StepHamiltonian
```

The `Hamiltonian` type represents the following Hamiltonian expression

```math
f_1(t) H_1 + f_2(t) H_2 + \cdots + f_n(t) H_n + H_c,
```

where ``f_i(t)`` are time-dependent parameters of the Hamiltonian,
``H_i`` are time-independent local terms of the Hamiltonian as linear operators
(in Julia, this means objects that support `LinearAlgebra.mul!` interface), and
``H_c`` is the constant component of the Hamiltonian.

A `Hamiltonian` object supports callable methods, which will produce a
`StepHamiltonian` that is time-independent, e.g.:

```@repl hamiltonian
using BloqadeExpr
h = BloqadeExpr.Hamiltonian(Float64, SumOfX(5, sin) + SumOfZ(5, cos))
h(0.1)
```

Here, we see that the Hamiltonian expression written as Yao blocks are automatically analyzed into time-dependent terms and constant terms. A more complicated example can be [`SumOfXPhase`](@ref):

```@repl hamiltonian
using BloqadeExpr
h = BloqadeExpr.Hamiltonian(Float64, SumOfXPhase(5, sin, cos) + SumOfZ(5, cos))
h(0.1)
```

## References

```@docs
rydberg_h
```

Except the standard operators from Yao, the following operators are also supported
by Bloqade:

```@docs
RydInteract
SumOfX
SumOfXPhase
SumOfZ
SumOfN
XPhase
```
